import request from '@/utils/request'

// 查询应急事件列表
export function listEmergencyevents(query) {
  return request({
    url: '/sooka-sponest-center-event/emergencyevents/list',
    method: 'get',
    params: query
  })
}

// 查询应急事件详细
export function getEmergencyevents(id) {
  return request({
    url: '/sooka-sponest-center-event/emergencyevents/' + id,
    method: 'get'
  })
}

// 新增应急事件
export function addEmergencyevents(data) {
  return request({
    url: '/sooka-sponest-center-event/emergencyevents',
    method: 'post',
    data: data
  })
}

// 修改应急事件
export function updateEmergencyevents(data) {
  return request({
    url: '/sooka-sponest-center-event/emergencyevents',
    method: 'put',
    data: data
  })
}

// 删除应急事件
export function delEmergencyevents(id) {
  return request({
    url: '/sooka-sponest-center-event/emergencyevents/' + id,
    method: 'delete'
  })
}
