import request from '@/utils/request';

// 查询事件类型列表
export function listEventtype(query) {
  return request({
    url: '/center-event/eventtype/list',
    method: 'get',
    params: query
  })
}

// 查询事件类型详细
export function getEventtype(id) {
  return request({
    url: '/center-event/eventtype/' + id,
    method: 'get'
  })
}

// 新增事件类型
export function addEventtype(data) {
  return request({
    url: '/center-event/eventtype',
    method: 'post',
    data: data
  })
}

// 修改事件类型
export function updateEventtype(data) {
  return request({
    url: '/center-event/eventtype',
    method: 'put',
    data: data
  })
}

// 删除事件类型
export function delEventtype(id) {
  return request({
    url: '/center-event/eventtype/' + id,
    method: 'delete'
  })
}

// 查询部门
export function deptTreeSelect() {
  return request({
    url: '/system/dept/treeselectAll',
    method: 'get'
  })
}

export function addEventtyepdept(data) {
  return request({
    url: '/center-event/eventtypemapdept/add',
    method: 'post',
    data: JSON.stringify(data)
  })
}
