import request from '@/utils/request'

// 查询事件模版类型列表
export function listMonitor(query) {
  return request({
    url: '/center-event/eventtypemonitor/list',
    method: 'get',
    params: query
  })
}

// 查询事件模版类型详细
export function getMonitor(id) {
  return request({
    url: '/center-event/eventtypemonitor/' + id,
    method: 'get'
  })
}

// 新增事件模版类型
export function addMonitor(data) {
  return request({
    url: '/center-event/eventtypemonitor',
    method: 'post',
    data: data
  })
}

// 修改事件模版类型
export function updateMonitor(data) {
  return request({
    url: '/center-event/eventtypemonitor',
    method: 'put',
    data: data
  })
}

// 删除事件模版类型
export function delMonitor(id) {
  return request({
    url: '/center-event/eventtypemonitor/' + id,
    method: 'delete'
  })
}

// 查询部门
export function deptTreeSelect() {
  return request({
    url: '/center-event/eventtype/getCentereventTEventtypeTreeLx',
    method: 'get'
  })
}

export function addEventtyepLx(data) {
  return request({
    url: '/center-event/eventtypemonitor/saveTypelx',
    method: 'post',
    data: JSON.stringify(data)
  })
}

// 查询事件模版类型列表
export function listByParentId(query) {
  return request({
    url: '/center-event/eventtypemonitor/listByParentId',
    method: 'get',
    params: query
  })
}
