import request from '@/utils/request'
var base="center-event";
var baseData="center-data";
// 查询事件（森林防火）列表
export function listForest(query) {
  return request({
    url: base+'/event/forest/forestfire/list',
    method: 'get',
    params: query
  })
}

//修改森林防火事件状态
export function updateCentereventTForestfireStatus(id,zt) {
  return request({
    url: base+'/event/forest/forestfire/updateCentereventTForestfireStatus/'+ id+'/'+zt,
    method: 'get'
  })
}

// 查询事件（森林防火）详细
export function getForest(id) {
  return request({
    url: base+'/event/forest/forestfire/' + id,
    method: 'get'
  })
}

// 新增事件（森林防火）
export function addForest(data) {
  return request({
    url: base+'/event/forest/forestfire',
    method: 'post',
    data: data
  })
}

// 修改事件（森林防火）
export function updateForest(data) {
  return request({
    url: base+'/event/forest/forestfire',
    method: 'put',
    data: data
  })
}

// 删除事件（森林防火）
export function delForest(id) {
  return request({
    url: base+'/event/forest/forestfire/' + id,
    method: 'delete'
  })
}

// 森林防火图片
export function listCenterdataTAttachByBusId(busId) {
  return request({
    url: baseData+'/attach/listCenterdataTAttachByBusId/' + busId,
    method: 'get'
  })
}
// 火点附近摄像头5公里显示 10个


// 森林防火图片
export function selectFjsxt(longitude,latitude) {
  return request({
    url: 'center-monitor/camera/selectFjsxt/'+longitude+'/' + latitude,
    method: 'get'
  })
}

// 新增火险报告（森林火灾损失）
export function addForestFireLoss(data) {
  return request({
    url: base+'/event/forest/forestfire/addForestFireLoss',
    method: 'post',
    data: data
  })
}

// 新增火险报告（火场资料）
export function addFireInformation(data) {
  return request({
    url: base+'/event/forest/forestfire/addFireInformation',
    method: 'post',
    data: data
  })
}

// 查询火险报告（森林火灾损失）详细
export function getForestFireLoss(eventId) {
  return request({
    url: base+'/event/forest/forestfire/getForestFireLoss/' + eventId,
    method: 'get'
  })
}

// 查询火险报告（火场资料）详细
export function getFireInformation(eventId) {
  return request({
    url: base+'/event/forest/forestfire/getFireInformation/' + eventId,
    method: 'get'
  })
}

// 修改火险报告（森林火灾损失）
export function updateForestFireLoss(data) {
  return request({
    url: base+'/event/forest/forestfire/updateForestFireLoss',
    method: 'put',
    data: data
  })
}

// 修改火险报告（火场资料）
export function updateFireInformation(data) {
  return request({
    url: base+'/event/forest/forestfire/updateFireInformation',
    method: 'put',
    data: data
  })
}

// 新增区域标记
export function addRegionalFlag(data) {
  return request({
    url: base+'/event/forest/forestfire/addRegionalFlag',
    method: 'post',
    data: data
  })
}

// 查询区域标记
export function getRegionalFlag(eventId) {
  return request({
    url: base+'/event/forest/forestfire/getRegionalFlag/' + eventId,
    method: 'get'
  })
}

// 删除区域标记
export function delRegionalFlag(eventId) {
  return request({
    url: base+'/event/forest/forestfire/delRegionalFlag/' + eventId,
    method: 'delete'
  })
}
