import request from '@/utils/request'
var base="center-event";

// 查询事件操作日志列表
export function listLog(query) {
  return request({
    url: base+'/event/system/log/list',
    method: 'get',
    params: query
  })
}

// 查询事件操作日志详细
export function getLog(id) {
  return request({
    url: base+'/event/system/log/' + id,
    method: 'get'
  })
}

// 新增事件操作日志
export function addLog(data) {
  return request({
    url: base+'/event/system/log',
    method: 'post',
    data: data
  })
}

// 修改事件操作日志
export function updateLog(data) {
  return request({
    url: base+'/event/system/log',
    method: 'put',
    data: data
  })
}

// 删除事件操作日志
export function delLog(id) {
  return request({
    url: base+'/event/system/log/' + id,
    method: 'delete'
  })
}
// 删除事件操作日志
export function listByEventCode(eventCode) {
  return request({
    url: base+'/event/system/log/listByEventCode/' + eventCode,
    method: 'get'
  })
}
// 删除事件操作日志
export function selectCentereventTLogListPC(eventCode) {
  return request({
    url: base+'/event/system/log/selectCentereventTLogListPC/' + eventCode,
    method: 'get'
  })
}

