import request from '@/utils/request'

// 查询事件预警列表
export function listWarm(query) {
  return request({
    url: '/sooka-sponest-center-event/warm/list',
    method: 'get',
    params: query
  })
}

// 查询事件预警详细
export function getWarm(id) {
  return request({
    url: '/sooka-sponest-center-event/warm/' + id,
    method: 'get'
  })
}

// 新增事件预警
export function addWarm(data) {
  return request({
    url: '/sooka-sponest-center-event/warm',
    method: 'post',
    data: data
  })
}

// 修改事件预警
export function updateWarm(data) {
  return request({
    url: '/sooka-sponest-center-event/warm',
    method: 'put',
    data: data
  })
}

// 删除事件预警
export function delWarm(id) {
  return request({
    url: '/sooka-sponest-center-event/warm/' + id,
    method: 'delete'
  })
}
//修改部门事件状态
export function updateDeptEventStatus(param) {
  return request({
    url: '/sooka-sponest-center-event/warm/updateDeptEventStatus' ,
    method: 'post',
    data: param
  })
}



// 查询事件预警详细
export function selectchannelCodeByCameraId(cameraId) {
  return request({
    url: '/center-monitor/camerachannel/selectchannelCodeByCameraId/' + cameraId,
    method: 'get'
  })
}


// 查询摄像头绑定事件
export function selectCameraEventByCameraId(cameraId) {
  return request({
    url: '/center-monitor/cameraevent/selectCameraEventByCameraId/' + cameraId,
    method: 'get'
  })
}
