import request from '@/utils/request'
var base="center-event";

/**
 * 道路晾晒（新增列表）
 * @param query
 */
export function list(query) {
  return request({
    url: base+'/flow/list',
    method: 'get',
    params: query
  })
}
/**
 * 道路晾晒（代办列表）
 * @param query
 */
export function toDoList(query) {
  return request({
    url: base+'/flow/toDoList',
    method: 'get',
    params: query
  })
}
/**
 * 道路晾晒（归档列表）
 * @param query
 */
export function unFileList(query) {
  return request({
    url: base+'/flow/unFileList',
    method: 'get',
    params: query
  })
}
/**
 * 道路晾晒（台账）
 * @param query
 */
export function accountList(query) {
  return request({
    url: base+'/flow/accountList',
    method: 'GET',
    params: query
  })
}
/**
 * 道路晾晒（新增）
 * @param query
 */
export function add(query) {
  return request({
    url: base+'/flow',
    method: 'POST',
    data: query
  })
}
/**
 * 道路晾晒（修改）
 * @param query
 */
export function update(query) {
  return request({
    url: base+'/flow',
    method: 'PUT',
    data: query
  })
}
/**
 * 道路晾晒（删除）
 * @param query
 */
export function del(ids) {
  return request({
    url: base+'/flow/'+ids,
    method: 'DELETE',
  })
}
/**
 * 道路晾晒（详情）
 * @param query
 */
export function get(id) {
  return request({
    url: base+'/flow/'+id,
    method: 'GET',
  })
}
/**
 * 道路晾晒（上报）
 * @param query
 */
export function report(id) {
  return request({
    url: base+'/flow/report/'+id,
    method: 'POST',
  })
}
/**
 * 道路晾晒（签收）
 * @param query
 */
export function sign(id) {
  return request({
    url: base+'/flow/sign/'+id,
    method: 'POST',
  })
}
/**
 * 道路晾晒（办结）
 * @param query
 */
export function settle(query) {
  return request({
    url: base+'/flow/settle',
    method: 'POST',
    params: query
  })
}
/**
 * 道路晾晒（归档）
 * @param query
 */
export function file(id) {
  return request({
    url: base+'/flow/file/'+id,
    method: 'POST',
  })
}
