package com.sooka.sponest.event.centereventtdeptevent.domain;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.ruoyi.common.core.annotation.Excel;
import com.ruoyi.common.datascope.base.domain.BaseBusinessEntity;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.util.Date;

/**
 * 事件部门对象 centerevent_t_dept_event
 *
 * @author 朱哲
 * @date 2022-08-29
 */
public class CentereventDeptEvent extends BaseBusinessEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 主键id
     */
    @NotBlank
    private String id;

    /**
     * 事件编码
     */
    @Excel(name = "事件编码")
    @NotBlank
    private String eventCode;

    /**
     * 部门id
     */
    @Excel(name = "部门id")
    @NotNull
    private Long deptId;

    /**
     * 部门名称
     */
    @Excel(name = "部门名称")
    @NotBlank
    private String deptName;

    /**
     * 是否催办(字典)
     */
    @Excel(name = "是否催办(字典)")
    @NotBlank
    private String isUrged;

    /**
     * 催办类型
     */
    @Excel(name = "催办类型")
    private String urgeType;

    /**
     * 事件状态
     */
    @Excel(name = "事件状态")
    @NotBlank
    private String eventStatus;

    /**
     * 事件状态value
     */
    @Excel(name = "事件状态value")
    @NotBlank
    private String eventStatusValue;

    /**
     * 第一次催办时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "第一次催办时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date urgeFirstTime;

    /**
     * 最后一次催办时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "最后一次催办时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date urgeLastTime;

    /**
     * 部门类型
     */
    @Excel(name = "部门类型")
    @NotBlank
    private String deptHandleType;

    public void setId(String id) {
        this.id = id;
    }

    public String getId() {
        return id;
    }

    public void setEventCode(String eventCode) {
        this.eventCode = eventCode;
    }

    public String getEventCode() {
        return eventCode;
    }

    public void setDeptId(Long deptId) {
        this.deptId = deptId;
    }

    public Long getDeptId() {
        return deptId;
    }

    public void setDeptName(String deptName) {
        this.deptName = deptName;
    }

    public String getDeptName() {
        return deptName;
    }

    public void setIsUrged(String isUrged) {
        this.isUrged = isUrged;
    }

    public String getIsUrged() {
        return isUrged;
    }

    public void setUrgeType(String urgeType) {
        this.urgeType = urgeType;
    }

    public String getUrgeType() {
        return urgeType;
    }

    public String getEventStatus() {
        return eventStatus;
    }

    public void setEventStatus(String eventStatus) {
        this.eventStatus = eventStatus;
    }

    public String getEventStatusValue() {
        return eventStatusValue;
    }

    public void setEventStatusValue(String eventStatusValue) {
        this.eventStatusValue = eventStatusValue;
    }

    public void setUrgeFirstTime(Date urgeFirstTime) {
        this.urgeFirstTime = urgeFirstTime;
    }

    public Date getUrgeFirstTime() {
        return urgeFirstTime;
    }

    public void setUrgeLastTime(Date urgeLastTime) {
        this.urgeLastTime = urgeLastTime;
    }

    public Date getUrgeLastTime() {
        return urgeLastTime;
    }

    public void setDeptHandleType(String deptHandleType) {
        this.deptHandleType = deptHandleType;
    }

    public String getDeptHandleType() {
        return deptHandleType;
    }
}
