package com.sooka.sponest.event.centereventtdeptevent.mapper;

import com.sooka.sponest.event.centereventtdeptevent.domain.CentereventDeptEvent;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 事件部门Mapper接口
 *
 * @author 朱哲
 * @date 2022-08-29
 */
public interface CentereventDeptEventMapper {

    /**
     * 查询事件部门列表
     *
     * @param centereventTDeptEvent 事件部门
     * @return 事件部门集合
     */
    List<CentereventDeptEvent> selectCentereventTDeptEventList(CentereventDeptEvent centereventTDeptEvent);

    /**
     * 查询事件部门
     *
     * @param id 事件部门主键
     * @return 事件部门
     */
    CentereventDeptEvent selectCentereventTDeptEventById(String id);

    /**
     * 新增事件部门
     *
     * @param centereventTDeptEvent 事件部门
     * @return 结果
     */
    int insertCentereventTDeptEvent(CentereventDeptEvent centereventTDeptEvent);

    /**
     * 修改事件部门
     *
     * @param centereventTDeptEvent 事件部门
     * @return 结果
     */
    int updateCentereventTDeptEvent(CentereventDeptEvent centereventTDeptEvent);

    /**
     * 批量删除事件部门
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    int deleteCentereventTDeptEventByIds(String[] ids);


    List<CentereventDeptEvent> selectByEventCode(String eventCode);

    int updateCentereventTDeptEventOtherDeptIdWyc(@Param("eventCode") String eventCode, @Param("deptId") String deptId);

    int selectCentereventTDeptEventByEventCode(@Param("eventCode") String eventCode, @Param("deptId") String deptId);

    int updateCentereventTDeptEventCf(String eventCode);

    int updateCentereventTDeptEventByCodeDeptId(CentereventDeptEvent centereventTDeptEvent);
}
