package com.sooka.sponest.event.centereventtdutysystem.mapper;

import com.sooka.sponest.event.centereventtdutysystem.domain.CentereventTDutySystem;

import java.util.List;

/**
 * 责任制Mapper接口
 *
 * @author lyq
 * @date 2022-11-26
 */
public interface CentereventTDutySystemMapper {

    /**
     * 查询责任制列表
     *
     * @param centereventTDutySystem 责任制
     * @return 责任制集合
     */
    List<CentereventTDutySystem> selectCentereventTDutySystemList(CentereventTDutySystem centereventTDutySystem);

    /**
     * 查询责任制
     *
     * @param id 责任制主键
     * @return 责任制
     */
    CentereventTDutySystem selectCentereventTDutySystemById(String id);

    /**
     * 新增责任制
     *
     * @param centereventTDutySystem 责任制
     * @return 结果
     */
    int insertCentereventTDutySystem(CentereventTDutySystem centereventTDutySystem);

    /**
     * 修改责任制
     *
     * @param centereventTDutySystem 责任制
     * @return 结果
     */
    int updateCentereventTDutySystem(CentereventTDutySystem centereventTDutySystem);

    /**
     * 批量删除责任制
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    int deleteCentereventTDutySystemByIds(String[] ids);
}
