package com.sooka.sponest.event.centereventteventcatalogue.controller;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.ruoyi.common.core.domain.R;
import com.ruoyi.common.core.utils.StringUtils;
import com.ruoyi.common.core.web.domain.AjaxResult;
import com.ruoyi.common.core.web.controller.BaseController;
import com.sooka.sponest.event.centereventteventcatalogue.domain.dahua.DaHuaFireEventVO;
import com.sooka.sponest.event.centereventteventcatalogue.domain.dahua.DaHuaOtherEventVO;
import com.sooka.sponest.event.centereventteventcatalogue.domain.haikang.HaiKangEventSmokeVo;
import com.sooka.sponest.event.centereventteventcatalogue.domain.haikang.HaiKangEventVo;
import com.sooka.sponest.event.centereventteventcatalogue.domain.tower.TowerEventVo;
import com.sooka.sponest.event.centereventteventcatalogue.domain.vo.DroneVO;
import com.sooka.sponest.event.centereventteventcatalogue.service.AlarmEventService;
import com.sooka.sponest.event.centereventtreportmessage.domain.CentereventTReportmessage;
import com.sooka.sponest.event.centereventtreportmessage.service.ICentereventTReportmessageService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.collections4.MapUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.sooka.sponest.event.utils.URLToJSONConverter;

import java.util.List;
import java.util.stream.Collectors;

@Api(tags = "海康")
@RestController
@RequestMapping("AlarmEventController")
public class AlarmEventController extends BaseController {

    protected final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private AlarmEventService alarmEventService;

    @Autowired
    private ICentereventTReportmessageService centereventTReportmessageService;

    @ApiOperation("火险事件上报")
    @PostMapping("/haikang@insertFireEvent")
    public R insertFireEvent(@RequestBody JSONArray jsonArray) {
        String eventCode = null;
        JSONObject jsonObject = JSONObject.parseObject(JSON.toJSONString(jsonArray.get(0)));
        try {
            HaiKangEventVo haiKangEventVo = JSONObject.toJavaObject(jsonObject.getJSONObject("sys_exclusive_original_data_message").getJSONObject("params"), HaiKangEventVo.class);
            eventCode = alarmEventService.insertHaiKangFireEvent(haiKangEventVo);
        } catch (Exception e) {
            logger.error(e.getMessage());
        }
        if (StringUtils.isBlank(eventCode)) {
            eventCode = String.valueOf(System.currentTimeMillis());
        }
        try {
            CentereventTReportmessage tReportMessage = new CentereventTReportmessage();
            tReportMessage.setId(eventCode);
            tReportMessage.setSource("海康摄像头-火情");
            tReportMessage.setContext(jsonArray.toJSONString());
            centereventTReportmessageService.insertCentereventTReportmessage(tReportMessage);
        } catch (Exception e) {
            logger.error(e.getMessage());
        }
        return R.ok();
    }

    @ApiOperation("城管事件上报")
    @PostMapping("/haikang@insertCityEvent")
    public R insertCityEvent(@RequestBody JSONArray jsonArray) {
        String eventCode = null;
        JSONObject jsonObject = JSONObject.parseObject(JSON.toJSONString(jsonArray.get(0)));
        try {
            HaiKangEventVo haiKangEventVo = JSONObject.toJavaObject(jsonObject.getJSONObject("params"), HaiKangEventVo.class);
            eventCode = alarmEventService.insertHaiKangCityEvent(haiKangEventVo);
        } catch (Exception e) {
            logger.error(e.getMessage());
        }
        if (StringUtils.isBlank(eventCode)) {
            eventCode = String.valueOf(System.currentTimeMillis());
        }
        try {
            CentereventTReportmessage tReportMessage = new CentereventTReportmessage();
            tReportMessage.setId(eventCode);
            tReportMessage.setSource("海康摄像头-城管");
            tReportMessage.setContext(jsonArray.toJSONString());
            centereventTReportmessageService.insertCentereventTReportmessage(tReportMessage);
        } catch (Exception e) {
            logger.error(e.getMessage());
        }
        return R.ok();
    }

    @PostMapping("/dahua@alarmEvent")
    public R alarmEvent(@RequestBody String jsonStr) {
        String eventCode = null;
        DaHuaFireEventVO daHuaFireEventVO = new DaHuaFireEventVO();
        try {
            daHuaFireEventVO = JSONObject.parseObject(jsonStr, DaHuaFireEventVO.class);
            eventCode = alarmEventService.insertDaHuaEvent(daHuaFireEventVO);
        } catch (Exception e) {
            logger.error(e.getMessage());
        }
        if (StringUtils.isBlank(eventCode)) {
            eventCode = String.valueOf(System.currentTimeMillis());
        }
        try {
            CentereventTReportmessage tReportMessage = new CentereventTReportmessage();
            tReportMessage.setId(eventCode);
            String alarmName = StringUtils.isBlank(MapUtils.getString(daHuaFireEventVO.getInfo(), "alarmTypeName")) ? MapUtils.getString(daHuaFireEventVO.getInfo(), "alarmType") : MapUtils.getString(daHuaFireEventVO.getInfo(), "alarmTypeName");
            tReportMessage.setSource("大华摄像头-" + alarmName);
            tReportMessage.setContext(jsonStr);
            centereventTReportmessageService.insertCentereventTReportmessage(tReportMessage);
        } catch (Exception e) {
            logger.error(e.getMessage());
        }
        return R.ok();
    }

    @PostMapping("/dahua@alarmEventOther")
    public R alarmEventOther(@RequestBody String jsonStr) {
        String eventCode = null;
        DaHuaOtherEventVO daHuaOtherEventVO = new DaHuaOtherEventVO();
        try {
            daHuaOtherEventVO = JSONObject.parseObject(jsonStr, DaHuaOtherEventVO.class);
            eventCode = alarmEventService.insertDaHuaOtherEvent(daHuaOtherEventVO);
        } catch (Exception e) {
            logger.error(e.getMessage());
        }
        if (StringUtils.isBlank(eventCode)) {
            eventCode = String.valueOf(System.currentTimeMillis());
        }
        try {
            CentereventTReportmessage tReportMessage = new CentereventTReportmessage();
            tReportMessage.setId(eventCode);
            String alarmName = StringUtils.isBlank(daHuaOtherEventVO.getAlarmName()) ? daHuaOtherEventVO.getAlarmType() : daHuaOtherEventVO.getAlarmName();
            tReportMessage.setSource("大华摄像头-" + alarmName);
            tReportMessage.setContext(jsonStr);
            centereventTReportmessageService.insertCentereventTReportmessage(tReportMessage);
        } catch (Exception e) {
            logger.error(e.getMessage());
        }
        return R.ok();
    }

    @PostMapping("/insertEventByReport")
    public R insertEventByReport(String start, String end, String source) {
        if (StringUtils.isBlank(start) || StringUtils.isBlank(end)) {
            return R.fail("请检查参数");
        }
        List<CentereventTReportmessage> reportmessages = centereventTReportmessageService.selectCentereventTReportmessageListRange(start, end, source);
        int i = 0;
        for (CentereventTReportmessage message : reportmessages) {
            String eventCode = null;
            if (message.getSource().contains("火情报警")) {
                try {
                    DaHuaFireEventVO daHuaFireEventVO = JSONObject.parseObject(message.getContext(), DaHuaFireEventVO.class);
                    daHuaFireEventVO.setCreateTime(message.getCreateTime());
                    eventCode = alarmEventService.insertDaHuaEvent(daHuaFireEventVO);
                } catch (Exception e) {
                    logger.error(e.getMessage());
                }
            } else {
                try {
                    DaHuaOtherEventVO daHuaOtherEventVO = JSONObject.parseObject(message.getContext(), DaHuaOtherEventVO.class);
                    daHuaOtherEventVO.setCreateTime(message.getCreateTime());
                    eventCode = alarmEventService.insertDaHuaOtherEvent(daHuaOtherEventVO);
                } catch (Exception e) {
                    logger.error(e.getMessage());
                }
            }
            if (StringUtils.isNotBlank(eventCode)) {
                centereventTReportmessageService.updateCentereventTReportmessage(message.getId(), eventCode);
                i++;
            }
        }
        return R.ok(i);// 3951
    }

    /**
     * 铁塔事件上报
     *
     * @param jsonStr
     * @return R
     */
    @PostMapping("/insertTowerEvent")
    public R insertTowerEvent(@RequestBody String jsonStr) {
        String eventCode = null;
        TowerEventVo towerEventVo = new TowerEventVo();
        try {
            JSONObject jsonObject = JSONObject.parseObject(jsonStr);
            towerEventVo = JSONObject.parseObject(jsonObject.getJSONObject("data").toJSONString(), TowerEventVo.class);
            eventCode = alarmEventService.insertTowerEvent(towerEventVo);
        } catch (Exception e) {
            logger.error(e.getMessage());
        }
        if (StringUtils.isBlank(eventCode)) {
            eventCode = String.valueOf(System.currentTimeMillis());
        }
        try {
            CentereventTReportmessage tReportMessage = new CentereventTReportmessage();
            tReportMessage.setId(eventCode);
            tReportMessage.setSource("铁塔-" + towerEventVo.getAlarmType());
            tReportMessage.setContext(jsonStr);
            centereventTReportmessageService.insertCentereventTReportmessage(tReportMessage);
        } catch (Exception e) {
            logger.error(e.getMessage());
        }
        return R.ok();
    }

    /**
     * 无人机上报
     */
    /*
     * {"data":
     * [{
     *  "timeStamp":0,                                                                      //时间戳
     *  "altitude":0.0,                                                                     //海拔高度
     *  "alarmType":"Sleep",                                                                //隐患类型
     *  "createTime":1742354657000,                                                         //隐患时间
     *  "photoPath":"https://47.93.50.30:443/media/dji-photos/wayline/1742354657053.JPG",   //隐患图片地址
     *  "latitude":38.185382,                                                               //隐患纬度
     *  "photoId":518,                                                                      //隐患图片id
     *  "longitude":107.487296322                                                           //隐患经度
     *  }]
     * }
     */
    @PostMapping("/droneReport")
    public AjaxResult droneReport(@RequestBody String jsonStr) {
        if (StringUtils.isEmpty(jsonStr)) {
            logger.error("参数为空");
            return AjaxResult.error("参数为空");
        }
        logger.info("无人机数据: {}", jsonStr);

        try {
            JSONObject jsonObject = JSON.parseObject(URLToJSONConverter.convertURLToJSON(jsonStr));
            JSONArray dataArray = jsonObject.getJSONArray("data");

            if (dataArray == null || dataArray.isEmpty()) {
                logger.error("数据格式异常: 缺少data数组");
                return AjaxResult.error("数据格式异常");
            }

            List<DroneVO> droneArray = dataArray.stream()
                    .map(data -> JSON.parseObject(data.toString(), DroneVO.class))
                    .collect(Collectors.toList());

            return toAjax(alarmEventService.insertDroneEvent(droneArray));
        } catch (Exception e) {
            logger.error("数据处理失败: {}", e.getMessage());
            return AjaxResult.error("处理失败: " + e.getMessage());
        }
    }



    /**
     * [{
     *     "method": "OnEventNotify",
     *     "params": {
     *         "ability": "behavioralAnalysis",
     *         "clients": [
     *             "aiEventCenter"
     *         ],
     *         "events": [
     *             {
     *                 "componentId": "ievents-backend",
     *                 "deploySubType": "4e4d7f52cd734f329b6ee6ec6b1100d3",
     *                 "deploymentId": "",
     *                 "eventId": "xmole_25a0de5395fe4c92b6865056a7aeec00",
     *                 "tenants": [
     *                     "public"
     *                 ],
     *                 "eventLvl": 2,
     *                 "eventName": "烟雾视频检测事件",
     *                 "eventType": "72057594155409152",
     *                 "eventTypeCode": "72057594155409152",
     *                 "happenTime": "2025-05-21T15:28:19.098+08:00",
     *                 "stopTime": "2025-05-21T15:28:19.098+08:00",
     *                 "snappedPicUrl": "/ngx/proxy?i=aHR0cDovLzE5Mi4xNjguMTAwLjExMjo2MTIwL3BpYz8wZDc2MDA9MGVjMGlwLWZmbzY0MS04NjEqOW82PTI0MzFsOD0xMjQ3KjUxNzI0NDc9ODEwNyo9dDExOSoqcHM1PTIqOWJlPTBhODhmMmJlNjU1ZTU5LWExNjZvMC0wKmwyN2ExZDAwPTEwNg==",
     *                 "srcIndex": "c9d5c65bd6aa4e20a77ed7639f8a3c0a",
     *                 "externalIndexCode": "00131076500000000000",
     *                 "srcName": "市府西街基站机房无线-梨花园",
     *                 "srcType": "camera",
     *                 "status": 0,
     *                 "eventConfirmStatus": 4,
     *                 "strEventType": "72057594155409152",
     *                 "timeout": 0,
     *                 "data": {
     *                     "lockTimeAfter": 15,
     *                     "latitude": "",
     *                     "transInfo": "{\"imageUrl\":\"http://192.168.100.112:6120/pic?0d7600=0ec0ip-ffo641-861*9o6=2431l8=1247*5172447=8107*=t119**ps5=2*9be=0a88f2be655e59-a166o0-0*l27a1d00=106\",\"detectionTarget\":0,\"regionCoordinatesList\":[{\"positionX\":0.760938,\"positionY\":0.663889},{\"positionX\":0.8132820000000001,\"positionY\":0.663889},{\"positionX\":0.8132820000000001,\"positionY\":0.9055559999999999},{\"positionX\":0.760938,\"positionY\":0.9055559999999999}],\"frameNum\":634712,\"targetAttrs\":{\"taskId\":\"FX20250515094019417\",\"cameraIndexCode\":\"c9d5c65bd6aa4e20a77ed7639f8a3c0a\",\"taskName\":\"烟火视频算法0515\",\"streamType\":\"realtimeVideo\",\"extendedAttrs\":\"{\\\"lockTimeAfter\\\":15,\\\"latitude\\\":\\\"\\\",\\\"eventSource\\\":\\\"ievents-backend\\\",\\\"tenantIndexCode\\\":\\\"public\\\",\\\"verifyTimeLimit\\\":1,\\\"algorithmCode\\\":\\\"HIKVISION_dc_smgd_5.101.250331_vbsd\\\",\\\"lockTime\\\":864000,\\\"deploymentId\\\":\\\"a886b86c7df84919a7d8081e2e0f3738\\\",\\\"pushGroup\\\":null,\\\"presetIndex\\\":-1,\\\"ruleId\\\":\\\"4e4d7f52cd734f329b6ee6ec6b1100d3\\\",\\\"userGroup\\\":null,\\\"lockTimeBefore\\\":15,\\\"longitude\\\":\\\"\\\",\\\"locationName\\\":\\\"市府西街基站机房无线-梨花园\\\",\\\"address\\\":\\\"市府西街基站机房无线-梨花园\\\",\\\"level\\\":2,\\\"verified\\\":false,\\\"videoLock\\\":false,\\\"resourceName\\\":\\\"市府西街基站机房无线-梨花园\\\",\\\"resourceIndexCode\\\":\\\"c9d5c65bd6aa4e20a77ed7639f8a3c0a\\\",\\\"pushUsers\\\":null,\\\"ruleRegion\\\":[{\\\"type\\\":\\\"polygon\\\",\\\"points\\\":[{\\\"x\\\":0,\\\"y\\\":0},{\\\"x\\\":1,\\\"y\\\":0},{\\\"x\\\":1,\\\"y\\\":1},{\\\"x\\\":0,\\\"y\\\":1}]}],\\\"algorithmName\\\":\\\"烟雾视频检测\\\",\\\"applicant\\\":\\\"admin\\\",\\\"eventCode\\\":72057594155409152,\\\"jobId\\\":\\\"FX20250515094019417\\\",\\\"subEventCode\\\":72057594155409152,\\\"resourceType\\\":\\\"camera\\\",\\\"externalIndexCode\\\":\\\"00131076500000000000\\\"}\",\"subTaskId\":\"18d026d13f744e5b88eb4f45aaebcd4c\",\"ruleId\":\"4e4d7f52cd734f329b6ee6ec6b1100d3\",\"aiFunctionCode\":\"HIKVISION_dc_smgd_5.101.250331_vbsd\",\"algorithmName\":\"烟雾视频检测\",\"algorithmVersion\":\"5.101.250331\",\"ownerId\":\"d1\",\"userId\":\"admin\",\"taskSource\":\"ievents\",\"rule\":\"{\\\"pictureAddTarget\\\":false,\\\"pictureAddRule\\\":false,\\\"rulesParam\\\":[{\\\"ruleCustomName\\\":\\\"新增规则\\\",\\\"eventType\\\":\\\"smog\\\",\\\"scene\\\":\\\"smokeAndFire\\\",\\\"ruleId\\\":\\\"4e4d7f52cd734f329b6ee6ec6b1100d3\\\",\\\"paramsInfo\\\":{\\\"imgParam\\\":50,\\\"procMode\\\":0,\\\"cameraMode\\\":0,\\\"Region\\\":[{\\\"x\\\":0,\\\"y\\\":0},{\\\"x\\\":1,\\\"y\\\":0},{\\\"x\\\":1,\\\"y\\\":1},{\\\"x\\\":0,\\\"y\\\":1}],\\\"simpleAlert\\\":1,\\\"filterSensitivity\\\":50,\\\"normalSensitivity\\\":80,\\\"skyParam\\\":50,\\\"cameraState\\\":0}}],\\\"shieldRegion\\\":[]}\",\"recognitionSign\":2,\"videoStructure\":1,\"analysisType\":\"realtime\",\"mainTaskId\":\"FX20250515094019417\",\"transmission\":{\"taskIds\":\"18d026d13f744e5b88eb4f45aaebcd4c\"},\"AISendTime\":\"2025-05-21T15:27:56.842+08:00\",\"engineSendTime\":\"2025-05-21 15:27:55.711\",\"ruleCustomName\":null}}",
     *                     "eventSource": "ievents-backend",
     *                     "tenantIndexCode": "public",
     *                     "verifyTimeLimit": 1,
     *                     "algorithmCode": "HIKVISION_dc_smgd_5.101.250331_vbsd",
     *                     "rect": "[{\"id\":null,\"index\":0,\"rect\":[{\"x\":\"0.760938\",\"y\":\"0.663889\"},{\"x\":\"0.8132820000000001\",\"y\":\"0.663889\"},{\"x\":\"0.8132820000000001\",\"y\":\"0.9055559999999999\"},{\"x\":\"0.760938\",\"y\":\"0.9055559999999999\"}],\"confidence\":null,\"tag\":null,\"typeTags\":null,\"valueTags\":null,\"url\":null,\"plateNo\":null}]",
     *                     "lockTime": 864000,
     *                     "deploymentId": "a886b86c7df84919a7d8081e2e0f3738",
     *                     "aiFunctionCode": "HIKVISION_dc_smgd_5.101.250331_vbsd",
     *                     "presetIndex": -1,
     *                     "tag": "",
     *                     "ruleId": "4e4d7f52cd734f329b6ee6ec6b1100d3",
     *                     "lockTimeBefore": 15,
     *                     "longitude": "",
     *                     "baseAlgorithmId": "HIKVISION_dc_smgd_5.101.250331_vbsd",
     *                     "locationName": "市府西街基站机房无线-梨花园",
     *                     "address": "市府西街基站机房无线-梨花园",
     *                     "level": 2,
     *                     "verified": false,
     *                     "videoLock": false,
     *                     "resourceName": "市府西街基站机房无线-梨花园",
     *                     "aiStrategyOutput": {
     *
     *                     },
     *                     "resourceIndexCode": "c9d5c65bd6aa4e20a77ed7639f8a3c0a",
     *                     "ruleRegion": [
     *                         {
     *                             "type": "polygon",
     *                             "points": [
     *                                 {
     *                                     "x": 0,
     *                                     "y": 0
     *                                 },
     *                                 {
     *                                     "x": 1,
     *                                     "y": 0
     *                                 },
     *                                 {
     *                                     "x": 1,
     *                                     "y": 1
     *                                 },
     *                                 {
     *                                     "x": 0,
     *                                     "y": 1
     *                                 }
     *                             ]
     *                         }
     *                     ],
     *                     "algorithmName": "烟雾视频检测",
     *                     "applicant": "admin",
     *                     "eventCode": 72057594155409152,
     *                     "jobId": "FX20250515094019417",
     *                     "targetList": "[]",
     *                     "ptzValue": "\"\"",
     *                     "region": "\"\"",
     *                     "subEventCode": 72057594155409152,
     *                     "taskId": "FX20250515094019417",
     *                     "resourceType": "camera",
     *                     "externalIndexCode": "00131076500000000000",
     *                     "strategyStatus": 0,
     *                     "presetIndexCode": "",
     *                     "manualConfirmFlag": true,
     *                     "autoVerify": false
     *                 }
     *             }
     *         ],
     *         "sendTime": "2025-05-21T15:28:00.438+08:00",
     *         "uids": [
     *             "admin"
     *         ],
     *         "quids": [
     *             "admin"
     *         ]
     *     }
     * }]
     * @return AjaxResult
     */
    @PostMapping("/smokeReport")
    public AjaxResult testReportJsonObj(@RequestBody JSONArray jsonArray){
        logger.info("海康-烟雾报警数据--->: {}", jsonArray);
        String eventCode = null;
        JSONObject jsonObject = JSONObject.parseObject(JSON.toJSONString(jsonArray.get(0)));
        try {
            HaiKangEventSmokeVo smokeEvent = JSONObject.toJavaObject(jsonObject.getJSONObject("params"), HaiKangEventSmokeVo.class);
            eventCode = alarmEventService.insertHaiKangSmokeEvent(smokeEvent);
        } catch (Exception e) {
            logger.error(e.getMessage());
        }
        if (StringUtils.isBlank(eventCode)) {
            eventCode = String.valueOf(System.currentTimeMillis());
        }
        try {
            CentereventTReportmessage tReportMessage = new CentereventTReportmessage();
            tReportMessage.setId(eventCode);
            tReportMessage.setSource("海康摄像头-烟雾");
            tReportMessage.setContext(jsonArray.toJSONString());
            centereventTReportmessageService.insertCentereventTReportmessage(tReportMessage);
        } catch (Exception e) {
            logger.error(e.getMessage());
        }

        return AjaxResult.success();
    }
}
