package com.sooka.sponest.event.centereventteventcatalogue.controller;

import com.ruoyi.common.core.domain.R;
import com.ruoyi.common.core.utils.SpringUtils;
import com.ruoyi.common.core.utils.StringUtils;
import com.ruoyi.common.core.web.controller.BaseController;
import com.ruoyi.common.security.utils.SecurityUtils;
import com.ruoyi.system.api.RemoteDeptService;
import com.sooka.sponest.event.centereventteventcatalogue.domain.bo.AppEventSalBO;
import com.sooka.sponest.event.centereventteventcatalogue.domain.vo.AppEventSalVO;
import com.sooka.sponest.event.centereventteventcatalogue.domain.vo.VisuForestCloudMapVO;
import com.sooka.sponest.event.centereventteventcatalogue.service.ICenterEventAppService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

/**
 * @program: sooka
 * @description: 事件中心-移动端控制器
 * @author: lyq
 * @create: 2022-10-26
 **/
@Api(tags = "移动端")
@RestController
@RequestMapping("/eventapp")
public class CenterEventAppController extends BaseController {

    @Autowired
    private ICenterEventAppService centerEventAppService;

    /**
     * 查询事件目录列表
     */
    @PostMapping("/listByApp")
    public R listByApp(@Validated @RequestBody AppEventSalVO appEventSalVO) {
//        if ("forest_event_status_7".equals(appEventSalVO.getEventStatusValue())) {
//            R<Boolean> result = SpringUtils.getBean(RemoteDeptService.class).deptParentsHasBureau(SecurityUtils.getLoginUser().getSysUser().getDeptId());
//            if (result.getData()) {
//                appEventSalVO.setEventStatusValue("-1");// 是行管局，只看签收之后的事件
//            }
//        }
        return R.ok(centerEventAppService.listByApp(appEventSalVO));
    }

    /**
     * 获取事件目录详细信息
     */
    @ApiOperation("获取事件目录详细信息")
    @GetMapping("/getCentereventTEventcatalogueByCode")
    public R getCentereventTEventcatalogueByCode(AppEventSalBO appEventSalBO) {
        if (StringUtils.isBlank(appEventSalBO.getEventCode())) {
            return R.fail();
        }
        return R.ok(centerEventAppService.selectCentereventTEventcatalogueByEventCode(appEventSalBO));
    }

    @ApiOperation("事件状态统计")
    @PostMapping("/getEventCountGroupByEventStatus")
    public R getEventCountGroupByEventStatus(@RequestBody VisuForestCloudMapVO visuForestCloudMapVO) {
        return R.ok(centerEventAppService.getEventCountGroupByEventStatus(visuForestCloudMapVO));
    }

    @ApiOperation("事件类型统计")
    @PostMapping("/getEventCountGroupByEventType")
    public R getEventCountGroupByEventType(@RequestBody VisuForestCloudMapVO visuForestCloudMapVO) {
        return R.ok(centerEventAppService.getEventCountGroupByEventType(visuForestCloudMapVO));
    }
}
