package com.sooka.sponest.event.centereventteventcatalogue.controller;

import com.ruoyi.common.core.web.controller.BaseController;
import com.ruoyi.common.core.web.domain.AjaxResult;
import com.sooka.sponest.event.centereventtdeptevent.domain.CentereventDeptEvent;
import com.sooka.sponest.event.centereventteventcatalogue.service.ICenterEventCommandCenterService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.HashMap;
import java.util.Map;

/**
 * @program: sooka
 * @description: 事件中心-可视化控制器
 * @author: lyq
 * @create: 2023-04-23
 **/
@Api(tags = "市指挥中心")
@RestController
@RequestMapping("/commandCenter")
public class CenterEventCommandController extends BaseController {

    @Autowired
    private ICenterEventCommandCenterService centerEventCommandCenterService;

    @ApiOperation("实时关注")
    @GetMapping("/getDeptEventCount")
    public AjaxResult getDeptEventCount(CentereventDeptEvent centereventTDeptEvent) {
        return AjaxResult.success(centerEventCommandCenterService.getDeptEventCount(centereventTDeptEvent));
    }

    @ApiOperation("实时关注-分析报告")
    @GetMapping("/getAnalysisReport")
    public AjaxResult getAnalysisReport(CentereventDeptEvent centereventTDeptEvent) {
        Map<String, Object> resultMap = new HashMap<>();
        resultMap.put("fireSource", centerEventCommandCenterService.getFireSource(centereventTDeptEvent));
        resultMap.put("firePlace", centerEventCommandCenterService.getFirePlace(centereventTDeptEvent));
        resultMap.put("fireLoss", centerEventCommandCenterService.getFireLoss(centereventTDeptEvent));
        resultMap.put("fireInfo", centerEventCommandCenterService.getFireInfo(centereventTDeptEvent));
        return AjaxResult.success(resultMap);
    }

    @ApiOperation("事件统计")
    @GetMapping("/getEventStatistics")
    public AjaxResult getEventStatistics(CentereventDeptEvent centereventTDeptEvent) {
        Map<String, Object> resultMap = new HashMap<>();
        resultMap.put("status", centerEventCommandCenterService.getEventStatusCount(centereventTDeptEvent));
        resultMap.put("type", centerEventCommandCenterService.getEventTypeCount(centereventTDeptEvent));
        return AjaxResult.success(resultMap);
    }

    @ApiOperation("事件统计click")
    @GetMapping("/getEventStatisticsOther")
    public AjaxResult getEventStatisticsOther(CentereventDeptEvent centereventTDeptEvent) {
        Map<String, Object> resultMap = new HashMap<>();
        resultMap.put("hgj", centerEventCommandCenterService.getEventHgjCount(centereventTDeptEvent));
        resultMap.put("trend", centerEventCommandCenterService.getEventTrend(centereventTDeptEvent));
        return AjaxResult.success(resultMap);
    }

    @ApiOperation("app事件统计")
    @GetMapping("/appEventStatistics")
    public AjaxResult appEventStatistics(CentereventDeptEvent centereventTDeptEvent) {
        Map<String, Object> resultMap = new HashMap<>();
        resultMap.put("bm", centerEventCommandCenterService.getEventBmCount(centereventTDeptEvent));
        resultMap.put("hgj", centerEventCommandCenterService.getEventHgjCount(centereventTDeptEvent));
        return AjaxResult.success(resultMap);
    }

    @ApiOperation("事件落点")
    @GetMapping("/getEventPoint")
    public AjaxResult getEventPoint(CentereventDeptEvent centereventTDeptEvent) {
        return AjaxResult.success(centerEventCommandCenterService.getEventPoint(centereventTDeptEvent));
    }
}
