package com.sooka.sponest.event.centereventteventcatalogue.controller;

import com.ruoyi.common.core.domain.R;
import com.ruoyi.common.core.utils.SpringUtils;
import com.ruoyi.common.core.utils.StringUtils;
import com.ruoyi.common.core.utils.poi.ExcelUtil;
import com.ruoyi.common.core.web.controller.BaseController;
import com.ruoyi.common.core.web.domain.AjaxResult;
import com.ruoyi.common.core.web.page.TableDataInfo;
import com.ruoyi.common.log.annotation.Log;
import com.ruoyi.common.log.enums.BusinessType;
import com.ruoyi.common.security.annotation.RequiresPermissions;
import com.ruoyi.system.api.RemoteConfigService;
import com.sooka.sponest.event.centereventteventcatalogue.domain.CentereventTDownloads;
import com.sooka.sponest.event.centereventteventcatalogue.service.ICentereventTDownloadsService;
import com.sooka.sponest.event.utils.EventConstants;
import com.sooka.sponest.monitor.api.RemoteMonitorService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 【请填写功能名称】Controller
 *
 * @author ruoyi
 * @date 2023-09-12
 */
@RestController
@RequestMapping("/downloads")
public class CentereventTDownloadsController extends BaseController {

    @Autowired
    private ICentereventTDownloadsService centereventTDownloadsService;

    @Autowired
    private RemoteMonitorService remoteMonitorService;

//    @Autowired
//    private RemoteMessageService remoteMessageService;
//
//    @PostMapping("/testMessage")
//    public AjaxResult testMessage() throws Exception {
//        MessageVo vo=new MessageVo();
//        vo.setType("1");
//        vo.setEventCode("testcode");
//        vo.setEventName("test名称");
//        vo.setPhones(new String[]{"13756659676"});
//        vo.setContent(new String []{"2023年8月10日 16:15:48 测试短信平台，请联系：演示，联系电话：18843065853"});
////        vo.setSignName("态势感知平台网");
//        remoteMessageService.sendTxMessage(vo);
//        System.out.println("==============>");
//        MessageVo vo1=new MessageVo();
//        vo1.setType("2");
//        vo1.setEventCode("testcode");
//        vo1.setEventName("test名称");
//        vo1.setPhones(new String[]{"13756659676"});
//        vo1.setContent(new String []{"四平市伊通县河源镇后倒木屯东北茨牙水库2023-07-27 06:28:21钓鱼检测","/j/961"});
//        remoteMessageService.sendTxMessage(vo1);
//        return AjaxResult.success();
//    }

    /**
     * 查询【请填写功能名称】列表
     */
    @RequiresPermissions("event:downloads:list")
    @GetMapping("/list")
    public TableDataInfo list(CentereventTDownloads centereventTDownloads) {
        startPage();
        List<CentereventTDownloads> list = centereventTDownloadsService.selectCentereventTDownloadsList(centereventTDownloads);
        if (StringUtils.isNotEmpty(list)) {
            String prefix = SpringUtils.getBean(RemoteConfigService.class).remotegetConfigKey(EventConstants.FILE_PREFIX_LOCAL).getData();
            list.forEach(item -> {
                if ("1".equals(item.getFlag())) {
                    item.setPath(prefix + item.getPath());
                }
            });
        }
        return getDataTable(list);
    }

    /**
     * 导出【请填写功能名称】列表
     */
    @RequiresPermissions("event:downloads:export")
    @Log(title = "【请填写功能名称】", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, CentereventTDownloads centereventTDownloads) {
        List<CentereventTDownloads> list = centereventTDownloadsService.selectCentereventTDownloadsList(centereventTDownloads);
        ExcelUtil<CentereventTDownloads> util = new ExcelUtil<>(CentereventTDownloads.class);
        util.exportExcel(response, list, "【请填写功能名称】数据");
    }

    /**
     * 获取【请填写功能名称】详细信息
     */
    @RequiresPermissions("event:downloads:query")
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") String id) {
        return AjaxResult.success(centereventTDownloadsService.selectCentereventTDownloadsById(id));
    }

    /**
     * 新增【请填写功能名称】
     */
    @RequiresPermissions("event:downloads:add")
    @Log(title = "【请填写功能名称】", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody CentereventTDownloads centereventTDownloads) {
        return toAjax(centereventTDownloadsService.insertCentereventTDownloads(centereventTDownloads));
    }

    /**
     * 修改【请填写功能名称】
     */
//    @RequiresPermissions("event:downloads:edit")
    @Log(title = "【请填写功能名称】", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody CentereventTDownloads centereventTDownloads) {
        return toAjax(centereventTDownloadsService.updateCentereventTDownloads(centereventTDownloads));
    }

    /**
     * 删除【请填写功能名称】
     */
    @RequiresPermissions("event:downloads:remove")
    @Log(title = "【请填写功能名称】", businessType = BusinessType.DELETE)
    @DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable String[] ids) {
        return toAjax(centereventTDownloadsService.deleteCentereventTDownloadsByIds(ids));
    }

    /**
     * 事件视频下载
     *
     * @param id
     * @return
     */
    @Log(title = "事件视频下载", businessType = BusinessType.OTHER)
    @GetMapping("/eventhandleDownload/{id}")
    public R eventhandleDownload(@PathVariable("id") String id) {
        Map<String, Object> params = new HashMap<>();
        params.put("id", id);
        List<Map<String, Object>> list = centereventTDownloadsService.downloadsCommon(params);
        // 校验 已下载不让重复下载
        if (StringUtils.isEmpty(list)) {
            return R.fail("已下载的视频，不能重复下载!");
        } else {
            return remoteMonitorService.getPlaybackByTime(list);
        }
    }

    @PostMapping("/downloadsMonth")
    public R downloadsMonth(@RequestBody Map<String, Object> params) {
        List<Map<String, Object>> list = centereventTDownloadsService.downloadsCommon(params);
        return remoteMonitorService.getPlaybackByTime(list);
    }
}
