package com.sooka.sponest.event.centereventteventcatalogue.controller;

import com.ruoyi.common.core.constant.HttpStatus;
import com.ruoyi.common.core.domain.R;
import com.ruoyi.common.core.utils.SpringUtils;
import com.ruoyi.common.core.utils.StringUtils;
import com.ruoyi.common.core.utils.file.FilePrefixUtils;
import com.ruoyi.common.core.utils.uuid.IdUtils;
import com.ruoyi.common.core.web.controller.BaseController;
import com.ruoyi.common.core.web.domain.AjaxResult;
import com.ruoyi.common.core.web.page.TableDataInfo;
import com.ruoyi.common.log.annotation.Log;
import com.ruoyi.common.log.enums.BusinessType;
import com.ruoyi.common.security.annotation.RequiresPermissions;
import com.ruoyi.common.security.utils.SecurityUtils;
import com.ruoyi.system.api.RemoteConfigService;
import com.ruoyi.system.api.RemoteDeptService;
import com.ruoyi.system.api.RemoteUserService;
import com.ruoyi.system.api.domain.SysUser;
import com.sooka.sponest.event.centereventteventcatalogue.domain.CentereventTEventcatalogue;
import com.sooka.sponest.event.centereventteventcatalogue.domain.bo.CentereventtDeptEventBO;
import com.sooka.sponest.event.centereventteventcatalogue.service.ICentereventTDownloadsService;
import com.sooka.sponest.event.centereventteventcatalogue.service.ICentereventTEventcatalogueService;
import com.sooka.sponest.event.centereventteventtype.domain.CentereventTEventtype;
import com.sooka.sponest.event.centereventteventtype.service.ICentereventTEventtypeService;
import com.sooka.sponest.event.centereventtfirelog.domain.CentereventTFireLog;
import com.sooka.sponest.event.centereventtfirelog.service.ICentereventTFireLogService;
import com.sooka.sponest.event.remoteapi.RemoteDataService;
import com.sooka.sponest.event.remoteapi.domain.CenterdataTAttach;
import com.sooka.sponest.event.utils.EventProducerUtil;
import com.sooka.sponest.event.utils.ExcelUtil;
import com.sooka.sponest.event.utils.RemoteApiUtil;
import com.sooka.sponest.monitor.api.RemoteMonitorService;
import com.sooka.sponest.monitor.api.domain.CenterdataTAidevicedept;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.util.*;
import java.util.concurrent.CompletableFuture;
import java.util.concurrent.ExecutionException;
import java.util.stream.Collectors;

import static com.sooka.sponest.event.utils.EventConstants.*;

/**
 * 事件目录Controller
 *
 * @author ruoyi
 * @date 2022-08-27
 */
@Api(tags = "事件目录")
@RestController
@RequestMapping("/eventcatalogue")
public class CentereventTEventcatalogueController extends BaseController {

    @Autowired
    private ICentereventTEventcatalogueService centereventTEventcatalogueService;

    @Autowired
    private ICentereventTFireLogService centereventTFireLogService;

    @Autowired
    private ICentereventTEventtypeService centereventTEventtypeService;

    @Autowired
    private RemoteDataService remoteDataService;

    @Autowired
    private ICentereventTDownloadsService centereventTDownloadsService;

//    @Autowired
//    @Qualifier("asyncTaskExecutor")
//    private ThreadPoolTaskExecutor asyncTaskExecutor;

    /**
     * 查询事件目录列表
     */
    @RequiresPermissions("eventcatalogue:eventcatalogue:list")
    @GetMapping("/listByPc")
    public TableDataInfo listByPc(CentereventTEventcatalogue centereventTEventcatalogue) {
        startPage();
        if ((StringUtils.isEmpty(centereventTEventcatalogue.getEventTypeXls()) && centereventTEventcatalogue.getDefaultTypeXl().contains("1"))
                || (StringUtils.isNotEmpty(centereventTEventcatalogue.getEventTypeXls()) && centereventTEventcatalogue.getEventTypeXls().contains("1"))) {
            centereventTEventcatalogue.setEventType("1");
        }
        return getDataTable(centereventTEventcatalogueService.listByPc(centereventTEventcatalogue));
    }

    /**
     * 导出事件目录列表
     */
    @RequiresPermissions("eventcatalogue:eventcatalogue:export")
    @Log(title = "事件目录", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, CentereventTEventcatalogue centereventTEventcatalogue) {
        if (StringUtils.isNotBlank(centereventTEventcatalogue.getEventType())) {
            centereventTEventcatalogue.setEventTypes(centereventTEventcatalogue.getEventType().split(","));
        }
        List<CentereventTEventcatalogue> list = centereventTEventcatalogueService.listByPc(centereventTEventcatalogue);
        ExcelUtil<CentereventTEventcatalogue> util = new ExcelUtil<>(CentereventTEventcatalogue.class);
        util.exportExcel(response, list, "事件目录数据");
    }

    /**
     * 获取事件目录详细信息
     */
    @RequiresPermissions("eventcatalogue:eventcatalogue:query")
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") String id) {
        CentereventTEventcatalogue centereventTEventcatalogue = centereventTEventcatalogueService.selectCentereventTEventcatalogueById(id);
        CentereventTFireLog centereventTFireLog = centereventTFireLogService.selectFirstCentereventTFireLogByEventCode(centereventTEventcatalogue.getEventCode());
        CenterdataTAttach centerdataTAttach = new CenterdataTAttach();
        centerdataTAttach.setBusId(centereventTFireLog.getId());
        List<CenterdataTAttach> centerdataTAttaches = remoteDataService.remoteattachlist(centerdataTAttach).getData();
        if (StringUtils.isNotEmpty(centerdataTAttaches)) {
            // 附件前缀
            Map<String, String> keyMap = SpringUtils.getBean(RemoteConfigService.class).remotegetConfigMap(Arrays.asList(FILE_PREFIX_LOCAL, FILE_PREFIX_HIK1, FILE_PREFIX_HIK2, FILE_PREFIX_DH1, FILE_PREFIX_DH2)).getData();
            String token = RemoteApiUtil.getInstance().getToken();// 大华token
            // 拼接组合
            centerdataTAttaches.forEach(item -> {
                if ("DH_1".equals(item.getBusSource())) {
                    item.setAttachPath(FilePrefixUtils.getUrlPrefix(item.getBusSource(), keyMap) + item.getAttachPath() + "?token=" + token);
                } else {
                    item.setAttachPath(FilePrefixUtils.getUrlPrefix(item.getBusSource(), keyMap) + item.getAttachPath());
                }
            });
        }
        centereventTEventcatalogue.setAttach(centerdataTAttaches);
        return AjaxResult.success(centereventTEventcatalogue);
    }

    /**
     * 获取事件目录详细信息
     */
    @ApiOperation("获取事件目录详细信息")
    @GetMapping("/getCentereventTEventcatalogueByCode")
    public R getCentereventTEventcatalogueByCode(String eventCode) {
        if (StringUtils.isBlank(eventCode)) {
            return R.fail();
        }
        return R.ok(centereventTEventcatalogueService.selectCentereventTEventcatalogueByEventCode(eventCode));
    }

    /**
     * 新增事件目录
     */
    @RequiresPermissions("eventcatalogue:eventcatalogue:add")
    @Log(title = "事件目录", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@Validated @RequestBody CentereventTEventcatalogue centereventTEventcatalogue) {
        return toAjax(centereventTEventcatalogueService.addCentereventTEventcatalogue(centereventTEventcatalogue));
    }

    /**
     * 新增事件目录
     */
    @ApiOperation("新增事件目录")
    @Log(title = "事件目录", businessType = BusinessType.INSERT)
    @PostMapping("/addOpenFen")
    public AjaxResult addOpenFen(@Validated @RequestBody CentereventTEventcatalogue centereventTEventcatalogue) {
        int result = 0;
        try {
            result = centereventTEventcatalogueService.addCentereventTEventcatalogue(centereventTEventcatalogue);
        } catch (Exception e) {
            logger.error(e.getMessage());
        }
        return toAjax(result);
    }

    /**
     * 事件处置
     */
    @ApiOperation("事件处置")
    @PostMapping("/eventHandling")
    public AjaxResult eventHandling(@RequestBody CentereventTEventcatalogue centereventTEventcatalogue) {
        CentereventTFireLog log = new CentereventTFireLog();
        log.setId(IdUtils.simpleUUID());
        log.setEventCode(centereventTEventcatalogue.getEventCode());
        log.setLogContent(SecurityUtils.getLoginUser().getSysUser().getNickName() + "延后处置该事件");
        centereventTFireLogService.insertCentereventTFireLog(log);
        return toAjax(centereventTEventcatalogueService.updateCentereventTEventcatalogue(centereventTEventcatalogue));
    }

    /**
     * 事件审核
     */
    @ApiOperation("事件审核")
    @PostMapping("/eventExamine")
    public AjaxResult eventExamine(@RequestBody CentereventTEventcatalogue centereventTEventcatalogue) {
        CentereventTFireLog log = new CentereventTFireLog();
        log.setId(IdUtils.simpleUUID());
        log.setEventCode(centereventTEventcatalogue.getEventCode());
        String content = SecurityUtils.getLoginUser().getSysUser().getNickName() + "审核结果：";
        content += "0".equals(centereventTEventcatalogue.getIsExamine()) ? "不通过" : "通过";
        content += "，审核意见：" + centereventTEventcatalogue.getEventDescription();
        log.setLogContent(content);
        centereventTFireLogService.insertCentereventTFireLog(log);
        if (StringUtils.isNotEmpty(centereventTEventcatalogue.getAttach())) {
            for (CenterdataTAttach centerdataTAttach : centereventTEventcatalogue.getAttach()) {
                centerdataTAttach.setBusId(log.getId());
                centerdataTAttach.setBusIndx("bus_indx_forest");
                centerdataTAttach.setBusSource("PC");
                centerdataTAttach.setFileType(FilePrefixUtils.getUrlSuffix(centerdataTAttach.getAttachPath()));
                remoteDataService.insertAttach(centerdataTAttach);
            }
        }
        if (!"1".equals(centereventTEventcatalogue.getIsExamine())) {
            centereventTEventcatalogue.setEventStatusValue("forest_event_status_2");
            centereventTEventcatalogue.setEventStatus("签收");
            SysUser user = SecurityUtils.getLoginUser().getSysUser();
            CompletableFuture<Void> future = CompletableFuture.runAsync(() -> {
                SysUser sysUser = SpringUtils.getBean(RemoteUserService.class).selectById(centereventTEventcatalogue.getUpdateBy()).getData();
                if (null != sysUser) {
                    String message = "您申请办结的事件经县(市/区)指挥中心审核，未达到归档标准，请重新处置！如有疑问请联系县(市/区)指挥中心。审核人："
                            + user.getNickName() + "，联系电话：" + user.getPhonenumber();
                    RemoteApiUtil.getInstance().sendMessage(new HashSet<>(Arrays.asList(sysUser.getPhonenumber())), message, centereventTEventcatalogue.getEventCode(), centereventTEventcatalogue.getEventName());
                }
            });
            try {
                future.get();
            } catch (InterruptedException e) {
                logger.error(e.getMessage());
            } catch (ExecutionException e) {
                logger.error(e.getMessage());
            }
        }
        // 审核后变更消息状态为已读
        RemoteApiUtil.getInstance().updateMessageByEventCode(centereventTEventcatalogue.getEventCode());
        centereventTEventcatalogue.setEventDescription(null);
        return toAjax(centereventTEventcatalogueService.updateCentereventTEventcatalogue(centereventTEventcatalogue));
    }

    @ApiOperation("事件流转")
    @Log(title = "事件目录", businessType = BusinessType.UPDATE)
    @PostMapping("/editEventStatus")
    public AjaxResult editEventStatus(@RequestBody CentereventtDeptEventBO centereventtDeptEventBO) {
        List<CenterdataTAidevicedept> listDept = new ArrayList<>();// 责任单位
        // 因确认时才有摄像头编号参数，此处单独验证
        if ("qr".equals(centereventtDeptEventBO.getEventStatus())) {
            if (StringUtils.isBlank(centereventtDeptEventBO.getCameraCode())) {
                return AjaxResult.error("请传入摄像头编码");
            }
            listDept = SpringUtils.getBean(RemoteMonitorService.class).listForCommandCenter(centereventtDeptEventBO.getCameraCode(), "1", "0").getData();
            if (StringUtils.isEmpty(listDept)) {
                return AjaxResult.error("未配置责任单位");
            }
        }
        // 因签收时火情事件需要事件小类，此处单独验证
        if ("qs".equals(centereventtDeptEventBO.getEventStatus()) && StringUtils.isBlank(centereventtDeptEventBO.getEventType())) {
            return AjaxResult.error("请选择事件类型");
        }
        // modify by majunqi 增加版本号 限制数据锁
        CentereventTEventcatalogue centereventTEventcatalogue = centereventTEventcatalogueService.selectCentereventTEventcatalogueById(centereventtDeptEventBO.getId());
        if (centereventtDeptEventBO.getVersion() != centereventTEventcatalogue.getVersion()) {
            return AjaxResult.error(HttpStatus.NOT_MODIFIED, "当前事件已经被流转为" + centereventTEventcatalogue.getEventStatus() + "状态，无法更改!");
        }
        centereventTEventcatalogue = centereventTEventcatalogueService.editEventStatus(centereventTEventcatalogue, centereventtDeptEventBO, listDept);
        // 确认时发送消息，极光推送
        try {
            if ("qr".equals(centereventtDeptEventBO.getEventStatus())) {
                SysUser sysUser = new SysUser();
                sysUser.setDeptIds(listDept.stream().map(CenterdataTAidevicedept::getMapDeptId).collect(Collectors.toList()).toArray(new Long[listDept.size()]));
                List<SysUser> sysUsers = SpringUtils.getBean(RemoteUserService.class).selectDeptAndUsersByIsShortmsg(sysUser).getData();
                Set<String> phones = new HashSet<>();
                Set<Long> userIds = new HashSet<>();
                if (StringUtils.isNotEmpty(sysUsers)) {
                    phones = sysUsers.stream().map(SysUser::getPhonenumber).collect(Collectors.toSet());
                    userIds = sysUsers.stream().map(SysUser::getUserId).collect(Collectors.toSet());
                }
                CentereventTEventtype centereventTEventtype = centereventTEventtypeService.selectCentereventTEventtypeById(null == centereventTEventcatalogue.getEventTypeXl() ? centereventTEventcatalogue.getEventType() : centereventTEventcatalogue.getEventTypeXl());
                String userName = SecurityUtils.getLoginUser().getSysUser().getNickName();
                String phone = SecurityUtils.getLoginUser().getSysUser().getPhonenumber();
                String message = centereventTEventcatalogue.getAddress() + "发生" + centereventTEventtype.getEventTypeName();
                message += "1".equals(centereventTEventtype.getId()) ? "" : "事件";
                message += "，请联系：" + userName + "，联系电话：" + phone;
                RemoteApiUtil.getInstance().sendMessageAndJg(phones, userIds, message, centereventTEventcatalogue.getEventCode(), centereventTEventcatalogue.getEventName());
            }
        } catch (Exception e) {
            logger.error(e.getMessage());
        }
//        // 确认时更改附件路径
//        try {
//            if ("qr".equals(centereventtDeptEventBO.getEventStatus())) {
//                CompletableFuture<Void> future = CompletableFuture.runAsync(() -> {
//                    Map<String, String> paramMap = SpringUtils.getBean(RemoteConfigService.class).remotegetConfigMap(Arrays.asList(FILE_PREFIX_LOCAL, FILE_PREFIX_HIK1, FILE_PREFIX_HIK2, FILE_PREFIX_DH1, FILE_PREFIX_DH2)).getData();
//                    paramMap.put("czlx", centereventtDeptEventBO.getCzlx());
//                    CentereventTFireLog log = centereventTFireLogService.selectFirstCentereventTFireLogByEventCode(centereventtDeptEventBO.getEventCode());
//                    paramMap.put("busId", log.getId());
//                    paramMap.put("token", RemoteApiUtil.getInstance().getToken());// 大华token
//                    remoteDataService.updateAttach(paramMap);
//                }/*, asyncTaskExecutor*/);
//                future.get();
//            }
//        } catch (Exception e) {
//            logger.error(e.getMessage());
//        }
        // 办结时推送可视化消息
        if ("bj".equals(centereventtDeptEventBO.getEventStatus())) {
            List<Long> deptIds = SpringUtils.getBean(RemoteDeptService.class).findParentIdByChildDeptIdAndParentType(centereventTEventcatalogue.getDeptId(), "sys_dept_type_17,sys_dept_type_18").getData();
            RemoteApiUtil.getInstance().insertCentermessageTPushrecord(deptIds, "有事件办结需要审核！", centereventTEventcatalogue.getEventCode());
        }
        // 推送测评
        if ("qs".equals(centereventtDeptEventBO.getEventStatus()) || "bj".equals(centereventtDeptEventBO.getEventStatus()) || "gd".equals(centereventtDeptEventBO.getEventStatus())) {
            RemoteApiUtil.getInstance().addFen(centereventTEventcatalogue, centereventtDeptEventBO.getEventStatus());
        }
        return AjaxResult.success();
    }

    /**
     * 删除事件目录
     */
    @RequiresPermissions("eventcatalogue:eventcatalogue:remove")
    @Log(title = "事件目录", businessType = BusinessType.DELETE)
    @DeleteMapping("/{eventCode}")
    public AjaxResult remove(@PathVariable String eventCode) {
        int result = centereventTEventcatalogueService.deleteCentereventTEventcatalogueByCode(eventCode);
        EventProducerUtil.publish(eventCode, BusinessType.DELETE);
        return toAjax(result);
    }

    /**
     * 手机端调用发送短信
     *
     * @author hanfucheng
     * @date 2023/5/22 16:25
     */
    @ApiOperation(value = "手机端调用发送短信", notes = "手机端调用发送短信")
    @PostMapping(value = "/sendingSMS")
    public AjaxResult sendingSMS(@RequestBody CentereventtDeptEventBO centereventtDeptEventBO) {
        if (StringUtils.isNotEmpty(centereventtDeptEventBO.getPhones()) && StringUtils.isNotBlank(centereventtDeptEventBO.getAddress())
                && StringUtils.isNotBlank(centereventtDeptEventBO.getId())) {
            CentereventTEventcatalogue centereventTEventcatalogue = new CentereventTEventcatalogue();
            centereventTEventcatalogue.setId(centereventtDeptEventBO.getId());
            centereventTEventcatalogue.setEscalation("1");
            centereventTEventcatalogueService.updateCentereventTEventcatalogue(centereventTEventcatalogue);
            String userName = SecurityUtils.getLoginUser().getSysUser().getNickName();
            String phone = SecurityUtils.getLoginUser().getSysUser().getPhonenumber();
            String message = centereventtDeptEventBO.getAddress() + "发生火情，请联系：" + userName + "，联系电话：" + phone;
            RemoteApiUtil.getInstance().sendMessage(new HashSet<>(centereventtDeptEventBO.getPhones()), message, null, null);
            return AjaxResult.success();
        }
        return AjaxResult.error("请校验参数!");
    }

    /**
     * 上报县区防火办
     *
     * @author lyq
     * @date 2023/5/24
     */
    @PostMapping("/reportFirePreventionOffice")
    public AjaxResult reportFirePreventionOffice(@RequestBody CentereventtDeptEventBO centereventtDeptEventBO) {
        centereventTEventcatalogueService.reportFirePreventionOffice(centereventtDeptEventBO);
        return AjaxResult.success();
    }
}
