package com.sooka.sponest.event.centereventteventcatalogue.domain;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.ruoyi.common.core.annotation.Excel;
import com.ruoyi.common.datascope.base.domain.BaseBusinessEntity;
import com.sooka.sponest.event.remoteapi.domain.CenterdataTAttach;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import javax.validation.constraints.NotBlank;
import java.util.Date;
import java.util.List;

/**
 * 事件目录对象 centerevent_t_eventcatalogue
 *
 * @author ruoyi
 * @date 2022-08-27
 */
public class CentereventTEventcatalogue extends BaseBusinessEntity {

    public CentereventTEventcatalogue() {

    }

    public CentereventTEventcatalogue(String eventType, String eventTypeXl, String eventName, String eventDescription, String longitude, String latitude, String reportor, Date reportTime, String address) {
        this.eventType = eventType;
        this.eventTypeXl = eventTypeXl;
        this.eventName = eventName;
        this.eventDescription = eventDescription;
        this.longitude = longitude;
        this.latitude = latitude;
        this.reportor = reportor;
        this.reportTime = reportTime;
        this.address = address;
    }

    private static final long serialVersionUID = 1L;

    /**
     * 主键id
     */
    private String id;

    /**
     * 事件编号
     */
    private String eventCode;

    /**
     * 事件名称
     */
    @Excel(name = "事件名称")
    @NotBlank(message = "事件名称不能为空")
    private String eventName;

    /**
     * 事件描述
     */
    @Excel(name = "事件描述")
    @NotBlank(message = "事件描述不能为空")
    private String eventDescription;

    /**
     * 事件分类(大类)
     */
    @Excel(name = "事件分类")
    @NotBlank(message = "事件分类大类不能为空")
    private String eventType;
    private String[] eventTypes;

    /**
     * 事件分类(小类)
     */
    @NotBlank(message = "事件分类小类不能为空")
    private String eventTypeXl;
    private List<String> eventTypeXls;// 选中分类
    private List<String> defaultTypeXl;// 默认分类

    /**
     * 事件小类名称
     */
    private String eventTypeXlName;

    /**
     * 事件来源
     */
    @Excel(name = "事件来源", dictType = "reporting_source")
    private String reportSource;

    /**
     * 经度
     */
    @Excel(name = "经度")
    @NotBlank(message = "经度不能为空")
    private String longitude;

    /**
     * 纬度
     */
    @Excel(name = "纬度")
    @NotBlank(message = "纬度不能为空")
    private String latitude;

    /**
     * 上报人
     */
    @Excel(name = "上报人")
    private String reportor;

    /**
     * 上报时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
//    @Excel(name = "上报时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    private Date reportTime;
    private String[] reportTimeRange;

    /**
     * 上报具体位置
     */
    private String address;

    /**
     * 事件状态key
     */
    @Excel(name = "事件状态")
    private String eventStatus;

    /**
     * 事件状态value
     */
    private String eventStatusValue;

    /**
     * 是否被催办
     */
    @Excel(name = "是否被催办", dictType = "sys_isurge")
    private String isUrged;

    private Integer urgeCount;

    /**
     * 火灾半径
     */
    private String fireRadius;

    /**
     * 关联预案
     */
    private String reserve;

    private String eventTypeLabel;

    private String eventTypeXlLabel;

    public String getEventTypeLabel() {
        return eventTypeLabel;
    }

    public void setEventTypeLabel(String eventTypeLabel) {
        this.eventTypeLabel = eventTypeLabel;
    }

    public String getEventTypeXlLabel() {
        return eventTypeXlLabel;
    }

    public void setEventTypeXlLabel(String eventTypeXlLabel) {
        this.eventTypeXlLabel = eventTypeXlLabel;
    }

    /**
     * 数据状态(可用 、不可用 ) 字典
     */
    private String dataStatus;


    /**
     * 数据所属部门id
     */
    private Long deptId;

    /**
     * 数据所属部门名称
     */
    private String deptName;

    private String statusFlag;

    private String escalation;// 是否联系扑火队

    private String isExamine;// 是否审核

    private String isPush;// 是否推送

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gdTime;// 归档时间

    private List<CenterdataTAttach> attach;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getEventCode() {
        return eventCode;
    }

    public void setEventCode(String eventCode) {
        this.eventCode = eventCode;
    }

    public String getEventName() {
        return eventName;
    }

    public void setEventName(String eventName) {
        this.eventName = eventName;
    }

    public String getEventDescription() {
        return eventDescription;
    }

    public void setEventDescription(String eventDescription) {
        this.eventDescription = eventDescription;
    }

    public String getEventType() {
        return eventType;
    }

    public void setEventType(String eventType) {
        this.eventType = eventType;
    }

    public String[] getEventTypes() {
        return eventTypes;
    }

    public void setEventTypes(String[] eventTypes) {
        this.eventTypes = eventTypes;
    }

    public String getEventTypeXl() {
        return eventTypeXl;
    }

    public void setEventTypeXl(String eventTypeXl) {
        this.eventTypeXl = eventTypeXl;
    }

    public List<String> getEventTypeXls() {
        return eventTypeXls;
    }

    public void setEventTypeXls(List<String> eventTypeXls) {
        this.eventTypeXls = eventTypeXls;
    }

    public List<String> getDefaultTypeXl() {
        return defaultTypeXl;
    }

    public void setDefaultTypeXl(List<String> defaultTypeXl) {
        this.defaultTypeXl = defaultTypeXl;
    }

    public String getEventTypeXlName() {
        return eventTypeXlName;
    }

    public void setEventTypeXlName(String eventTypeXlName) {
        this.eventTypeXlName = eventTypeXlName;
    }

    public String getReportSource() {
        return reportSource;
    }

    public void setReportSource(String reportSource) {
        this.reportSource = reportSource;
    }

    public String getLongitude() {
        return longitude;
    }

    public void setLongitude(String longitude) {
        this.longitude = longitude;
    }

    public String getLatitude() {
        return latitude;
    }

    public void setLatitude(String latitude) {
        this.latitude = latitude;
    }

    public String getReportor() {
        return reportor;
    }

    public void setReportor(String reportor) {
        this.reportor = reportor;
    }

    public Date getReportTime() {
        return reportTime;
    }

    public void setReportTime(Date reportTime) {
        this.reportTime = reportTime;
    }

    public String[] getReportTimeRange() {
        return reportTimeRange;
    }

    public void setReportTimeRange(String[] reportTimeRange) {
        this.reportTimeRange = reportTimeRange;
    }

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public String getEventStatus() {
        return eventStatus;
    }

    public void setEventStatus(String eventStatus) {
        this.eventStatus = eventStatus;
    }

    public String getEventStatusValue() {
        return eventStatusValue;
    }

    public void setEventStatusValue(String eventStatusValue) {
        this.eventStatusValue = eventStatusValue;
    }

    public String getIsUrged() {
        return isUrged;
    }

    public void setIsUrged(String isUrged) {
        this.isUrged = isUrged;
    }

    public Integer getUrgeCount() {
        return urgeCount;
    }

    public void setUrgeCount(Integer urgeCount) {
        this.urgeCount = urgeCount;
    }

    public String getFireRadius() {
        return fireRadius;
    }

    public void setFireRadius(String fireRadius) {
        this.fireRadius = fireRadius;
    }

    public String getReserve() {
        return reserve;
    }

    public void setReserve(String reserve) {
        this.reserve = reserve;
    }

    public String getDataStatus() {
        return dataStatus;
    }

    public void setDataStatus(String dataStatus) {
        this.dataStatus = dataStatus;
    }

    public Long getDeptId() {
        return deptId;
    }

    public void setDeptId(Long deptId) {
        this.deptId = deptId;
    }

    public String getDeptName() {
        return deptName;
    }

    public void setDeptName(String deptName) {
        this.deptName = deptName;
    }

    public String getStatusFlag() {
        return statusFlag;
    }

    public String getEscalation() {
        return escalation;
    }

    public void setEscalation(String escalation) {
        this.escalation = escalation;
    }

    public String getIsExamine() {
        return isExamine;
    }

    public void setIsExamine(String isExamine) {
        this.isExamine = isExamine;
    }

    public String getIsPush() {
        return isPush;
    }

    public void setIsPush(String isPush) {
        this.isPush = isPush;
    }

    public void setStatusFlag(String statusFlag) {
        this.statusFlag = statusFlag;
    }

    public Date getGdTime() {
        return gdTime;
    }

    public void setGdTime(Date gdTime) {
        this.gdTime = gdTime;
    }

    public List<CenterdataTAttach> getAttach() {
        return attach;
    }

    public void setAttach(List<CenterdataTAttach> attach) {
        this.attach = attach;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this, ToStringStyle.MULTI_LINE_STYLE)
                .append("id", getId())
                .append("eventCode", getEventCode())
                .append("eventName", getEventName())
                .append("eventDescription", getEventDescription())
                .append("eventType", getEventType())
                .append("reportSource", getReportSource())
                .append("longitude", getLongitude())
                .append("latitude", getLatitude())
                .append("reportor", getReportor())
                .append("reportTime", getReportTime())
                .append("eventStatus", getEventStatus())
                .append("eventStatusValue", getEventStatusValue())
                .append("isUrged", getIsUrged())
                .append("deptId", getDeptId())
                .append("deptName", getDeptName())
                .append("dataStatus", getDataStatus())
                .append("createBy", getCreateBy())
                .append("createName", getCreateName())
                .append("createTime", getCreateTime())
                .append("updateBy", getUpdateBy())
                .append("updateName", getUpdateName())
                .append("updateTime", getUpdateTime())
                .toString();
    }
}
