package com.sooka.sponest.event.centereventteventcatalogue.domain.dahua;

import com.ruoyi.common.core.utils.StringUtils;
import com.sooka.sponest.monitor.api.domain.CenterdataTCamera;
import lombok.Data;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import java.text.DecimalFormat;
import java.util.List;

@Data
public class InfoVO {

    private FirePointVO[] firePoint;

    private PtzPositionVO ptzPosition;

    private Long resourceId;

    private String orgName;

    /**
     * 该设备关联的其他通道的唯一标识码
     */
    private List<String> otherChannelSns;

    private String nodeCode;

    private String distance;

    private String alarmTypeName;

    private String alarmPictures;

    private String alarmDateStr;

    private String resourceName;

    private String deviceCode;

    private String alarmCode;

    private String alarmPicture;

    private Long nodeType;

    private Long alarmDate;

    private String deviceName;

    private String picture;

    private Long alarmGrade;

    private Long alarmType;

    private String orgCode;

    private String alarmPosition;

    private String angle;

    private String channelName;

    /**
     * 通道唯一标示码
     */
    private String channelSn;

    private String elevation;


    public String toString(CenterdataTCamera centerdataTCamera) {
        String toString = new ToStringBuilder(this, ToStringStyle.NO_CLASS_NAME_STYLE)
                .append("行政区：", getAlarmPosition())
                .append("瞭望塔：", getChannelName())
                .append("方向：", getDirection(getAngle()))
                .append("距离：", getStr(getDistance()))
                .append("高程：", getStr(getElevation()))
                .append("经度：", StringUtils.isEmpty(getFirePoint()) ? centerdataTCamera.getLongitude() : getFirePoint()[0].getGpsX())
                .append("纬度：", StringUtils.isEmpty(getFirePoint()) ? centerdataTCamera.getLatitude() : getFirePoint()[0].getGpsY())
                .toString().replaceAll("=", "");
        return toString.substring(1, toString.length() - 1);
    }

    public String getStr(String str) {
        if (StringUtils.isBlank(str)) {
            return "";
        }
        return str;
    }

    public String getDirection(String str) {
        if (StringUtils.isBlank(str)) {
            return "";
        }
        double angleStr = Double.parseDouble(str);//转成double进行比较
        DecimalFormat df = new DecimalFormat(".00");
        String newangle = df.format(angleStr);//保留两位小数 转成字符串进行拼接
        String outAngle = "";
        if (67d <= angleStr && angleStr <= 111d) {
            outAngle = "东" + newangle + "°";
        } else if (158d <= angleStr && angleStr <= 202d) {
            outAngle = "南" + newangle + "°";
        } else if (247d <= angleStr && angleStr <= 288d) {
            outAngle = "西" + newangle + "°";
        } else if ((338d <= angleStr && angleStr <= 359d) || (0d <= angleStr && angleStr <= 21d)) {
            outAngle = "北" + newangle + "°";
        } else if (203d <= angleStr && angleStr <= 246d) {
            outAngle = "西南" + newangle + "°";
        } else if (22d <= angleStr && angleStr <= 66d) {
            outAngle = "东北" + newangle + "°";
        } else if (292d <= angleStr && angleStr <= 337d) {
            outAngle = "西北" + newangle + "°";
        } else if (112d <= angleStr && angleStr <= 157d) {
            outAngle = "东南" + newangle + "°";
        }
        return outAngle;
    }
}
