package com.sooka.sponest.event.centereventteventcatalogue.domain.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.*;
import org.apache.ibatis.type.Alias;

import java.util.Date;

@Setter
@Getter
@NoArgsConstructor
@AllArgsConstructor
@ToString
@Alias("droneVo")
public class DroneVO {

    /**
     * 数据id
     */
    private String id;
    /**
     * 上报无人机id
     */
    private String copterId;
    /**
     * 时间戳
     */
    private Long timeStamp;
    /**
     * 海拔高度
     */
    private Double altitude;
    /**
     * 隐患类型
     */
    private String alarmType;
    /**
     * 隐患时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date creationTime;
    /**
     * 隐患图片地址
     */
    private String photoPath;
    /**
     * 隐患纬度
     */
    private String latitude;
    /**
     * 隐患经度
     */
    private String longitude;
    /**
     * 隐患图片id
     */
    private Integer photoId;
    /**
     * 图片名称
     */
    private String photoName;
    /**
     * 本地图片路径
     */
    private String localPath;

}
