package com.sooka.sponest.event.centereventteventcatalogue.mapper;

import com.sooka.sponest.event.centereventteventcatalogue.domain.CentereventTEventcatalogue;
import com.sooka.sponest.event.urge.domain.EventReminder;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 事件目录Mapper接口
 *
 * @author ruoyi
 * @date 2022-08-27
 */
public interface CentereventTEventcatalogueMapper {

    List<CentereventTEventcatalogue> selectCentereventTEventcatalogueListByPc(CentereventTEventcatalogue centereventTEventcatalogue);

    /**
     * 查询事件目录
     *
     * @param id 事件目录主键
     * @return 事件目录
     */
    CentereventTEventcatalogue selectCentereventTEventcatalogueById(String id);

    CentereventTEventcatalogue selectCentereventTEventcatalogueByEventCode(String eventCode);

    CentereventTEventcatalogue selectCentereventTEventcatalogueByCode(CentereventTEventcatalogue centereventTEventcatalogue);

    /**
     * 新增事件目录
     *
     * @param centereventTEventcatalogue 事件目录
     * @return 结果
     */
    int insertCentereventTEventcatalogue(CentereventTEventcatalogue centereventTEventcatalogue);

    /**
     * 修改事件目录
     *
     * @param centereventTEventcatalogue 事件目录
     * @return 结果
     */
    int updateCentereventTEventcatalogue(CentereventTEventcatalogue centereventTEventcatalogue);

    /**
     * 删除事件目录
     *
     * @param eventCode
     * @return
     */
    int deleteCentereventTEventcatalogueByCode(String eventCode);

    /**
     * 查询事件催办时间
     *
     * @param isUrged
     * @param eventStatusValue
     * @return
     */
    List<EventReminder> getReminderTime(@Param("isUrged") String isUrged, @Param("eventStatusValue") String eventStatusValue);

    CentereventTEventcatalogue mqtest(@Param("start") String start, @Param("end") String end, @Param("limit") int limit);
}
