package com.sooka.sponest.event.centereventteventcatalogue.service;

import com.sooka.sponest.event.centereventteventcatalogue.domain.bo.VisuForestCloudExposureStageBO;
import com.sooka.sponest.event.centereventteventcatalogue.domain.bo.VisuForestCloudMapEventListBO;
import com.sooka.sponest.event.centereventteventcatalogue.domain.bo.VisuForestCloudTodayEventsBO;
import com.sooka.sponest.event.centereventteventcatalogue.domain.bo.VisuForestEventTodayEventListBO;
import com.sooka.sponest.event.centereventteventcatalogue.domain.vo.VisuForestCloudMapVO;

import java.util.List;
import java.util.Map;

/**
 * 事件中心-可视化Service接口
 *
 * @author lyq
 * @date 2022-10-26
 */
public interface ICenterEventViewService {

    VisuForestCloudTodayEventsBO selectTodayEvents(VisuForestCloudMapVO visuForestCloudMapVO);

    List<Map<String, Object>> selectDeptEventCount(VisuForestCloudMapVO visuForestCloudMapVO);

    List<VisuForestCloudMapEventListBO> selectEventList(VisuForestCloudMapVO visuForestCloudMapVO);

    Map<String, Object> getEventDetail(VisuForestCloudMapVO visuForestCloudMapVO);

    List<Map<String, Object>> selectEventByCalendar(VisuForestCloudMapVO visuForestCloudMapVO);

    List<VisuForestCloudExposureStageBO> selectExposureStage(VisuForestCloudMapVO visuForestCloudMapVO);

    List<Map<String, Object>> getEventByEventType(VisuForestCloudMapVO visuForestCloudMapVO);

    List<Map<String, Object>> getEventByReportorOrder(VisuForestCloudMapVO visuForestCloudMapVO);

    List<VisuForestEventTodayEventListBO> getNearEvent(VisuForestCloudMapVO visuForestCloudMapVO);

    VisuForestEventTodayEventListBO eventPush(VisuForestCloudMapVO visuForestCloudMapVO);

    List<VisuForestCloudMapEventListBO> listAll(VisuForestCloudMapVO visuForestCloudMapVO);

    Map<String, Object> getHousingConstructionEventCount(VisuForestCloudMapVO visuForestCloudMapVO);

    List<VisuForestCloudMapEventListBO> getHousingConstructionEventList(VisuForestCloudMapVO visuForestCloudMapVO);
}
