package com.sooka.sponest.event.centereventteventcatalogue.service;

import com.sooka.sponest.event.centereventteventcatalogue.domain.CentereventTEventcatalogue;
import com.sooka.sponest.event.centereventteventcatalogue.domain.bo.CentereventtDeptEventBO;
import com.sooka.sponest.event.urge.domain.EventReminder;
import com.sooka.sponest.monitor.api.domain.CenterdataTAidevicedept;

import java.util.List;

/**
 * 事件目录Service接口
 *
 * @author ruoyi
 * @date 2022-08-27
 */
public interface ICentereventTEventcatalogueService {

    /**
     * 查询事件目录列表
     *
     * @param centereventTEventcatalogue 事件目录
     * @return 事件目录集合
     */
    List<CentereventTEventcatalogue> listByPc(CentereventTEventcatalogue centereventTEventcatalogue);

    /**
     * 查询事件目录
     *
     * @param id 事件目录主键
     * @return 事件目录
     */
    CentereventTEventcatalogue selectCentereventTEventcatalogueById(String id);

    CentereventTEventcatalogue selectCentereventTEventcatalogueByEventCode(String eventCode);

    CentereventTEventcatalogue selectCentereventTEventcatalogueByEventCode(CentereventTEventcatalogue centereventTEventcatalogue);

    /**
     * 新增事件目录
     *
     * @param centereventTEventcatalogue 事件目录
     * @return 结果
     */
    int insertCentereventTEventcatalogue(CentereventTEventcatalogue centereventTEventcatalogue);

    /**
     * 新增事件目录
     *
     * @param centereventTEventcatalogue 事件目录
     * @return 结果
     */
    int addCentereventTEventcatalogue(CentereventTEventcatalogue centereventTEventcatalogue);

    /**
     * 修改事件目录
     *
     * @param centereventTEventcatalogue 事件目录
     * @return 结果
     */
    int updateCentereventTEventcatalogue(CentereventTEventcatalogue centereventTEventcatalogue);

    CentereventTEventcatalogue editEventStatus(CentereventTEventcatalogue centereventTEventcatalogue, CentereventtDeptEventBO centereventtDeptEventBO, List<CenterdataTAidevicedept> listDept);

    /**
     * 删除事件目录信息
     *
     * @param eventCode
     * @return
     */
    int deleteCentereventTEventcatalogueByCode(String eventCode);

    /**
     * 查询事件催办时间
     *
     * @param isUrged
     * @param eventStatusValue
     * @return
     */
    List<EventReminder> getReminderTime(String isUrged, String eventStatusValue);

    void reportFirePreventionOffice(CentereventtDeptEventBO centereventtDeptEventBO);

    CentereventTEventcatalogue mqtest(String start, String end, int limit);
}
