package com.sooka.sponest.event.centereventteventcatalogue.service.impl;

import com.ruoyi.common.core.utils.SpringUtils;
import com.ruoyi.common.core.utils.StringUtils;
import com.ruoyi.common.datascope.annotation.DataScopeMutiDept;
import com.ruoyi.common.datascope.base.service.BaseService;
import com.ruoyi.common.security.utils.SecurityUtils;
import com.ruoyi.system.api.RemoteConfigService;
import com.ruoyi.system.api.RemoteDeptService;
import com.ruoyi.system.api.domain.SysDept;
import com.sooka.sponest.event.centereventtdeptevent.domain.CentereventDeptEvent;
import com.sooka.sponest.event.centereventtdeptevent.service.ICentereventDeptEventService;
import com.sooka.sponest.event.centereventteventcatalogue.domain.bo.AppEventSalBO;
import com.sooka.sponest.event.centereventteventcatalogue.domain.vo.AppEventSalVO;
import com.sooka.sponest.event.centereventteventcatalogue.domain.vo.VisuForestCloudMapVO;
import com.sooka.sponest.event.centereventteventcatalogue.mapper.CenterEventAppMapper;
import com.sooka.sponest.event.centereventteventcatalogue.service.ICenterEventAppService;
import com.sooka.sponest.event.centereventtfireevent.service.ICentereventTFireEventService;
import com.sooka.sponest.event.centereventtfirelog.domain.CentereventTFireLog;
import com.sooka.sponest.event.centereventtfirelog.service.ICentereventTFireLogService;
import com.sooka.sponest.event.remoteapi.RemoteDataService;
import com.sooka.sponest.event.remoteapi.domain.CenterdataTAttach;
import com.sooka.sponest.monitor.api.RemoteMonitorService;
import org.apache.commons.collections4.MapUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import static com.sooka.sponest.event.utils.EventConstants.FILE_DOWNLOAD;
import static com.sooka.sponest.event.utils.EventConstants.FILE_PREFIX_LOCAL;

/**
 * 事件中心-移动端Service业务层处理
 *
 * @author lyq
 * @date 2022-11-05
 */
@Service
public class CenterEventAppServiceImpl extends BaseService implements ICenterEventAppService {

    @Autowired
    private CenterEventAppMapper centerEventAppMapper;

    @Autowired
    private ICentereventTFireEventService centereventTFireEventService;

    @Autowired
    private ICentereventTFireLogService centereventTFireLogService;

    @Autowired
    private ICentereventDeptEventService centereventDeptEventService;

    @Autowired
    private RemoteDataService remoteDataService;

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public List<AppEventSalBO> listByApp(AppEventSalVO appEventSalVO) {
        setSookaDataBase(appEventSalVO);
        long size = appEventSalVO.getPageSize();
        long start = (appEventSalVO.getPageNum() - 1) * size;
        appEventSalVO.setPageNum(start);
        return centerEventAppMapper.listByApp(appEventSalVO);
    }

    @Override
    public AppEventSalBO selectCentereventTEventcatalogueByEventCode(AppEventSalBO appEventSalBO) {
        setSookaDataBase(appEventSalBO);
        AppEventSalBO bo = centerEventAppMapper.selectCentereventTEventcatalogueByEventCode(appEventSalBO);
        List<Long> deptIds = centereventDeptEventService.selectByEventCode(appEventSalBO.getEventCode()).stream().map(CentereventDeptEvent::getDeptId).collect(Collectors.toList());
        if (deptIds.contains(bo.getDeptId())) {
            bo.setStatusFlag("1");// 可视化是否显示办结按钮
        }
        // 森林防火、秸秆禁烧，添加防火办标识
        if ("101".equals(bo.getEventTypeValue()) || "102".equals(bo.getEventTypeValue())) {
            SysDept sysDept = new SysDept();
            sysDept.setDeptId(SecurityUtils.getLoginUser().getSysUser().getDeptId());
            sysDept.setDeptTypes(new String[]{"sys_dept_type_20"});// 区县防火办
            List<SysDept> sysDepts = SpringUtils.getBean(RemoteDeptService.class).selectDeptAndUsersByDeptType(sysDept).getData();
            deptIds = sysDepts.stream().map(SysDept::getDeptId).collect(Collectors.toList());
            if (deptIds.contains(SecurityUtils.getLoginUser().getSysUser().getDeptId())) {
                bo.setDisableFlag("1");// 是
            }
        }
        bo.setUrl("");
        CentereventTFireLog centereventTFireLog = centereventTFireLogService.selectFirstCentereventTFireLogByEventCode(bo.getEventCode());
        List<CenterdataTAttach> centerdataTAttaches = remoteDataService.urlAttch(centereventTFireLog.getId()).getData();
        bo.setAttachs(centerdataTAttaches);
        List<CenterdataTAttach> centerdataTAttaches1 = remoteDataService.urlAttchMpF(centereventTFireLog.getId()).getData();
        bo.setAttachsMpf(centerdataTAttaches1);

        VisuForestCloudMapVO sal = new VisuForestCloudMapVO();
        sal.setEventCode(appEventSalBO.getEventCode());
        Map<String, Object> asl = centereventTFireEventService.getYuAnByEventCode(sal);
        if (StringUtils.isNotNull(asl) && StringUtils.isNotBlank(MapUtils.getString(asl, FILE_PREFIX_LOCAL))) {
            StringBuilder newDiles = new StringBuilder();
            String url = MapUtils.getString(asl, FILE_PREFIX_LOCAL);
            String name = MapUtils.getString(asl, "fileName");
            String prefix = SpringUtils.getBean(RemoteConfigService.class).remotegetConfigKey(FILE_DOWNLOAD).getData();
            newDiles.append(prefix + "Download?fileName=" + name + "&&group=" + url.substring(0, url.indexOf('/')) + "&&path=" + url.substring(url.indexOf('/') + 1));
            asl.put(FILE_PREFIX_LOCAL, newDiles);
            bo.setAppAttachSal(asl);
        }
        if (bo.getReportSource().equals("AI")) {
            // 确认时，前端需传参摄像头编号
            bo.setCenterdataTCamera(SpringUtils.getBean(RemoteMonitorService.class).selectByCameraId(bo.getCreateBy()).getData());
        }
        return bo;
    }

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public List<Map<String, Object>> getEventCountGroupByEventStatus(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        return centerEventAppMapper.getEventCountGroupByEventStatus(visuForestCloudMapVO);
    }

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public List<Map<String, Object>> getEventCountGroupByEventType(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        List<Map<String, Object>> resultList = centerEventAppMapper.getEventCountGroupByEventType(visuForestCloudMapVO);
        // 提取有效数据pid
        List<String> pIds = resultList.stream().filter(item -> MapUtils.getLong(item, "num") > 0L)
                .map(item -> MapUtils.getString(item, "parent_id")).collect(Collectors.toList());
        resultList = resultList.stream().filter(item -> MapUtils.getLong(item, "num") > 0L || pIds.contains(MapUtils.getString(item, "id"))).collect(Collectors.toList());
        return queryEventSonBySelect(resultList, "0");
    }

    public List<Map<String, Object>> queryEventSonBySelect(List<Map<String, Object>> list, String id) {
        List<Map<String, Object>> bo = new ArrayList<>();
        for (Map<String, Object> map : list) {
            if (id.equals(MapUtils.getString(map, "parent_id"))) {
                map.put("children", queryEventSonBySelect(list, MapUtils.getString(map, "id")));
                bo.add(map);
            }
        }
        return bo;
    }
}
