package com.sooka.sponest.event.centereventteventcatalogue.service.impl;

import com.ruoyi.common.datascope.annotation.DataScopeMutiDept;
import com.ruoyi.common.datascope.base.service.BaseService;
import com.sooka.sponest.event.centereventteventcatalogue.domain.bo.VisuForestCloudMapEventListBO;
import com.sooka.sponest.event.centereventteventcatalogue.domain.vo.VisuForestCloudMapVO;
import com.sooka.sponest.event.centereventteventcatalogue.mapper.CenterEventReportMapper;
import com.sooka.sponest.event.centereventteventcatalogue.service.ICenterEventReportService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Iterator;
import java.util.List;
import java.util.Map;

/**
 * 事件中心-大数据Service业务层处理
 *
 * @author lyq
 * @date 2022-10-26
 */
@Service
public class CenterEventReportServiceImpl extends BaseService implements ICenterEventReportService {

    @Autowired
    private CenterEventReportMapper centerEventReportMapper;

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public int getEventTotal(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        return centerEventReportMapper.getEventTotal(visuForestCloudMapVO);
    }

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public List<Map<String, Object>> getEventCountGroupByReportSource(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        return centerEventReportMapper.getEventCountGroupByReportSource(visuForestCloudMapVO);
    }

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public List<Map<String, Object>> getEventCountGroupByEventTypeXl(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        return centerEventReportMapper.getEventCountGroupByEventTypeXl(visuForestCloudMapVO);
    }

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public List<Map<String, Object>> getEventTypeRadar(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        return centerEventReportMapper.getEventTypeRadar(visuForestCloudMapVO);
    }

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public List<Map<String, Object>> getEventCountGroupByFireSource(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        return centerEventReportMapper.getEventCountGroupByFireSource(visuForestCloudMapVO);
    }

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public List<Map<String, Object>> getEventCountGroupByFireRisk(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        return centerEventReportMapper.getEventCountGroupByFireRisk(visuForestCloudMapVO);
    }

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public List<Map<String, Object>> getEventCountGroupByFireInsurance(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        return centerEventReportMapper.getEventCountGroupByFireInsurance(visuForestCloudMapVO);
    }

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public List<Map<String, Object>> getEventCountGroupByFireType(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        return centerEventReportMapper.getEventCountGroupByFireType(visuForestCloudMapVO);
    }

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public List<Map<String, Object>> getEventInfoList(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        List<Map<String, Object>> result = centerEventReportMapper.getEventInfoList(visuForestCloudMapVO);
        Iterator<Map<String, Object>> iterator = result.iterator();
        while (iterator.hasNext()) {
            if (null == iterator.next()) {
                iterator.remove();
            }
        }
        return result;
    }

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public List<Map<String, Object>> getAIEventCountGroupByReportor(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        return centerEventReportMapper.getAIEventCountGroupByReportor(visuForestCloudMapVO);
    }

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public List<Map<String, Object>> getEventCountGroupByYearMonth(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        return centerEventReportMapper.getEventCountGroupByYearMonth(visuForestCloudMapVO);
    }

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public List<Map<String, Object>> getEventTypeCountGroupByYearMonth(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        return centerEventReportMapper.getEventTypeCountGroupByYearMonth(visuForestCloudMapVO);
    }

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public List<Map<String, Object>> getEventCountGroupByEventDept(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        return centerEventReportMapper.getEventCountGroupByEventDept(visuForestCloudMapVO);
    }

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public List<Map<String, Object>> getEventDeptCountGroupByYearMonth(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        return centerEventReportMapper.getEventDeptCountGroupByYearMonth(visuForestCloudMapVO);
    }

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public List<Map<String, Object>> getEventLatLng(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        return centerEventReportMapper.getEventLatLng(visuForestCloudMapVO);
    }

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public List<Map<String, Object>> getEventCountGroupByEventStatus(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        return centerEventReportMapper.getEventCountGroupByEventStatus(visuForestCloudMapVO);
    }

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public int getEventGjnumsMap(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        return centerEventReportMapper.getEventGjnumsMap(visuForestCloudMapVO);
    }

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public List<VisuForestCloudMapEventListBO> selectEventList(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        return centerEventReportMapper.selectEventList(visuForestCloudMapVO);
    }
}
