package com.sooka.sponest.event.centereventteventcatalogue.service.impl;

import com.ruoyi.common.core.utils.SpringUtils;
import com.ruoyi.common.core.utils.StringUtils;
import com.ruoyi.common.core.utils.file.FilePrefixUtils;
import com.ruoyi.common.datascope.annotation.DataScopeMutiDept;
import com.ruoyi.common.datascope.base.service.BaseService;
import com.ruoyi.system.api.RemoteConfigService;
import com.sooka.sponest.event.centereventteventcatalogue.domain.CentereventTEventcatalogue;
import com.sooka.sponest.event.centereventteventcatalogue.domain.bo.VisuForestCloudExposureStageBO;
import com.sooka.sponest.event.centereventteventcatalogue.domain.bo.VisuForestCloudMapEventListBO;
import com.sooka.sponest.event.centereventteventcatalogue.domain.bo.VisuForestCloudTodayEventsBO;
import com.sooka.sponest.event.centereventteventcatalogue.domain.bo.VisuForestEventTodayEventListBO;
import com.sooka.sponest.event.centereventteventcatalogue.domain.vo.VisuForestCloudMapVO;
import com.sooka.sponest.event.centereventteventcatalogue.mapper.CenterEventViewMapper;
import com.sooka.sponest.event.centereventteventcatalogue.service.ICenterEventViewService;
import com.sooka.sponest.event.centereventteventcatalogue.service.ICentereventTEventcatalogueService;
import com.sooka.sponest.event.centereventtfireevent.domain.CentereventTFireEvent;
import com.sooka.sponest.event.centereventtfireevent.service.ICentereventTFireEventService;
import com.sooka.sponest.event.centereventtfirelog.domain.CentereventTFireLog;
import com.sooka.sponest.event.centereventtfirelog.domain.FileVO;
import com.sooka.sponest.event.centereventtfirelog.service.ICentereventTFireLogService;
import com.sooka.sponest.event.remoteapi.RemoteDataService;
import com.sooka.sponest.event.remoteapi.domain.CenterdataTAttach;
import com.sooka.sponest.event.utils.RemoteApiUtil;
import com.sooka.sponest.monitor.api.RemoteMonitorService;
import com.sooka.sponest.monitor.api.domain.CenterdataTCamera;
import org.apache.commons.collections4.MapUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.*;
import java.util.stream.Collectors;

import static com.sooka.sponest.event.utils.EventConstants.*;

/**
 * 事件中心-可视化Service业务层处理
 *
 * @author lyq
 * @date 2022-10-26
 */
@Service
public class CenterEventViewServiceImpl extends BaseService implements ICenterEventViewService {

    @Autowired
    private CenterEventViewMapper centerEventViewMapper;

    @Autowired
    private RemoteDataService remoteDataService;

    @Autowired
    private ICentereventTEventcatalogueService centereventTEventcatalogueService;

    @Autowired
    private ICentereventTFireEventService centereventTFireEventService;

    @Autowired
    private ICentereventTFireLogService centereventTFireLogService;

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public VisuForestCloudTodayEventsBO selectTodayEvents(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        List<VisuForestCloudTodayEventsBO> ls = centerEventViewMapper.selectTodayEvents(visuForestCloudMapVO);
        VisuForestCloudTodayEventsBO bo = null;
        if (StringUtils.isNotEmpty(ls)) {
            bo = ls.get(0);
            bo.setTotal(bo.getNewReport().add(bo.getReadySure().add(bo.getReadyFinish())));
            if (bo.getTotal().compareTo(new BigDecimal(0)) != 0) {
                bo.setNewReportPre(StringUtils.getPercent(bo.getTotal(), bo.getNewReport()));
                bo.setReadySurePre(StringUtils.getPercent(bo.getTotal(), bo.getReadySure()));
                bo.setReadyFinishPre(StringUtils.getPercent(bo.getTotal(), bo.getReadyFinish()));
            }
            BigDecimal to = bo.getAiTotal().add(bo.getOtherTotal());
            if (to.compareTo(new BigDecimal(0)) != 0) {
                bo.setAiTotalPre(StringUtils.getPercent(to, bo.getAiTotal()));
                bo.setOtherTotalPre(StringUtils.getPercent(to, bo.getOtherTotal()));
            }
            String t = bo.getTotal().toString();
            if (t.length() <= 6) {
                bo.setTotalStr(t);
                for (int i = 0; i < 6 - t.length(); i++) {
                    bo.setTotalStr("0" + bo.getTotalStr());
                }
            }
        }
        return bo;
    }

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public List<Map<String, Object>> selectDeptEventCount(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        return centerEventViewMapper.selectDeptEventCount(visuForestCloudMapVO);
    }

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public List<VisuForestCloudMapEventListBO> selectEventList(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        List<VisuForestCloudMapEventListBO> result = centerEventViewMapper.selectEventList(visuForestCloudMapVO);
        if (StringUtils.isEmpty(result)) {
            return result;
        }
        Map<String, String> keyMap = SpringUtils.getBean(RemoteConfigService.class).remotegetConfigMap(Arrays.asList(FILE_PREFIX_LOCAL, FILE_PREFIX_HIK1, FILE_PREFIX_HIK2, FILE_PREFIX_DH1, FILE_PREFIX_DH2)).getData();
        String token = RemoteApiUtil.getInstance().getToken();// 大华token
        List<String> eventCodes = result.stream().map(VisuForestCloudMapEventListBO::getEventCode).collect(Collectors.toList());
        visuForestCloudMapVO.setEventStatus(eventCodes);
        List<VisuForestCloudMapEventListBO> attachs = centerEventViewMapper.getEventFile(visuForestCloudMapVO);
        result.forEach(event -> {
            for (VisuForestCloudMapEventListBO attach : attachs) {
                if (event.getEventCode().equals(attach.getEventCode())) {
                    if ("DH_1".equals(attach.getPictureSource())) {
                        event.setPicturePath(FilePrefixUtils.getUrlPrefix(attach.getPictureSource(), keyMap) + attach.getPicturePath() + "?token=" + token);
                    } else {
                        event.setPicturePath(FilePrefixUtils.getUrlPrefix(attach.getPictureSource(), keyMap) + attach.getPicturePath());
                    }
                    event.setPictureSource(attach.getReportSource());
                    event.setPictureType(attach.getPictureType());
                }
            }
        });
        return result;
    }

    @Override
    public Map<String, Object> getEventDetail(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        // 查日志
        List<CentereventTFireLog> logs = centereventTFireLogService.selectCentereventTFireLogList(new CentereventTFireLog(visuForestCloudMapVO.getEventCode()));
        // 提取日志id
        List<String> logIds = logs.stream().map(CentereventTFireLog::getId).collect(Collectors.toList());
        // 查附件
        List<CenterdataTAttach> files = remoteDataService.remotelistNew(new CenterdataTAttach(logIds)).getData();
        // 附件前缀
        Map<String, String> keyMap = SpringUtils.getBean(RemoteConfigService.class).remotegetConfigMap(Arrays.asList(FILE_DOWNLOAD, FILE_PREFIX_LOCAL, FILE_PREFIX_HIK1, FILE_PREFIX_HIK2, FILE_PREFIX_HIK3, FILE_PREFIX_DH1, FILE_PREFIX_DH2)).getData();
        String token = RemoteApiUtil.getInstance().getToken();// 大华token
        // 拼接组合
        logs.forEach(log -> {
            List<FileVO> fileVOList = new ArrayList();
            files.forEach(file -> {
                if (log.getId().equals(file.getBusId())) {
                    FileVO fileVO = new FileVO();
                    if ("DH_1".equals(file.getBusSource())) {
                        fileVO.setFileUrl(FilePrefixUtils.getUrlPrefix(file.getBusSource(), keyMap) + file.getAttachPath() + "?token=" + token);
                    } else if ("image".equals(file.getFileType()) || "video".equals(file.getFileType())) {
                        fileVO.setFileUrl(FilePrefixUtils.getUrlPrefix(file.getBusSource(), keyMap) + file.getAttachPath());
                    } else {
                        StringBuilder newDiles = new StringBuilder();
                        String url = file.getAttachPath();
                        String name = file.getFileName();
                        newDiles.append(keyMap.get(FILE_DOWNLOAD) + "Download?fileName=" + name + "&&group=" + url.substring(0, url.indexOf('/')) + "&&path=" + url.substring(url.indexOf('/') + 1));
                        fileVO.setFileUrl(newDiles.toString());
                    }
                    fileVO.setFileName(file.getFileName());
                    fileVO.setFileType(file.getFileType());
                    fileVOList.add(fileVO);
                }
            });
            log.setFileVOs(fileVOList);
        });
        // 返回值
        Map<String, Object> resultMap = new HashMap();
        CentereventTEventcatalogue catalogue = centereventTEventcatalogueService.selectCentereventTEventcatalogueByEventCode(visuForestCloudMapVO.getEventCode());
        resultMap.put("catalogue", catalogue);
        resultMap.put("eventdetail", centereventTFireEventService.selectCentereventTFireEventList(new CentereventTFireEvent(visuForestCloudMapVO.getEventCode())));
        Map<String, Object> yuAnMap = centereventTFireEventService.getYuAnByEventCode(visuForestCloudMapVO);
        if (StringUtils.isNotNull(yuAnMap) && StringUtils.isNotBlank(MapUtils.getString(yuAnMap, FILE_PREFIX_LOCAL))) {
            StringBuilder newDiles = new StringBuilder();
            String url = MapUtils.getString(yuAnMap, "fileUrl");
            String name = MapUtils.getString(yuAnMap, "fileName");
            newDiles.append(keyMap.get(FILE_DOWNLOAD) + "Download?fileName=" + name + "&&group=" + url.substring(0, url.indexOf('/')) + "&&path=" + url.substring(url.indexOf('/') + 1));
            yuAnMap.put("fileUrl", newDiles);
        }
        resultMap.put("visuForestCloudYuAnBo", yuAnMap);
        resultMap.put("eventlog", logs);
        // 摄像头上报
        if (REPORTING_SOURCE_1.equals(catalogue.getReportSource())) {
            resultMap.put("centermonitorTCamera", SpringUtils.getBean(RemoteMonitorService.class).selectByCameraId(catalogue.getCreateBy()).getData());
        }
        // 传感器上报
        if (REPORTING_SOURCE_4.equals(catalogue.getReportSource())) {
            resultMap.put("centermonitorTCamera", new CenterdataTCamera(catalogue.getCreateBy(), catalogue.getCreateName()));
        }
        return resultMap;
    }

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public List<Map<String, Object>> selectEventByCalendar(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        return centerEventViewMapper.selectEventByCalendar(visuForestCloudMapVO);
    }

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public List<VisuForestCloudExposureStageBO> selectExposureStage(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        return centerEventViewMapper.selectExposureStage(visuForestCloudMapVO);
    }

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public List<Map<String, Object>> getEventByEventType(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        return centerEventViewMapper.getEventByEventType(visuForestCloudMapVO);
    }

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public List<Map<String, Object>> getEventByReportorOrder(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        return centerEventViewMapper.getEventByReportorOrder(visuForestCloudMapVO);
    }

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public List<VisuForestEventTodayEventListBO> getNearEvent(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        List<VisuForestEventTodayEventListBO> result = centerEventViewMapper.getNearEvent(visuForestCloudMapVO);
        if (StringUtils.isEmpty(result)) {
            return result;
        }
        // 附件前缀
        Map<String, String> keyMap = SpringUtils.getBean(RemoteConfigService.class).remotegetConfigMap(Arrays.asList(FILE_PREFIX_LOCAL, FILE_PREFIX_HIK1, FILE_PREFIX_HIK2, FILE_PREFIX_DH1, FILE_PREFIX_DH2)).getData();
        String token = RemoteApiUtil.getInstance().getToken();// 大华token
        List<String> eventCodes = result.stream().map(VisuForestEventTodayEventListBO::getEventCode).collect(Collectors.toList());
        visuForestCloudMapVO.setEventStatus(eventCodes);
        List<VisuForestCloudMapEventListBO> attachs = centerEventViewMapper.getEventFile(visuForestCloudMapVO);
        result.forEach(event -> {
            for (VisuForestCloudMapEventListBO attach : attachs) {
                if (event.getEventCode().equals(attach.getEventCode())) {
                    if ("DH_1".equals(attach.getPictureSource())) {
                        event.setPicturePath(FilePrefixUtils.getUrlPrefix(attach.getPictureSource(), keyMap) + attach.getPicturePath() + "?token=" + token);
                    } else {
                        event.setPicturePath(FilePrefixUtils.getUrlPrefix(attach.getPictureSource(), keyMap) + attach.getPicturePath());
                    }
                    event.setPictureSource(attach.getReportSource());
                    event.setPictureType(attach.getPictureType());
                }
            }
        });
        return result;
    }

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public VisuForestEventTodayEventListBO eventPush(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        VisuForestEventTodayEventListBO event = centerEventViewMapper.eventPush(visuForestCloudMapVO);
        if (StringUtils.isNull(event)) {
            return null;
        }
        // 附件前缀
        Map<String, String> keyMap = SpringUtils.getBean(RemoteConfigService.class).remotegetConfigMap(Arrays.asList(FILE_PREFIX_LOCAL, FILE_PREFIX_HIK1, FILE_PREFIX_HIK2, FILE_PREFIX_DH1, FILE_PREFIX_DH2)).getData();
        String token = RemoteApiUtil.getInstance().getToken();// 大华token
        visuForestCloudMapVO.setEventStatus(Arrays.asList(event.getEventCode()));
        List<VisuForestCloudMapEventListBO> attachs = centerEventViewMapper.getEventFile(visuForestCloudMapVO);
        attachs.forEach(attach -> {
            if ("DH_1".equals(attach.getPictureSource())) {
                event.setPicturePath(FilePrefixUtils.getUrlPrefix(attach.getPictureSource(), keyMap) + attach.getPicturePath() + "?token=" + token);
            } else {
                event.setPicturePath(FilePrefixUtils.getUrlPrefix(attach.getPictureSource(), keyMap) + attach.getPicturePath());
            }
            event.setPictureSource(attach.getReportSource());
            event.setPictureType(attach.getPictureType());
        });
        return event;
    }

    @Override
    public List<VisuForestCloudMapEventListBO> listAll(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        List<VisuForestCloudMapEventListBO> result = centerEventViewMapper.listAll(visuForestCloudMapVO);
        if (StringUtils.isEmpty(result)) {
            return result;
        }
        Map<String, String> keyMap = SpringUtils.getBean(RemoteConfigService.class).remotegetConfigMap(Arrays.asList(FILE_PREFIX_LOCAL, FILE_PREFIX_HIK1, FILE_PREFIX_HIK2, FILE_PREFIX_DH1, FILE_PREFIX_DH2)).getData();
        String token = RemoteApiUtil.getInstance().getToken();// 大华token
        List<String> eventCodes = result.stream().map(VisuForestCloudMapEventListBO::getEventCode).collect(Collectors.toList());
        visuForestCloudMapVO.setEventStatus(eventCodes);
        visuForestCloudMapVO.setTemplateType("true");
        List<VisuForestCloudMapEventListBO> attachs = centerEventViewMapper.getEventFile(visuForestCloudMapVO);
        result.forEach(event -> {
            for (VisuForestCloudMapEventListBO attach : attachs) {
                if (event.getEventCode().equals(attach.getEventCode())) {
                    if ("DH_1".equals(attach.getPictureSource())) {
                        event.getPicturePathList().add(FilePrefixUtils.getUrlPrefix(attach.getPictureSource(), keyMap) + attach.getPicturePath() + "?token=" + token);
                    } else {
                        event.getPicturePathList().add(FilePrefixUtils.getUrlPrefix(attach.getPictureSource(), keyMap) + attach.getPicturePath());
                    }
                }
            }
        });
        return result;
    }

    @Override
    public Map<String, Object> getHousingConstructionEventCount(VisuForestCloudMapVO visuForestCloudMapVO) {
        return centerEventViewMapper.getHousingConstructionEventCount(visuForestCloudMapVO);
    }

    @Override
    public List<VisuForestCloudMapEventListBO> getHousingConstructionEventList(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        List<VisuForestCloudMapEventListBO> result = centerEventViewMapper.getHousingConstructionEventList(visuForestCloudMapVO);
        if (StringUtils.isEmpty(result)) {
            return result;
        }
        Map<String, String> keyMap = SpringUtils.getBean(RemoteConfigService.class).remotegetConfigMap(Arrays.asList(FILE_PREFIX_LOCAL, FILE_PREFIX_HIK1, FILE_PREFIX_HIK2, FILE_PREFIX_DH1, FILE_PREFIX_DH2)).getData();
        String token = RemoteApiUtil.getInstance().getToken();// 大华token
        List<String> eventCodes = result.stream().map(VisuForestCloudMapEventListBO::getEventCode).collect(Collectors.toList());
        visuForestCloudMapVO.setEventStatus(eventCodes);
        List<VisuForestCloudMapEventListBO> attachs = centerEventViewMapper.getEventFile(visuForestCloudMapVO);
        result.forEach(event -> {
            for (VisuForestCloudMapEventListBO attach : attachs) {
                if (event.getEventCode().equals(attach.getEventCode())) {
                    if ("DH_1".equals(attach.getPictureSource())) {
                        event.setPicturePath(FilePrefixUtils.getUrlPrefix(attach.getPictureSource(), keyMap) + attach.getPicturePath() + "?token=" + token);
                    } else {
                        event.setPicturePath(FilePrefixUtils.getUrlPrefix(attach.getPictureSource(), keyMap) + attach.getPicturePath());
                    }
                }
            }
        });
        return result;
    }
}
