package com.sooka.sponest.event.centereventteventtype.service;

import com.sooka.sponest.event.centereventteventcatalogue.domain.CentereventTEventcatalogue;
import com.sooka.sponest.event.centereventteventtype.domain.CentereventTEventtype;

import java.util.List;
import java.util.Map;

/**
 * 事件类型Service接口
 *
 * @author ruoyi
 * @date 2022-08-27
 */
public interface ICentereventTEventtypeService {

    /**
     * 查询事件类型列表
     *
     * @param centereventTEventtype 事件类型
     * @return 事件类型集合
     */
    List<CentereventTEventtype> selectCentereventTEventtypeList(CentereventTEventtype centereventTEventtype);

    /**
     * 查询事件类型
     *
     * @param id 事件类型主键
     * @return 事件类型
     */
    CentereventTEventtype selectCentereventTEventtypeById(String id);

    /**
     * 查询事件类型
     *
     * @param code 事件类型主键
     * @return 事件类型
     */
    CentereventTEventtype selectCentereventTEventtypeByCode(String code);

    /**
     * 查询事件类型
     *
     * @param code 事件类型主键
     * @return 事件类型
     */
    CentereventTEventtype selectCentereventTEventtypeByCodeTower(String code);

    /**
     * 新增事件类型
     *
     * @param centereventTEventtype 事件类型
     * @return 结果
     */
    int insertCentereventTEventtype(CentereventTEventtype centereventTEventtype);

    /**
     * 修改事件类型
     *
     * @param centereventTEventtype 事件类型
     * @return 结果
     */
    int updateCentereventTEventtype(CentereventTEventtype centereventTEventtype);

    /**
     * 批量删除事件类型
     *
     * @param ids 需要删除的事件类型主键集合
     * @return 结果
     */
    int deleteCentereventTEventtypeByIds(String[] ids);

    /**
     * 查询事件类型树结构
     *
     * @author hanfucheng
     * @date 2023/4/10 10:53
     */
    List<Map<String, Object>> getCentereventTEventtypeTree();

    List<Map<String, Object>> getCentereventTEventtypeTreeLx(CentereventTEventtype centereventTEventtype);

    long getReminderTimeById(CentereventTEventcatalogue centereventTEventcatalogue);
}
