package com.sooka.sponest.event.centereventteventtypemapdept.controller;

import com.alibaba.fastjson.JSON;
import com.ruoyi.common.core.domain.R;
import com.ruoyi.common.core.utils.poi.ExcelUtil;
import com.ruoyi.common.core.web.controller.BaseController;
import com.ruoyi.common.core.web.domain.AjaxResult;
import com.ruoyi.common.core.web.page.TableDataInfo;
import com.ruoyi.common.log.annotation.Log;
import com.ruoyi.common.log.enums.BusinessType;
import com.ruoyi.common.security.annotation.RequiresPermissions;
import com.sooka.sponest.event.centereventteventtypemapdept.domain.CentereventTEventtypemapdept;
import com.sooka.sponest.event.centereventteventtypemapdept.service.ICentereventTEventtypemapdeptService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 事件类型对应行管局Controller
 *
 * @author 朱哲
 * @date 2022-08-29
 */
@Api(tags = "事件类型对应行管局")
@RestController
@RequestMapping("/eventtypemapdept")
public class CentereventTEventtypemapdeptController extends BaseController {

    @Autowired
    private ICentereventTEventtypemapdeptService centereventTEventtypemapdeptService;

    private static final Map<Long, String> deptTypeMap = new HashMap();

    static {
        deptTypeMap.put(367L, "sys_dept_type_16");// 市林业局
        deptTypeMap.put(3776L, "sys_dept_type_13");// 市农业农村局
        deptTypeMap.put(3778L, "sys_dept_type_15");// 市水利局
        deptTypeMap.put(3773L, "sys_dept_type_10");// 市生态环境局
        deptTypeMap.put(3774L, "sys_dept_type_11");// 市应急管理局
        deptTypeMap.put(3775L, "sys_dept_type_12");// 市交通运输局
        deptTypeMap.put(3772L, "sys_dept_type_9");// 市自然资源局
        deptTypeMap.put(3777L, "sys_dept_type_14");// 市消防救援支队
        deptTypeMap.put(14449L, "sys_dept_type_29");// 市公安局森林警察支队
    }

    /**
     * 查询事件类型对行管局列表
     */
    @RequiresPermissions("eventtypemapdept:eventtypemapdept:list")
    @GetMapping("/list")
    public TableDataInfo list(CentereventTEventtypemapdept centereventTEventtypemapdept) {
        startPage();
        List<CentereventTEventtypemapdept> list = centereventTEventtypemapdeptService.selectCentereventTEventtypemapdeptList(centereventTEventtypemapdept);
        return getDataTable(list);
    }

    /**
     * 查询事件类型对行管局列表
     */
    @ApiOperation("查询事件类型对应行管局列表")
    @GetMapping("/getCentereventTEventtypemapdeptByEventtype")
    public R getCentereventTEventtypemapdeptByEventtype(CentereventTEventtypemapdept centereventTEventtypemapdept) {
        return R.ok(centereventTEventtypemapdeptService.selectCentereventTEventtypemapdeptList(centereventTEventtypemapdept));
    }

    /**
     * 导出事件类型对行管局列表
     */
    @RequiresPermissions("eventtypemapdept:eventtypemapdept:export")
    @Log(title = "事件类型对行管局", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, CentereventTEventtypemapdept centereventTEventtypemapdept) {
        List<CentereventTEventtypemapdept> list = centereventTEventtypemapdeptService.selectCentereventTEventtypemapdeptList(centereventTEventtypemapdept);
        ExcelUtil<CentereventTEventtypemapdept> util = new ExcelUtil<>(CentereventTEventtypemapdept.class);
        util.exportExcel(response, list, "事件类型对行管局数据");
    }

    /**
     * 获取事件类型对行管局详细信息
     */
    @RequiresPermissions("eventtypemapdept:eventtypemapdept:query")
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") String id) {
        return AjaxResult.success(centereventTEventtypemapdeptService.selectCentereventTEventtypemapdeptById(id));
    }

    /**
     * 新增事件类型对行管局
     */
    @RequiresPermissions("eventtypemapdept:eventtypemapdept:add")
    @Log(title = "事件类型对行管局", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody CentereventTEventtypemapdept centereventTEventtypemapdept) {
        return toAjax(centereventTEventtypemapdeptService.insertCentereventTEventtypemapdept(centereventTEventtypemapdept));
    }

    //    @RequiresPermissions("eventtypemapdept:eventtypemapdept:add")
    @Log(title = "事件类型对行管局", businessType = BusinessType.INSERT)
    @PostMapping("/add")
    public AjaxResult add(@RequestBody String data) {
        List<CentereventTEventtypemapdept> centereventTEventtypemapdepts = JSON.parseArray(data, CentereventTEventtypemapdept.class);
        for (CentereventTEventtypemapdept typedept : centereventTEventtypemapdepts) {
            typedept.setDeptTypeDict(deptTypeMap.get(typedept.getDeptId()));
        }
        return toAjax(centereventTEventtypemapdeptService.insertCentereventTEventtypemapdepts(centereventTEventtypemapdepts));
    }

    /**
     * 修改事件类型对行管局
     */
    @RequiresPermissions("eventtypemapdept:eventtypemapdept:edit")
    @Log(title = "事件类型对行管局", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody CentereventTEventtypemapdept centereventTEventtypemapdept) {
        return toAjax(centereventTEventtypemapdeptService.updateCentereventTEventtypemapdept(centereventTEventtypemapdept));
    }

    /**
     * 删除事件类型对行管局
     */
    @RequiresPermissions("eventtypemapdept:eventtypemapdept:remove")
    @Log(title = "事件类型对行管局", businessType = BusinessType.DELETE)
    @DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable String[] ids) {
        return toAjax(centereventTEventtypemapdeptService.deleteCentereventTEventtypemapdeptByIds(ids));
    }
}
