package com.sooka.sponest.event.centereventteventtypemapdept.service.impl;

import com.ruoyi.common.core.utils.DateUtils;
import com.ruoyi.common.security.utils.SecurityUtils;
import com.ruoyi.system.api.domain.SysUser;
import com.sooka.sponest.event.centereventteventtypemapdept.domain.CentereventTEventtypemapdept;
import com.sooka.sponest.event.centereventteventtypemapdept.mapper.CentereventTEventtypemapdeptMapper;
import com.sooka.sponest.event.centereventteventtypemapdept.service.ICentereventTEventtypemapdeptService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.List;

/**
 * 事件类型对行管局Service业务层处理
 *
 * @author 朱哲
 * @date 2022-08-29
 */
@Service
public class CentereventTEventtypemapdeptServiceImpl implements ICentereventTEventtypemapdeptService {

    @Autowired
    private CentereventTEventtypemapdeptMapper centereventTEventtypemapdeptMapper;

    /**
     * 查询事件类型对行管局列表
     *
     * @param centereventTEventtypemapdept 事件类型对行管局
     * @return 事件类型对行管局
     */
    @Override
    public List<CentereventTEventtypemapdept> selectCentereventTEventtypemapdeptList(CentereventTEventtypemapdept centereventTEventtypemapdept) {
        return centereventTEventtypemapdeptMapper.selectCentereventTEventtypemapdeptList(centereventTEventtypemapdept);
    }

    /**
     * 查询事件类型对行管局
     *
     * @param id 事件类型对行管局主键
     * @return 事件类型对行管局
     */
    @Override
    public CentereventTEventtypemapdept selectCentereventTEventtypemapdeptById(String id) {
        return centereventTEventtypemapdeptMapper.selectCentereventTEventtypemapdeptById(id);
    }

    /**
     * 新增事件类型对行管局
     *
     * @param centereventTEventtypemapdept 事件类型对行管局
     * @return 结果
     */
    @Transactional
    @Override
    public int insertCentereventTEventtypemapdept(CentereventTEventtypemapdept centereventTEventtypemapdept) {
        centereventTEventtypemapdept.setCreateTime(DateUtils.getNowDate());
        return centereventTEventtypemapdeptMapper.insertCentereventTEventtypemapdept(centereventTEventtypemapdept);
    }

    @Transactional
    @Override
    public int insertCentereventTEventtypemapdepts(List<CentereventTEventtypemapdept> centereventTEventtypemapdepts) {
        centereventTEventtypemapdeptMapper.deleteCentereventTEventtypemapdeptByEventtypevalue(centereventTEventtypemapdepts.get(0).getEventTypeValue());
        SysUser sysUser = SecurityUtils.getLoginUser().getSysUser();
        Date date = DateUtils.getNowDate();
        for (CentereventTEventtypemapdept centereventTEventtypemapdept : centereventTEventtypemapdepts) {
            centereventTEventtypemapdept.setCreateBy(sysUser.getUserId().toString());
            centereventTEventtypemapdept.setCreateName(sysUser.getNickName());
            centereventTEventtypemapdept.setCreateTime(date);
            centereventTEventtypemapdeptMapper.insertCentereventTEventtypemapdept(centereventTEventtypemapdept);
        }
        return 1;
    }

    /**
     * 修改事件类型对行管局
     *
     * @param centereventTEventtypemapdept 事件类型对行管局
     * @return 结果
     */
    @Transactional
    @Override
    public int updateCentereventTEventtypemapdept(CentereventTEventtypemapdept centereventTEventtypemapdept) {
        return centereventTEventtypemapdeptMapper.updateCentereventTEventtypemapdept(centereventTEventtypemapdept);
    }

    /**
     * 批量删除事件类型对行管局
     *
     * @param ids 需要删除的事件类型对行管局主键
     * @return 结果
     */
    @Transactional
    @Override
    public int deleteCentereventTEventtypemapdeptByIds(String[] ids) {
        return centereventTEventtypemapdeptMapper.deleteCentereventTEventtypemapdeptByIds(ids);
    }
}
