package com.sooka.sponest.event.centereventteventtypemonitor.mapper;

import com.sooka.sponest.event.centereventteventcatalogue.domain.vo.VisuForestCloudMapVO;
import com.sooka.sponest.event.centereventteventtypemonitor.domain.CentereventTEventtypeMonitor;

import java.util.List;
import java.util.Map;

/**
 * @Auther: mjq
 * @Date: 2023/7/1 - 07 - 01 - 9:23
 * @Description: com.sooka.sponest.event.centereventteventtypemonitor.mapper
 * @version: 1.0
 */
public interface CentereventTEventtypeMonitorMapper {

    /**
     * 查询事件模版类型列表
     *
     * @param centereventTEventtypeMonitor 事件模版类型
     * @return 事件模版类型集合
     */
    List<CentereventTEventtypeMonitor> selectCentereventTEventtypeMonitorList(CentereventTEventtypeMonitor centereventTEventtypeMonitor);

    /**
     * 查询事件模版类型
     *
     * @param id 事件模版类型主键
     * @return 事件模版类型
     */
    CentereventTEventtypeMonitor selectCentereventTEventtypeMonitorById(Long id);

    /**
     * 新增事件模版类型
     *
     * @param centereventTEventtypeMonitor 事件模版类型
     * @return 结果
     */
    int insertCentereventTEventtypeMonitor(CentereventTEventtypeMonitor centereventTEventtypeMonitor);

    /**
     * 修改事件模版类型
     *
     * @param centereventTEventtypeMonitor 事件模版类型
     * @return 结果
     */
    int updateCentereventTEventtypeMonitor(CentereventTEventtypeMonitor centereventTEventtypeMonitor);

    int deleteCentereventTEventtypeMonitorByParentId(String parentId);

    List<Map<String, Object>> getCentereventTEventtypemonitorTree(String templateType);

    List<Map<String, Object>> getEventByEventType(VisuForestCloudMapVO visuForestCloudMapVO);
}
