package com.sooka.sponest.event.centereventteventtypemonitor.service.impl;

import com.ruoyi.common.datascope.annotation.DataScopeMutiDept;
import com.ruoyi.common.datascope.base.service.BaseService;
import com.sooka.sponest.event.centereventteventcatalogue.domain.vo.VisuForestCloudMapVO;
import com.sooka.sponest.event.centereventteventtype.domain.CentereventTEventtype;
import com.sooka.sponest.event.centereventteventtype.mapper.CentereventTEventtypeMapper;
import com.sooka.sponest.event.centereventteventtypemonitor.domain.CentereventTEventtypeMonitor;
import com.sooka.sponest.event.centereventteventtypemonitor.mapper.CentereventTEventtypeMonitorMapper;
import com.sooka.sponest.event.centereventteventtypemonitor.service.ICentereventTEventtypemonitorService;
import org.apache.commons.collections4.MapUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Auther: mjq
 * @Date: 2023/7/1 - 07 - 01 - 9:14
 * @Description: com.sooka.sponest.event.centereventteventtypemonitor.service.impl
 * @version: 1.0
 */
@Service
public class CentereventTEventtypemonitorServiceImpl extends BaseService implements ICentereventTEventtypemonitorService {

    @Autowired
    private CentereventTEventtypeMonitorMapper centereventTEventtypeMonitorMapper;

    @Autowired
    private CentereventTEventtypeMapper centereventTEventtypeMapper;

    static final String ID = "id";
    static final String PARENT_ID = "parent_id";
    static final String EVENT_TYPE_NAME = "event_type_name";

    /**
     * 查询事件模版类型列表
     *
     * @param centereventTEventtypeMonitor 事件模版类型
     * @return 事件模版类型
     */
    @Override
    public List<CentereventTEventtypeMonitor> selectCentereventTEventtypeMonitorList(CentereventTEventtypeMonitor centereventTEventtypeMonitor) {
        return centereventTEventtypeMonitorMapper.selectCentereventTEventtypeMonitorList(centereventTEventtypeMonitor);
    }

    /**
     * 查询事件模版类型
     *
     * @param id 事件模版类型主键
     * @return 事件模版类型
     */
    @Override
    public CentereventTEventtypeMonitor selectCentereventTEventtypeMonitorById(Long id) {
        return centereventTEventtypeMonitorMapper.selectCentereventTEventtypeMonitorById(id);
    }

    /**
     * 新增事件模版类型
     *
     * @param centereventTEventtypeMonitor 事件模版类型
     * @return 结果
     */
    @Override
    public int insertCentereventTEventtypeMonitor(CentereventTEventtypeMonitor centereventTEventtypeMonitor) {
        return centereventTEventtypeMonitorMapper.insertCentereventTEventtypeMonitor(centereventTEventtypeMonitor);
    }

    /**
     * 修改事件模版类型
     *
     * @param centereventTEventtypeMonitor 事件模版类型
     * @return 结果
     */
    @Override
    public int updateCentereventTEventtypeMonitor(CentereventTEventtypeMonitor centereventTEventtypeMonitor) {
        return centereventTEventtypeMonitorMapper.updateCentereventTEventtypeMonitor(centereventTEventtypeMonitor);
    }

    /**
     * 删除事件模版类型信息
     *
     * @param id 事件模版类型主键
     * @return 结果
     */
    @Override
    public int deleteCentereventTEventtypeMonitorById(Long id) {
        return centereventTEventtypeMonitorMapper.deleteCentereventTEventtypeMonitorByParentId(String.valueOf(id));
    }

    @Override
    public List<Map<String, Object>> getCentereventTEventtypemonitorTree(String templateType) {
        List<Map<String, Object>> bigList = new ArrayList<>();
        List<Map<String, Object>> mapList = centereventTEventtypeMonitorMapper.getCentereventTEventtypemonitorTree(templateType);
        for (Map<String, Object> map : mapList) {
            if ("0".equals(map.get(PARENT_ID))) {
                Map<String, Object> bigType = new HashMap<>();
                List<Map<String, Object>> smallList = new ArrayList<>();
                bigType.put("value", map.get(ID));
                bigType.put("label", map.get(EVENT_TYPE_NAME));
                for (Map<String, Object> map1 : mapList) {
                    if (map1.get(PARENT_ID).equals(map.get(ID).toString())) {
                        Map<String, Object> smallType = new HashMap<>();
                        smallType.put("value", map1.get(ID));
                        smallType.put("label", map1.get(EVENT_TYPE_NAME));
                        smallList.add(smallType);
                    }
                }
                bigType.put("children", smallList);
                bigType.put("count", smallList.size());
                bigList.add(bigType);
            }
        }
        return bigList;
    }

    @DataScopeMutiDept(deptAlias = "c")
    @Override
    public List<Map<String, Object>> getEventByEventType(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        List<Map<String, Object>> bigList = new ArrayList<>();
        List<Map<String, Object>> mapList = centereventTEventtypeMonitorMapper.getEventByEventType(visuForestCloudMapVO);
        for (Map<String, Object> map : mapList) {
            if (0 == MapUtils.getLong(map, PARENT_ID)) {
                Map<String, Object> bigType = new HashMap<>();
                List<Map<String, Object>> smallList = new ArrayList<>();
                bigType.put(ID, map.get(ID));
                bigType.put(EVENT_TYPE_NAME, map.get(EVENT_TYPE_NAME));
                Long sum = 0L;
                for (Map<String, Object> map1 : mapList) {
                    if (MapUtils.getString(map1, PARENT_ID).equals(MapUtils.getString(map, ID))) {
                        Map<String, Object> smallType = new HashMap<>();
                        smallType.put(ID, map1.get(ID));
                        smallType.put(PARENT_ID, map1.get(PARENT_ID));
                        smallType.put("nums", map1.get("nums"));
                        smallType.put(EVENT_TYPE_NAME, map1.get(EVENT_TYPE_NAME));
                        smallType.put("typeXlId", map1.get("typeXlId"));
                        smallType.put("typeDlId", map1.get("typeDlId"));
                        smallType.put("typeDlName", map1.get("typeDlName"));
                        smallList.add(smallType);
                        sum = sum + MapUtils.getLong(map1, "nums");
                    }
                }
                bigType.put("children", smallList);
                bigType.put("sum", sum);
                bigList.add(bigType);
            }
        }
        return bigList;
    }

    @Transactional
    @Override
    public int saveTypelx(List<CentereventTEventtypeMonitor> centereventTEventtypeMonitor) {
        int result = centereventTEventtypeMonitorMapper.deleteCentereventTEventtypeMonitorByParentId(String.valueOf(centereventTEventtypeMonitor.get(0).getParentId()));
        for (CentereventTEventtypeMonitor monitor : centereventTEventtypeMonitor) {
            if (!"1".equals(String.valueOf(monitor.getTypeXlId()))) {//火情事件
                CentereventTEventtype eventtype = centereventTEventtypeMapper.selectCentereventTEventtypeById(String.valueOf(monitor.getTypeXlId()));
                eventtype = centereventTEventtypeMapper.selectCentereventTEventtypeById(eventtype.getParentId());
                monitor.setTypeDlId(Long.parseLong(eventtype.getId()));
                monitor.setTypeDlName(eventtype.getEventTypeName());
            } else {
                monitor.setTypeDlId(0L);
                monitor.setTypeDlName("火情事件");
            }
            result = centereventTEventtypeMonitorMapper.insertCentereventTEventtypeMonitor(monitor);
        }
        return result;
    }
}
