package com.sooka.sponest.event.centereventtfireevent.domain;

import com.ruoyi.common.core.annotation.Excel;
import com.ruoyi.common.core.web.domain.BaseEntity;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

/**
 * 事件扩展（森林防火）对象 centerevent_t_fire_event
 *
 * @author 朱哲
 * @date 2022-08-29
 */
public class CentereventTFireEvent extends BaseEntity {

    public CentereventTFireEvent() {

    }

    public CentereventTFireEvent(String eventCode) {
        this.eventCode = eventCode;
    }

    private static final long serialVersionUID = 1L;

    /**
     * 主键id
     */
    private String id;

    /**
     * 火灾半径
     */
    @Excel(name = "火灾半径")
    private String fireRadius;

    /**
     * 关联预案
     */
    @Excel(name = "关联预案")
    private String reserve;

    /**
     * 事件编号
     */
    @Excel(name = "事件编号")
    private String eventCode;

    /**
     * 创建人名称
     */
    @Excel(name = "创建人名称")
    private String createName;

    /**
     * 更新人名称
     */
    @Excel(name = "更新人名称")
    private String updateName;

    /**
     * 数据状态(可用 、不可用 ) 字典
     */
    @Excel(name = "数据状态(可用 、不可用 ) 字典")
    private String dataStatus;

    /**
     * 数据所属部门id
     */
    @Excel(name = "数据所属部门id")
    private Long deptId;

    /**
     * 数据所属部门名称
     */
    @Excel(name = "数据所属部门名称")
    private String deptName;

    public void setId(String id) {
        this.id = id;
    }

    public String getId() {
        return id;
    }

    public void setFireRadius(String fireRadius) {
        this.fireRadius = fireRadius;
    }

    public String getFireRadius() {
        return fireRadius;
    }

    public void setReserve(String reserve) {
        this.reserve = reserve;
    }

    public String getReserve() {
        return reserve;
    }

    public void setEventCode(String eventCode) {
        this.eventCode = eventCode;
    }

    public String getEventCode() {
        return eventCode;
    }

    public void setCreateName(String createName) {
        this.createName = createName;
    }

    public String getCreateName() {
        return createName;
    }

    public void setUpdateName(String updateName) {
        this.updateName = updateName;
    }

    public String getUpdateName() {
        return updateName;
    }

    public void setDataStatus(String dataStatus) {
        this.dataStatus = dataStatus;
    }

    public String getDataStatus() {
        return dataStatus;
    }

    public void setDeptId(Long deptId) {
        this.deptId = deptId;
    }

    public Long getDeptId() {
        return deptId;
    }

    public void setDeptName(String deptName) {
        this.deptName = deptName;
    }

    public String getDeptName() {
        return deptName;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this, ToStringStyle.MULTI_LINE_STYLE)
                .append("id", getId())
                .append("fireRadius", getFireRadius())
                .append("reserve", getReserve())
                .append("eventCode", getEventCode())
                .append("createBy", getCreateBy())
                .append("createName", getCreateName())
                .append("createTime", getCreateTime())
                .append("updateBy", getUpdateBy())
                .append("updateName", getUpdateName())
                .append("updateTime", getUpdateTime())
                .append("dataStatus", getDataStatus())
                .append("deptId", getDeptId())
                .append("deptName", getDeptName())
                .toString();
    }
}
