package com.sooka.sponest.event.centereventtfireevent.mapper;

import com.sooka.sponest.event.centereventteventcatalogue.domain.vo.VisuForestCloudMapVO;
import com.sooka.sponest.event.centereventtfireevent.domain.CentereventTFireEvent;

import java.util.List;
import java.util.Map;

/**
 * 事件扩展（森林防火）Mapper接口
 *
 * @author 朱哲
 * @date 2022-08-29
 */
public interface CentereventTFireEventMapper {

    /**
     * 查询事件扩展（森林防火）列表
     *
     * @param centereventTFireEvent 事件扩展（森林防火）
     * @return 事件扩展（森林防火）集合
     */
    List<CentereventTFireEvent> selectCentereventTFireEventList(CentereventTFireEvent centereventTFireEvent);

    /**
     * 查询事件扩展（森林防火）
     *
     * @param id 事件扩展（森林防火）主键
     * @return 事件扩展（森林防火）
     */
    CentereventTFireEvent selectCentereventTFireEventByEventCode(String eventCode);

    /**
     * 新增事件扩展（森林防火）
     *
     * @param centereventTFireEvent 事件扩展（森林防火）
     * @return 结果
     */
    int insertCentereventTFireEvent(CentereventTFireEvent centereventTFireEvent);

    /**
     * 修改事件扩展（森林防火）
     *
     * @param centereventTFireEvent 事件扩展（森林防火）
     * @return 结果
     */
    int updateCentereventTFireEvent(CentereventTFireEvent centereventTFireEvent);

    /**
     * 批量删除事件扩展（森林防火）
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    int deleteCentereventTFireEventByIds(String[] ids);


    Map<String, Object> getYuAnByEventCode(VisuForestCloudMapVO visuForestCloudMapVO);
}
