package com.sooka.sponest.event.centereventtfireevent.service.impl;

import com.ruoyi.common.core.utils.DateUtils;
import com.ruoyi.common.datascope.base.service.BaseService;
import com.ruoyi.common.security.utils.SecurityUtils;
import com.sooka.sponest.event.centereventteventcatalogue.domain.vo.VisuForestCloudMapVO;
import com.sooka.sponest.event.centereventtfireevent.domain.CentereventTFireEvent;
import com.sooka.sponest.event.centereventtfireevent.mapper.CentereventTFireEventMapper;
import com.sooka.sponest.event.centereventtfireevent.service.ICentereventTFireEventService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

/**
 * 事件扩展（森林防火）Service业务层处理
 *
 * @author 朱哲
 * @date 2022-08-29
 */
@Service
public class CentereventTFireEventServiceImpl extends BaseService implements ICentereventTFireEventService {

    @Autowired
    private CentereventTFireEventMapper centereventTFireEventMapper;

    /**
     * 查询事件扩展（森林防火）列表
     *
     * @param centereventTFireEvent 事件扩展（森林防火）
     * @return 事件扩展（森林防火）
     */
    @Override
    public List<CentereventTFireEvent> selectCentereventTFireEventList(CentereventTFireEvent centereventTFireEvent) {
        return centereventTFireEventMapper.selectCentereventTFireEventList(centereventTFireEvent);
    }

    /**
     * 查询事件扩展（森林防火）
     *
     * @param 事件扩展（森林防火）主键
     * @return 事件扩展（森林防火）
     */
    @Override
    public CentereventTFireEvent selectCentereventTFireEventByEventCode(String eventCode) {
        return centereventTFireEventMapper.selectCentereventTFireEventByEventCode(eventCode);
    }

    /**
     * 新增事件扩展（森林防火）
     *
     * @param centereventTFireEvent 事件扩展（森林防火）
     * @return 结果
     */
    @Transactional
    @Override
    public int insertCentereventTFireEvent(CentereventTFireEvent centereventTFireEvent) {
        centereventTFireEvent.setCreateBy(SecurityUtils.getUserId().toString());
        centereventTFireEvent.setCreateName(SecurityUtils.getLoginUser().getSysUser().getNickName());
        centereventTFireEvent.setCreateTime(DateUtils.getNowDate());
        return centereventTFireEventMapper.insertCentereventTFireEvent(centereventTFireEvent);
    }

    /**
     * 修改事件扩展（森林防火）
     *
     * @param centereventTFireEvent 事件扩展（森林防火）
     * @return 结果
     */
    @Transactional
    @Override
    public int updateCentereventTFireEvent(CentereventTFireEvent centereventTFireEvent) {
        centereventTFireEvent.setUpdateBy(SecurityUtils.getUserId().toString());
        centereventTFireEvent.setUpdateName(SecurityUtils.getLoginUser().getSysUser().getNickName());
        centereventTFireEvent.setUpdateTime(DateUtils.getNowDate());
        return centereventTFireEventMapper.updateCentereventTFireEvent(centereventTFireEvent);
    }

    /**
     * 批量删除事件扩展（森林防火）
     *
     * @param ids 需要删除的事件扩展（森林防火）主键
     * @return 结果
     */
    @Transactional
    @Override
    public int deleteCentereventTFireEventByIds(String[] ids) {
        return centereventTFireEventMapper.deleteCentereventTFireEventByIds(ids);
    }


    @Override
    public Map<String, Object> getYuAnByEventCode(VisuForestCloudMapVO visuForestCloudMapVO) {
        setSookaDataBase(visuForestCloudMapVO);
        return centereventTFireEventMapper.getYuAnByEventCode(visuForestCloudMapVO);
    }
}
