package com.sooka.sponest.event.centereventtfireinformation.controller;

import com.ruoyi.common.core.domain.R;
import com.ruoyi.common.core.web.controller.BaseController;
import com.ruoyi.common.core.web.page.TableDataInfo;
import com.ruoyi.common.security.annotation.RequiresPermissions;
import com.sooka.sponest.event.centereventtfireinformation.domain.FireInformation;
import com.sooka.sponest.event.centereventtfireinformation.service.ICentereventTFireInformationService;
import com.sooka.sponest.event.utils.ExcelUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.util.List;

@RestController
@RequestMapping("/fireInformation")
public class FireInformationController extends BaseController {

    protected final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private ICentereventTFireInformationService iCentereventTFireInformationService;

    /*
    * 林业灾后评估
    *
    * @author 韩福成
    * @date 2024/5/6 10:41
    */
    @PostMapping("/list")
    public TableDataInfo list(@RequestBody FireInformation fireInformation) {
        startPage();
        List<FireInformation> list = iCentereventTFireInformationService.fireInformation(fireInformation);
        return getDataTable(list);
    }

    /*
    * 详情
    *
    * @author 韩福成
    * @date 2024/5/6 13:28
    */
    @RequiresPermissions("event:fireInformation:query")
    @GetMapping("/getDetails/{evevtCode}")
    public R getDetails(@PathVariable("evevtCode") String evevtCode) {
        return R.ok(iCentereventTFireInformationService.getDetails(evevtCode));
    }

    /*
    * 导出
    *
    * @author 韩福成
    * @date 2024/5/7 10:41
    */
    @RequiresPermissions("event:fireInformation:export")
    @PostMapping("/export")
    public void export(HttpServletResponse response, FireInformation fireInformation) {
        List<FireInformation> list = iCentereventTFireInformationService.fireInformation(fireInformation);
        ExcelUtil<FireInformation> util = new ExcelUtil<>(FireInformation.class);
        util.exportExcel(response, list, "林业灾后评估");
    }

}
