package com.sooka.sponest.event.centereventtfireinformation.domain;

import com.ruoyi.common.core.annotation.Excel;
import com.ruoyi.common.core.annotation.Excels;
import com.ruoyi.common.datascope.base.domain.BaseBusinessEntity;
import com.sooka.sponest.event.centereventtforestfireloss.domain.Table1;
import lombok.Data;

/**
 * 火场资料对象 centerevent_t_fire_information
 *
 * @author ruoyi
 */
@Data
public class FireInformation extends BaseBusinessEntity {

    private String id;

    private String eventId;

    private String eventCode;

    @Excel(name = "事件名称")
    private String eventName;

    //centerevent_t_forest_fire_loss
    @Excels({
            @Excel(name = "填报单位", targetAttr = "reportUnit"),
            @Excel(name = "填报时间（年）", targetAttr = "reportTimeY"),
            @Excel(name = "填报时间（月）", targetAttr = "reportTimeM"),
            @Excel(name = "填报时间（日）", targetAttr = "reportTimeD"),
            @Excel(name = "森林火灾损失总计", targetAttr = "forestFireLossTotal"),
            @Excel(name = "火灾损失总计", targetAttr = "fireLossTotal"),
            @Excel(name = "成林蓄积", targetAttr = "forestArea"),
            @Excel(name = "成林价值", targetAttr = "forestPrice"),
            @Excel(name = "幼树株树", targetAttr = "treesNumber"),
            @Excel(name = "幼树价值", targetAttr = "treesPrice"),
            @Excel(name = "轻伤人数", targetAttr = "minorInjuriesNumber"),
            @Excel(name = "轻伤费用", targetAttr = "minorInjuriesPrice"),
            @Excel(name = "重伤人数", targetAttr = "seriouslyInjuredNumber"),
            @Excel(name = "重伤费用", targetAttr = "seriouslyInjuredPrice"),
            @Excel(name = "死亡人数", targetAttr = "deathNumber"),
            @Excel(name = "死亡费用", targetAttr = "deathPrice"),
            @Excel(name = "其他火灾损失", targetAttr = "elseFireLossPrice"),
            @Excel(name = "扑火费用合计", targetAttr = "blazesPriceTotal"),
            @Excel(name = "人工天数", targetAttr = "artificialDays"),
            @Excel(name = "人工费用", targetAttr = "artificialPrice"),
            @Excel(name = "车辆数量", targetAttr = "vehicleNumber"),
            @Excel(name = "汽车数量", targetAttr = "carNumber"),
            @Excel(name = "车辆费用", targetAttr = "vehiclePrice"),
            @Excel(name = "飞机数量", targetAttr = "planeNumber"),
            @Excel(name = "飞机费用", targetAttr = "planePrice"),
            @Excel(name = "其他扑火费用", targetAttr = "elseBlazesPrice"),
            @Excel(name = "备注", targetAttr = "note")
    })
    private Table1 table1;

    //centerevent_t_fire_information
    @Excels({
            @Excel(name = "起火时间", targetAttr = "fireTime"),
            @Excel(name = "发现时间", targetAttr = "foundTime"),
            @Excel(name = "扑灭时间", targetAttr = "blazesTime"),
            @Excel(name = "起火城市", targetAttr = "address"),
            @Excel(name = "起火地点", targetAttr = "firePlace"),
            @Excel(name = "发现方式", targetAttr = "foundType"),
            @Excel(name = "东经（度）", targetAttr = "longitudeD"),
            @Excel(name = "东经（分）", targetAttr = "longitudeM"),
            @Excel(name = "东经（秒）", targetAttr = "longitudeS"),
            @Excel(name = "北纬（度）", targetAttr = "latitudeD"),
            @Excel(name = "北纬（分）", targetAttr = "latitudeM"),
            @Excel(name = "北纬（秒）", targetAttr = "latitudeS"),
            @Excel(name = "起火原因", targetAttr = "fireSource"),
            @Excel(name = "火灾种类", targetAttr = "fireType"),
            @Excel(name = "火灾等级", targetAttr = "fireLevel"),
            @Excel(name = "总面积合计", targetAttr = "areaTotal"),
            @Excel(name = "森林面积损失合计", targetAttr = "forestLossAreaTotal"),
            @Excel(name = "原始林面积", targetAttr = "originalForestArea"),
            @Excel(name = "人工林面积", targetAttr = "artificialForestArea"),
            @Excel(name = "出动总人数", targetAttr = "peopleTotal"),
            @Excel(name = "扑火队人数", targetAttr = "blazesTeamNumber"),
            @Excel(name = "森警人数", targetAttr = "policeNumber"),
            @Excel(name = "军队人数", targetAttr = "armyNumber"),
            @Excel(name = "群众人数", targetAttr = "crowdNumber"),
            @Excel(name = "风力灭火机", targetAttr = "windExtinguisher"),
            @Excel(name = "二号工具", targetAttr = "secondTool"),
            @Excel(name = "水枪", targetAttr = "waterGun"),
            @Excel(name = "其他", targetAttr = "elseThings"),
            @Excel(name = "林木组成", targetAttr = "forestComposition"),
            @Excel(name = "林令", targetAttr = "forestToken"),
            @Excel(name = "疏密度", targetAttr = "porosities"),
            @Excel(name = "天气", targetAttr = "weather"),
            @Excel(name = "气温", targetAttr = "temperature"),
            @Excel(name = "火险等级", targetAttr = "fireInsuranceLevel"),
            @Excel(name = "风力等级", targetAttr = "windLevel"),
            @Excel(name = "风向", targetAttr = "windDirection"),
            @Excel(name = "指挥扑火人单位", targetAttr = "commandUnit"),
            @Excel(name = "指挥扑火人姓名", targetAttr = "commandName"),
            @Excel(name = "指挥扑火人职务", targetAttr = "commandPosition"),
            @Excel(name = "调查人单位", targetAttr = "surveyUnit"),
            @Excel(name = "调查人姓名", targetAttr = "surveyName"),
            @Excel(name = "调查人职务", targetAttr = "surveyPosition"),
            @Excel(name = "肇事人姓名", targetAttr = "accidentName"),
            @Excel(name = "肇事人性别", targetAttr = "accidentSex"),
            @Excel(name = "肇事人年龄", targetAttr = "accidentAge"),
            @Excel(name = "肇事人职业", targetAttr = "accidentPosition"),
            @Excel(name = "肇事人单位或住址", targetAttr = "accidentUnit"),
            @Excel(name = "处理方式", targetAttr = "dealType"),
            @Excel(name = "处理人数", targetAttr = "dealNumber"),
            @Excel(name = "刑事处罚人数", targetAttr = "criminalDealNumber"),
            @Excel(name = "肇事人处理情况", targetAttr = "accidentDealSituation"),
            @Excel(name = "责任人追查情况", targetAttr = "responsibilityDealSituation"),
            @Excel(name = "领导责任追查情况", targetAttr = "leadershipDealSituation"),
            @Excel(name = "县填表人", targetAttr = "townForm"),
            @Excel(name = "县审核人", targetAttr = "townAudit"),
            @Excel(name = "市填表人", targetAttr = "cityForm"),
            @Excel(name = "市审核人", targetAttr = "cityAudit")
    })
    private Table2 table2;

    private String day;
}
