package com.sooka.sponest.event.centereventtfirelog.domain;

import com.ruoyi.common.core.annotation.Excel;
import com.ruoyi.common.core.web.domain.BaseEntity;
import com.sooka.sponest.event.remoteapi.domain.CenterdataTAttach;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import javax.validation.constraints.NotBlank;
import java.util.List;

/**
 * 事件操作日志对象 centerevent_t_fire_log
 *
 * @author 朱哲
 * @date 2022-08-29
 */
public class CentereventTFireLog extends BaseEntity {

    public CentereventTFireLog() {

    }

    public CentereventTFireLog(String eventCode) {
        this.eventCode = eventCode;
    }

    private static final long serialVersionUID = 1L;


    /**
     * 主键
     */
    private String id;

    /**
     * 事件编码
     */
    @Excel(name = "事件编码")
    @NotBlank
    private String eventCode;

    /**
     * 操作内容
     */
    @Excel(name = "操作内容")
    private String logContent;

    /**
     * 填报纬度
     */
    @Excel(name = "填报纬度")
    private String latitude;

    /**
     * 填报经度
     */
    @Excel(name = "填报经度")
    private String longitude;

    /**
     * 业务操作
     */
    @Excel(name = "业务操作")
    @NotBlank
    private String operation;

    /**
     * 操作类型（PC/手机/AI）
     */
    @Excel(name = "操作类型", readConverterExp = "P=C/手机/AI")
    @NotBlank
    private String operationType;


    /**
     * 创建人名称
     */
    @Excel(name = "创建人名称")
    private String createName;

    private List<CenterdataTAttach> fileList;

    private List<FileVO> fileVOs;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getEventCode() {
        return eventCode;
    }

    public void setEventCode(String eventCode) {
        this.eventCode = eventCode;
    }

    public String getLogContent() {
        return logContent;
    }

    public void setLogContent(String logContent) {
        this.logContent = logContent;
    }

    public String getLatitude() {
        return latitude;
    }

    public void setLatitude(String latitude) {
        this.latitude = latitude;
    }

    public String getLongitude() {
        return longitude;
    }

    public void setLongitude(String longitude) {
        this.longitude = longitude;
    }

    public String getOperation() {
        return operation;
    }

    public void setOperation(String operation) {
        this.operation = operation;
    }

    public String getOperationType() {
        return operationType;
    }

    public void setOperationType(String operationType) {
        this.operationType = operationType;
    }

    public String getCreateName() {
        return createName;
    }

    public void setCreateName(String createName) {
        this.createName = createName;
    }

    public List<CenterdataTAttach> getFileList() {
        return fileList;
    }

    public void setFileList(List<CenterdataTAttach> fileList) {
        this.fileList = fileList;
    }

    public List<FileVO> getFileVOs() {
        return fileVOs;
    }

    public void setFileVOs(List<FileVO> fileVOs) {
        this.fileVOs = fileVOs;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this, ToStringStyle.MULTI_LINE_STYLE)
                .append("id", getId())
                .append("eventCode", getEventCode())
                .append("logContent", getLogContent())
                .append("latitude", getLatitude())
                .append("longitude", getLongitude())
                .append("operation", getOperation())
                .append("operationType", getOperationType())
                .append("createBy", getCreateBy())
                .append("createName", getCreateName())
                .append("createTime", getCreateTime())
                .toString();
    }
}
