package com.sooka.sponest.event.centereventtfirelog.service;

import com.sooka.sponest.event.centereventtfirelog.domain.CentereventTFireLog;

import java.util.List;

/**
 * 事件操作日志Service接口
 *
 * @author 朱哲
 * @date 2022-08-29
 */
public interface ICentereventTFireLogService {

    /**
     * 查询事件操作日志列表
     *
     * @param centereventTFireLog 事件操作日志
     * @return 事件操作日志集合
     */
    List<CentereventTFireLog> selectCentereventTFireLogList(CentereventTFireLog centereventTFireLog);

    /**
     * 查询事件操作日志
     *
     * @param id 事件操作日志主键
     * @return 事件操作日志
     */
    CentereventTFireLog selectCentereventTFireLogById(String id);

    /**
     * 查询首条事件操作日志
     *
     * @param eventCode 事件编号
     * @return 事件操作日志
     */
    CentereventTFireLog selectFirstCentereventTFireLogByEventCode(String eventCode);

    /**
     * 新增事件操作日志
     *
     * @param centereventTFireLog 事件操作日志
     * @return 结果
     */
    int insertCentereventTFireLog(CentereventTFireLog centereventTFireLog);

    /**
     * 修改事件操作日志
     *
     * @param centereventTFireLog 事件操作日志
     * @return 结果
     */
    int updateCentereventTFireLog(CentereventTFireLog centereventTFireLog);

    /**
     * 批量删除事件操作日志
     *
     * @param ids 需要删除的事件操作日志主键集合
     * @return 结果
     */
    int deleteCentereventTFireLogByIds(String[] ids);
}
