package com.sooka.sponest.event.centereventtfirespread.mapper;

import com.sooka.sponest.event.centereventtfirespread.domain.CentereventTFireSpread;
import io.lettuce.core.dynamic.annotation.Param;

import java.util.List;

/**
 * 火灾蔓延Mapper接口
 *
 * @author ruoyi
 * @date 2023-04-30
 */
public interface CentereventTFireSpreadMapper {

    /**
     * 查询火灾蔓延列表
     *
     * @param centereventTFireSpread 火灾蔓延
     * @return 火灾蔓延集合
     */
    List<CentereventTFireSpread> selectCentereventTFireSpreadList(CentereventTFireSpread centereventTFireSpread);

    /**
     * 查询火灾蔓延
     *
     * @param id 火灾蔓延主键
     * @return 火灾蔓延
     */
    CentereventTFireSpread selectCentereventTFireSpreadById(String id);

    CentereventTFireSpread getFireSpreadInfo();

    /**
     * 新增火灾蔓延
     *
     * @param centereventTFireSpread 火灾蔓延
     * @return 结果
     */
    int insertCentereventTFireSpread(CentereventTFireSpread centereventTFireSpread);

    /**
     * 修改火灾蔓延
     *
     * @param centereventTFireSpread 火灾蔓延
     * @return 结果
     */
    int updateCentereventTFireSpread(CentereventTFireSpread centereventTFireSpread);

    /**
     * 批量删除火灾蔓延
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    int deleteCentereventTFireSpreadByIds(String[] ids);

    CentereventTFireSpread getNewDataByDate(@Param("date") String date);
}
