package com.sooka.sponest.event.centereventtfirespread.service.impl;

import com.ruoyi.common.core.utils.DateUtils;
import com.ruoyi.common.core.utils.uuid.IdUtils;
import com.ruoyi.common.security.utils.SecurityUtils;
import com.sooka.sponest.event.centereventtfirespread.domain.CentereventTFireSpread;
import com.sooka.sponest.event.centereventtfirespread.mapper.CentereventTFireSpreadMapper;
import com.sooka.sponest.event.centereventtfirespread.service.ICentereventTFireSpreadService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 火灾蔓延Service业务层处理
 *
 * @author ruoyi
 * @date 2023-04-30
 */
@Service
public class CentereventTFireSpreadServiceImpl implements ICentereventTFireSpreadService {

    @Autowired
    private CentereventTFireSpreadMapper centereventTFireSpreadMapper;

    /**
     * 查询火灾蔓延
     *
     * @param id 火灾蔓延主键
     * @return 火灾蔓延
     */
    @Override
    public CentereventTFireSpread selectCentereventTFireSpreadById(String id) {
        return centereventTFireSpreadMapper.selectCentereventTFireSpreadById(id);
    }

    /**
     * 查询火灾蔓延列表
     *
     * @param centereventTFireSpread 火灾蔓延
     * @return 火灾蔓延
     */
    @Override
    public List<CentereventTFireSpread> selectCentereventTFireSpreadList(CentereventTFireSpread centereventTFireSpread) {
        return centereventTFireSpreadMapper.selectCentereventTFireSpreadList(centereventTFireSpread);
    }

    @Override
    public CentereventTFireSpread getFireSpreadInfo() {
        return centereventTFireSpreadMapper.getFireSpreadInfo();
    }

    /**
     * 新增火灾蔓延
     *
     * @param centereventTFireSpread 火灾蔓延
     * @return 结果
     */
    @Override
    public int insertCentereventTFireSpread(CentereventTFireSpread centereventTFireSpread) {
        centereventTFireSpread.setId(IdUtils.simpleUUID());
        centereventTFireSpread.setCreateBy(SecurityUtils.getUserId().toString());
        centereventTFireSpread.setCreateTime(DateUtils.getNowDate());
        return centereventTFireSpreadMapper.insertCentereventTFireSpread(centereventTFireSpread);
    }

    /**
     * 修改火灾蔓延
     *
     * @param centereventTFireSpread 火灾蔓延
     * @return 结果
     */
    @Override
    public int updateCentereventTFireSpread(CentereventTFireSpread centereventTFireSpread) {
        return centereventTFireSpreadMapper.updateCentereventTFireSpread(centereventTFireSpread);
    }

    /**
     * 批量删除火灾蔓延
     *
     * @param ids 需要删除的火灾蔓延主键
     * @return 结果
     */
    @Override
    public int deleteCentereventTFireSpreadByIds(String[] ids) {
        return centereventTFireSpreadMapper.deleteCentereventTFireSpreadByIds(ids);
    }

    @Override
    public CentereventTFireSpread getNewDataByDate(String date) {
        return centereventTFireSpreadMapper.getNewDataByDate(date);
    }
}
