package com.sooka.sponest.event.centereventtforestfireloss.controller;

import com.ruoyi.common.core.domain.R;
import com.ruoyi.common.core.web.controller.BaseController;
import com.ruoyi.common.core.web.domain.AjaxResult;
import com.sooka.sponest.event.centereventtfireinformation.domain.FireInformation;
import com.sooka.sponest.event.centereventtfireinformation.service.ICentereventTFireInformationService;
import com.sooka.sponest.event.centereventtforestfireloss.domain.VisuForestFireLossVO;
import com.sooka.sponest.event.centereventtforestfireloss.service.ICentereventTForestFireLossService;
import com.sooka.sponest.event.centereventtregionalflag.service.ICentereventTRegionalFlagService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.Map;

/**
 * 火灾损失Controller
 *
 * @author lyq
 * @date 2023-1-31
 */
@Api(tags = "火灾损失")
@RestController
@RequestMapping("/centereventtforestfireloss")
public class CentereventTForestFireLossController extends BaseController {

    @Autowired
    private ICentereventTForestFireLossService centereventTForestFireLossService;

    @Autowired
    private ICentereventTRegionalFlagService centereventTRegionalFlagService;

    @Autowired
    private ICentereventTFireInformationService centereventTFireInformationService;

    @ApiOperation("灾后评估")
    @PostMapping("/getFireLoss")
    public R getFireLoss(@RequestBody VisuForestFireLossVO visuForestFireLossVO) {
        Map<String, Object> resultMap = new HashMap<>();
        resultMap.put("visuForestFireLossBO", centereventTForestFireLossService.getFireLoss(visuForestFireLossVO));
        resultMap.put("regionalFlagBOList", centereventTRegionalFlagService.getFireRegion(visuForestFireLossVO.getFireType(), visuForestFireLossVO.getYear()));
        return R.ok(resultMap);
    }

    // 新增火险报告（火场资料）
    @PostMapping("/addFireInformationFeign")
    public AjaxResult addFireInformationFeign(@RequestBody FireInformation fireInformation) {
        return toAjax(centereventTFireInformationService.addFireInformation(fireInformation));
    }

    @GetMapping("/getFireRegion")
    public R getFireRegion(String fireType, String year) {
        return R.ok(centereventTRegionalFlagService.getFireRegion(fireType, year));
    }
}
