package com.sooka.sponest.event.centereventtforestfireloss.service.impl;

import com.ruoyi.common.core.utils.uuid.IdUtils;
import com.ruoyi.common.datascope.annotation.DataScopeMutiDept;
import com.ruoyi.common.datascope.base.service.BaseService;
import com.sooka.sponest.event.centereventtforestfireloss.domain.ForestFireLoss;
import com.sooka.sponest.event.centereventtforestfireloss.domain.VisuForestFireLossVO;
import com.sooka.sponest.event.centereventtforestfireloss.mapper.CentereventTForestFireLossMapper;
import com.sooka.sponest.event.centereventtforestfireloss.service.ICentereventTForestFireLossService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Map;

/**
 * 事件目录Mapper接口
 *
 * @author ruoyi
 * @date 2022-08-27
 */
@Service
public class CentereventTForestFireLossServiceImpl extends BaseService implements ICentereventTForestFireLossService {

    @Autowired
    private CentereventTForestFireLossMapper centereventTForestFireLossMapper;

    // 新增火险报告（森林火灾损失）
    @Override
    public int addForestFireLoss(ForestFireLoss forestFireLoss) {
        forestFireLoss.setId(IdUtils.simpleUUID());
        return centereventTForestFireLossMapper.addForestFireLoss(forestFireLoss);
    }

    @DataScopeMutiDept(deptAlias = "d")
    @Override
    public Map<String, Object> getFireLoss(VisuForestFireLossVO visuForestFireLossVO) {
        setSookaDataBase(visuForestFireLossVO);
        return centereventTForestFireLossMapper.getFireLoss(visuForestFireLossVO);
    }
}
