package com.sooka.sponest.event.centereventtlog.domain;

import com.ruoyi.common.core.annotation.Excel;
import com.ruoyi.common.datascope.base.domain.BaseBusinessEntity;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import java.util.List;

/**
 * 事件操作日志对象 centerevent_t_log
 *
 * @author ruoyi
 * @date 2022-05-24
 */
public class CentereventTLog extends BaseBusinessEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 主键id
     */
    private String id;

    /**
     * 部门名称（当前操作人）
     */
    @Excel(name = "部门名称", readConverterExp = "当=前操作人")
    private String deptName;

    /**
     * 部门id(操作人本部门)
     */
    @Excel(name = "部门id(操作人本部门)")
    private Long deptId;

    /**
     * 内容
     */
    @Excel(name = "内容")
    private String logContent;

    /**
     * 维度
     */
    @Excel(name = "维度")
    private String latitude;

    /**
     * 经度
     */
    @Excel(name = "经度")
    private String longitude;

    /**
     * 事件编码
     */
    @Excel(name = "事件编码")
    private String eventCode;

    /**
     * 操作类型（1-机器反馈 2-人为操作）
     */
    @Excel(name = "操作类型", readConverterExp = "1=-机器反馈,2=-人为操作")
    private String operationType;

    public String getMessageType() {
        return messageType;
    }

    public void setMessageType(String messageType) {
        this.messageType = messageType;
    }

    private String messageType;

    /**
     * 数据状态(1-可用 2-不可用 ) - 字典
     */
    @Excel(name = "数据状态(1-可用 2-不可用 ) - 字典")
    private String dataStatus;

    public String getFileUrl() {
        return fileUrl;
    }

    public void setFileUrl(String fileUrl) {
        this.fileUrl = fileUrl;
    }

    private String fileUrl;

    public List<String> getFileUrls() {
        return fileUrls;
    }

    public void setFileUrls(List<String> fileUrls) {
        this.fileUrls = fileUrls;
    }

    private List<String> fileUrls;

    public void setId(String id) {
        this.id = id;
    }

    public String getId() {
        return id;
    }

    public void setDeptName(String deptName) {
        this.deptName = deptName;
    }

    public String getDeptName() {
        return deptName;
    }

    public void setDeptId(Long deptId) {
        this.deptId = deptId;
    }

    public Long getDeptId() {
        return deptId;
    }

    public void setLogContent(String logContent) {
        this.logContent = logContent;
    }

    public String getLogContent() {
        return logContent;
    }

    public void setLatitude(String latitude) {
        this.latitude = latitude;
    }

    public String getLatitude() {
        return latitude;
    }

    public void setLongitude(String longitude) {
        this.longitude = longitude;
    }

    public String getLongitude() {
        return longitude;
    }

    public void setEventCode(String eventCode) {
        this.eventCode = eventCode;
    }

    public String getEventCode() {
        return eventCode;
    }

    public void setOperationType(String operationType) {
        this.operationType = operationType;
    }

    public String getOperationType() {
        return operationType;
    }

    public void setDataStatus(String dataStatus) {
        this.dataStatus = dataStatus;
    }

    public String getDataStatus() {
        return dataStatus;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this, ToStringStyle.MULTI_LINE_STYLE)
                .append("id", getId())
                .append("deptName", getDeptName())
                .append("deptId", getDeptId())
                .append("logContent", getLogContent())
                .append("latitude", getLatitude())
                .append("longitude", getLongitude())
                .append("eventCode", getEventCode())
                .append("operationType", getOperationType())
                .append("createBy", getCreateBy())
                .append("createName", getCreateName())
                .append("createTime", getCreateTime())
                .append("updateBy", getUpdateBy())
                .append("updateName", getUpdateName())
                .append("updateTime", getUpdateTime())
                .append("dataStatus", getDataStatus())
                .append("dataDeptId", getDataDeptId())
                .toString();
    }
}
