package com.sooka.sponest.event.centereventtlog.mapper;

import com.sooka.sponest.event.centereventtlog.domain.CentereventTLog;

import java.util.List;

/**
 * 事件操作日志Mapper接口
 *
 * @author ruoyi
 * @date 2022-05-24
 */
public interface CentereventTLogMapper {

    /**
     * 查询事件操作日志列表
     *
     * @param centereventTLog 事件操作日志
     * @return 事件操作日志集合
     */
    List<CentereventTLog> selectCentereventTLogList(CentereventTLog centereventTLog);

    List<CentereventTLog> selectCentereventTLogListPC(CentereventTLog centereventTLog);

    /**
     * 查询事件操作日志
     *
     * @param id 事件操作日志主键
     * @return 事件操作日志
     */
    CentereventTLog selectCentereventTLogById(String id);

    /**
     * 新增事件操作日志
     *
     * @param centereventTLog 事件操作日志
     * @return 结果
     */
    int insertCentereventTLog(CentereventTLog centereventTLog);

    /**
     * 修改事件操作日志
     *
     * @param centereventTLog 事件操作日志
     * @return 结果
     */
    int updateCentereventTLog(CentereventTLog centereventTLog);

    /**
     * 批量删除事件操作日志
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    int deleteCentereventTLogByIds(String[] ids);
}
