package com.sooka.sponest.event.centereventtlog.service.impl;

import com.ruoyi.common.core.utils.DateUtils;
import com.ruoyi.common.core.utils.SpringUtils;
import com.ruoyi.common.core.utils.StringUtils;
import com.ruoyi.common.core.utils.uuid.IdUtils;
import com.ruoyi.common.datascope.base.service.BaseService;
import com.ruoyi.system.api.RemoteConfigService;
import com.sooka.sponest.event.centereventtlog.domain.CentereventTLog;
import com.sooka.sponest.event.centereventtlog.mapper.CentereventTLogMapper;
import com.sooka.sponest.event.centereventtlog.service.ICentereventTLogService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * 事件操作日志Service业务层处理
 *
 * @author ruoyi
 * @date 2022-05-24
 */
@Service
public class CentereventTLogServiceImpl extends BaseService implements ICentereventTLogService {

    @Autowired
    private CentereventTLogMapper centereventTLogMapper;

    /**
     * 查询事件操作日志列表
     *
     * @param centereventTLog 事件操作日志
     * @return 事件操作日志
     */
    @Override
    public List<CentereventTLog> selectCentereventTLogList(CentereventTLog centereventTLog) {
        return centereventTLogMapper.selectCentereventTLogList(centereventTLog);
    }

    @Override
    public List<CentereventTLog> selectCentereventTLogListPC(CentereventTLog centereventTLog) {
        setSookaDataBase(centereventTLog);
        List<CentereventTLog> centereventTLogList = centereventTLogMapper.selectCentereventTLogListPC(centereventTLog);
        String fileurl = SpringUtils.getBean(RemoteConfigService.class).remotegetConfigKey("fileUrl").getData();
        for (CentereventTLog centereventTLog1 : centereventTLogList) {
            if (StringUtils.isNotEmpty(centereventTLog1.getFileUrl())) {
                List<String> fileUtrlList = new ArrayList<>();
                String[] fileUrls = centereventTLog1.getFileUrl().split(",");
                for (String str : fileUrls) {
                    fileUtrlList.add(fileurl + str);
                }
                centereventTLog1.setFileUrls(fileUtrlList);
            }
        }
        return centereventTLogList;
    }

    /**
     * 查询事件操作日志
     *
     * @param id 事件操作日志主键
     * @return 事件操作日志
     */
    @Override
    public CentereventTLog selectCentereventTLogById(String id) {
        return centereventTLogMapper.selectCentereventTLogById(id);
    }

    /**
     * 新增事件操作日志
     *
     * @param centereventTLog 事件操作日志
     * @return 结果
     */
    @Override
    public int insertCentereventTLog(CentereventTLog centereventTLog) {
        centereventTLog.setId(IdUtils.simpleUUID());
        centereventTLog.setCreateTime(DateUtils.getNowDate());
        return centereventTLogMapper.insertCentereventTLog(centereventTLog);
    }

    /**
     * 修改事件操作日志
     *
     * @param centereventTLog 事件操作日志
     * @return 结果
     */
    @Override
    public int updateCentereventTLog(CentereventTLog centereventTLog) {
        centereventTLog.setUpdateTime(DateUtils.getNowDate());
        return centereventTLogMapper.updateCentereventTLog(centereventTLog);
    }

    /**
     * 批量删除事件操作日志
     *
     * @param ids 需要删除的事件操作日志主键
     * @return 结果
     */
    @Override
    public int deleteCentereventTLogByIds(String[] ids) {
        return centereventTLogMapper.deleteCentereventTLogByIds(ids);
    }
}
