package com.sooka.sponest.event.centereventtreportmessage.mapper;

import com.sooka.sponest.event.centereventtreportmessage.domain.CentereventTReportmessage;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 报文日志Mapper接口
 *
 * @author ruoyi
 * @date 2022-05-24
 */
public interface CentereventTReportmessageMapper {

    /**
     * 查询报文日志列表
     *
     * @param centereventTReportmessage 报文日志
     * @return 报文日志集合
     */
    List<CentereventTReportmessage> selectCentereventTReportmessageList(CentereventTReportmessage centereventTReportmessage);

    List<CentereventTReportmessage> selectCentereventTReportmessageListRange(@Param("start") String start, @Param("end") String end, @Param("source") String source);

    /**
     * 查询报文日志
     *
     * @param id 报文日志主键
     * @return 报文日志
     */
    CentereventTReportmessage selectCentereventTReportmessageById(String id);

    /**
     * 新增报文日志
     *
     * @param centereventTReportmessage 报文日志
     * @return 结果
     */
    int insertCentereventTReportmessage(CentereventTReportmessage centereventTReportmessage);

    /**
     * 修改报文日志
     *
     * @param centereventTReportmessage 报文日志
     * @return 结果
     */
    int updateCentereventTReportmessage(CentereventTReportmessage centereventTReportmessage);

    int updateCentereventTReportmessageId(@Param("id") String id, @Param("eventCode") String eventCode);

    /**
     * 批量删除报文日志
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    int deleteCentereventTReportmessageByIds(String[] ids);
}
