package com.sooka.sponest.event.centereventtreportmessage.service;

import com.sooka.sponest.event.centereventtreportmessage.domain.CentereventTReportmessage;

import java.util.List;

/**
 * 报文日志Service接口
 *
 * @author ruoyi
 * @date 2022-05-24
 */
public interface ICentereventTReportmessageService {

    /**
     * 查询报文日志列表
     *
     * @param centereventTReportmessage 报文日志
     * @return 报文日志集合
     */
    List<CentereventTReportmessage> selectCentereventTReportmessageList(CentereventTReportmessage centereventTReportmessage);

    List<CentereventTReportmessage> selectCentereventTReportmessageListRange(String start, String end, String source);

    /**
     * 查询报文日志
     *
     * @param id 报文日志主键
     * @return 报文日志
     */
    CentereventTReportmessage selectCentereventTReportmessageById(String id);

    /**
     * 新增报文日志
     *
     * @param centereventTReportmessage 报文日志
     * @return 结果
     */
    int insertCentereventTReportmessage(CentereventTReportmessage centereventTReportmessage);

    /**
     * 修改报文日志
     *
     * @param centereventTReportmessage 报文日志
     * @return 结果
     */
    int updateCentereventTReportmessage(CentereventTReportmessage centereventTReportmessage);

    int updateCentereventTReportmessage(String id, String eventCode);

    /**
     * 批量删除报文日志
     *
     * @param ids 需要删除的报文日志主键集合
     * @return 结果
     */
    int deleteCentereventTReportmessageByIds(String[] ids);
}
