package com.sooka.sponest.event.centereventtreportmessage.service.impl;

import com.ruoyi.common.core.utils.DateUtils;
import com.sooka.sponest.event.centereventtreportmessage.domain.CentereventTReportmessage;
import com.sooka.sponest.event.centereventtreportmessage.mapper.CentereventTReportmessageMapper;
import com.sooka.sponest.event.centereventtreportmessage.service.ICentereventTReportmessageService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 报文日志Service业务层处理
 *
 * @author ruoyi
 * @date 2022-05-24
 */
@Service
public class CentereventTReportmessageServiceImpl implements ICentereventTReportmessageService {

    @Autowired
    private CentereventTReportmessageMapper centereventTReportmessageMapper;

    /**
     * 查询报文日志列表
     *
     * @param centereventTReportmessage 报文日志
     * @return 报文日志
     */
    @Override
    public List<CentereventTReportmessage> selectCentereventTReportmessageList(CentereventTReportmessage centereventTReportmessage) {
        return centereventTReportmessageMapper.selectCentereventTReportmessageList(centereventTReportmessage);
    }

    @Override
    public List<CentereventTReportmessage> selectCentereventTReportmessageListRange(String start, String end, String source) {
        return centereventTReportmessageMapper.selectCentereventTReportmessageListRange(start, end, source);
    }

    /**
     * 查询报文日志
     *
     * @param id 报文日志主键
     * @return 报文日志
     */
    @Override
    public CentereventTReportmessage selectCentereventTReportmessageById(String id) {
        return centereventTReportmessageMapper.selectCentereventTReportmessageById(id);
    }

    /**
     * 新增报文日志
     *
     * @param centereventTReportmessage 报文日志
     * @return 结果
     */
    @Transactional
    @Override
    public int insertCentereventTReportmessage(CentereventTReportmessage centereventTReportmessage) {
        centereventTReportmessage.setCreateTime(DateUtils.getNowDate());
        return centereventTReportmessageMapper.insertCentereventTReportmessage(centereventTReportmessage);
    }

    /**
     * 修改报文日志
     *
     * @param centereventTReportmessage 报文日志
     * @return 结果
     */
    @Transactional
    @Override
    public int updateCentereventTReportmessage(CentereventTReportmessage centereventTReportmessage) {
        return centereventTReportmessageMapper.updateCentereventTReportmessage(centereventTReportmessage);
    }

    @Transactional
    @Override
    public int updateCentereventTReportmessage(String id, String eventCode) {
        return centereventTReportmessageMapper.updateCentereventTReportmessageId(id, eventCode);
    }

    /**
     * 批量删除报文日志
     *
     * @param ids 需要删除的报文日志主键
     * @return 结果
     */
    @Transactional
    @Override
    public int deleteCentereventTReportmessageByIds(String[] ids) {
        return centereventTReportmessageMapper.deleteCentereventTReportmessageByIds(ids);
    }
}
