package com.sooka.sponest.event.emergency.emergencyevents.controller;

import com.ruoyi.common.core.domain.R;
import com.ruoyi.common.core.utils.poi.ExcelUtil;
import com.ruoyi.common.core.web.controller.BaseController;
import com.ruoyi.common.core.web.domain.AjaxResult;
import com.ruoyi.common.core.web.page.TableDataInfo;
import com.ruoyi.common.log.annotation.Log;
import com.ruoyi.common.log.enums.BusinessType;
import com.ruoyi.common.security.annotation.RequiresPermissions;
import com.sooka.sponest.event.emergency.emergencyevents.domain.CentereventTEmergencyEmergencyevents;
import com.sooka.sponest.event.emergency.emergencyevents.mapper.CentereventTEmergencyEmergencyeventsMapper;
import com.sooka.sponest.event.emergency.emergencyevents.service.ICentereventTEmergencyEmergencyeventsService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 * 应急事件Controller
 *
 * @author ruoyi
 * @date 2022-07-20
 */
@RestController
@RequestMapping("/emergencyevents")
public class CentereventTEmergencyEmergencyeventsController extends BaseController {

    @Autowired
    private ICentereventTEmergencyEmergencyeventsService centereventTEmergencyEmergencyeventsService;

    @Autowired
    CentereventTEmergencyEmergencyeventsMapper centereventTEmergencyEmergencyeventsMapper;

    /**
     * 查询应急事件列表
     */
    @RequiresPermissions("emergencyevents:emergencyevents:list")
    @GetMapping("/list")
    public TableDataInfo list(CentereventTEmergencyEmergencyevents centereventTEmergencyEmergencyevents) {
        startPage();
        List<CentereventTEmergencyEmergencyevents> list = centereventTEmergencyEmergencyeventsService.selectCentereventTEmergencyEmergencyeventsList(centereventTEmergencyEmergencyevents);
        return getDataTable(list);
    }

    /**
     * 查询应急事件列表
     */
    @PostMapping("/feginEmergencyEmergencyeventsList")
    public R<List<CentereventTEmergencyEmergencyevents>> feginEmergencyEmergencyeventsList(CentereventTEmergencyEmergencyevents centereventTEmergencyEmergencyevents) {
        List<CentereventTEmergencyEmergencyevents> list = centereventTEmergencyEmergencyeventsService.selectCentereventTEmergencyEmergencyeventsList(centereventTEmergencyEmergencyevents);
        return R.ok(list);
    }

    /**
     * 查询应急事件列表
     */
    @PostMapping("/feignSelectByIds/{Ids}")
    public R<List<CentereventTEmergencyEmergencyevents>> feignSelectByIds(@PathVariable String[] Ids) {
        List<CentereventTEmergencyEmergencyevents> list = centereventTEmergencyEmergencyeventsService.selectByIds(Ids);
        return R.ok(list);
    }

    /**
     * 查询应急事件列表
     */
    @PostMapping("/feignSelectByMeetingCode/{meetingCodes}")
    public R<List<CentereventTEmergencyEmergencyevents>> feignSelectByMeetingCode(@PathVariable String[] meetingCodes) {
        List<CentereventTEmergencyEmergencyevents> list = centereventTEmergencyEmergencyeventsService.selectByMeetingCode(meetingCodes);
        return R.ok(list);
    }

    /**
     * 导出应急事件列表
     */
    @RequiresPermissions("emergencyevents:emergencyevents:export")
    @Log(title = "应急事件", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, CentereventTEmergencyEmergencyevents centereventTEmergencyEmergencyevents) {
        List<CentereventTEmergencyEmergencyevents> list = centereventTEmergencyEmergencyeventsService.selectCentereventTEmergencyEmergencyeventsList(centereventTEmergencyEmergencyevents);
        ExcelUtil<CentereventTEmergencyEmergencyevents> util = new ExcelUtil<>(CentereventTEmergencyEmergencyevents.class);
        util.exportExcel(response, list, "应急事件数据");
    }

    /**
     * 获取应急事件详细信息
     */
    @RequiresPermissions("emergencyevents:emergencyevents:query")
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") String id) {
        return AjaxResult.success(centereventTEmergencyEmergencyeventsService.selectCentereventTEmergencyEmergencyeventsById(id));
    }

    /**
     * 新增应急事件
     */
    @RequiresPermissions("emergencyevents:emergencyevents:add")
    @Log(title = "应急事件", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody CentereventTEmergencyEmergencyevents centereventTEmergencyEmergencyevents) {
        return toAjax(centereventTEmergencyEmergencyeventsService.insertCentereventTEmergencyEmergencyevents(centereventTEmergencyEmergencyevents));
    }

    @PostMapping("/insertEmergencyevents")
    public void insertEmergencyevents(@RequestBody CentereventTEmergencyEmergencyevents centereventTEmergencyEmergencyevents) {
        centereventTEmergencyEmergencyeventsMapper.insertCentereventTEmergencyEmergencyevents(centereventTEmergencyEmergencyevents);
    }

    /**
     * 修改应急事件
     */
    @RequiresPermissions("emergencyevents:emergencyevents:edit")
    @Log(title = "应急事件", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody CentereventTEmergencyEmergencyevents centereventTEmergencyEmergencyevents) {
        return toAjax(centereventTEmergencyEmergencyeventsService.updateCentereventTEmergencyEmergencyevents(centereventTEmergencyEmergencyevents));
    }

    /**
     * 修改应急事件
     */

    @PutMapping("/feignUpdateEmergencyevents")
    public AjaxResult feignUpdateEmergencyevents(@RequestBody CentereventTEmergencyEmergencyevents centereventTEmergencyEmergencyevents) {
        return toAjax(centereventTEmergencyEmergencyeventsService.updateCentereventTEmergencyEmergencyevents(centereventTEmergencyEmergencyevents));
    }

    /**
     * 删除应急事件
     */
    @RequiresPermissions("emergencyevents:emergencyevents:remove")
    @Log(title = "应急事件", businessType = BusinessType.DELETE)
    @DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable String[] ids) {
        return toAjax(centereventTEmergencyEmergencyeventsService.deleteCentereventTEmergencyEmergencyeventsByIds(ids));
    }
}
