package com.sooka.sponest.event.emergency.emergencyevents.domain;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.ruoyi.common.core.annotation.Excel;
import com.ruoyi.common.core.web.domain.BaseEntity;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import java.util.Date;

/**
 * 应急事件对象 centerevent_t_emergency_emergencyevents
 *
 * @author ruoyi
 * @date 2022-07-20
 */
public class CentereventTEmergencyEmergencyevents extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键ID */
    private String id;

    /** 删除人 */
    @Excel(name = "删除人")
    private String deleteBy;

    /** 删除时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "删除时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date deleteTime;

    /** 数据状态 */
    @Excel(name = "数据状态")
    private String dataStatus;

    /** 经度 */
    @Excel(name = "经度")
    private String longitude;

    /** 纬度 */
    @Excel(name = "纬度")
    private String latitude;

    /** 应急状态(字典项目) */
    @Excel(name = "应急状态(字典项目)")
    private String dangerStatus;

    /** 标题 */
    @Excel(name = "标题")
    private String title;

    /** 内容 */
    @Excel(name = "内容")
    private String content;

    /** 地址 */
    @Excel(name = "地址")
    private String address;

    /** 会议号码 */
    @Excel(name = "会议号码")
    private String meetingCode;

    /** 会议密码-主持者 */
    @Excel(name = "会议密码-主持者")
    private String meetingPassword;

    /** 会议密码-参会者 */
    @Excel(name = "会议密码-参会者")
    private String meetingJoinpassword;

    /** 会议状态(0-关闭 1-开启) */
    @Excel(name = "会议状态(0-关闭 1-开启)")
    private String meetingStatus;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    private Long owndeptid;

    /** 数据所属部门(政或党的id) */
    @Excel(name = "数据所属部门(政或党的id)")
    private Long deptId;

    public void setId(String id)
    {
        this.id = id;
    }

    public String getId()
    {
        return id;
    }
    public void setDeleteBy(String deleteBy)
    {
        this.deleteBy = deleteBy;
    }

    public String getDeleteBy()
    {
        return deleteBy;
    }
    public void setDeleteTime(Date deleteTime)
    {
        this.deleteTime = deleteTime;
    }

    public Date getDeleteTime()
    {
        return deleteTime;
    }
    public void setDataStatus(String dataStatus)
    {
        this.dataStatus = dataStatus;
    }

    public String getDataStatus()
    {
        return dataStatus;
    }
    public void setLongitude(String longitude)
    {
        this.longitude = longitude;
    }

    public String getLongitude()
    {
        return longitude;
    }
    public void setLatitude(String latitude)
    {
        this.latitude = latitude;
    }

    public String getLatitude()
    {
        return latitude;
    }
    public void setDangerStatus(String dangerStatus)
    {
        this.dangerStatus = dangerStatus;
    }

    public String getDangerStatus()
    {
        return dangerStatus;
    }
    public void setTitle(String title)
    {
        this.title = title;
    }

    public String getTitle()
    {
        return title;
    }
    public void setContent(String content)
    {
        this.content = content;
    }

    public String getContent()
    {
        return content;
    }
    public void setAddress(String address)
    {
        this.address = address;
    }

    public String getAddress()
    {
        return address;
    }
    public void setMeetingCode(String meetingCode)
    {
        this.meetingCode = meetingCode;
    }

    public String getMeetingCode()
    {
        return meetingCode;
    }
    public void setMeetingPassword(String meetingPassword)
    {
        this.meetingPassword = meetingPassword;
    }

    public String getMeetingPassword()
    {
        return meetingPassword;
    }
    public void setMeetingJoinpassword(String meetingJoinpassword)
    {
        this.meetingJoinpassword = meetingJoinpassword;
    }

    public String getMeetingJoinpassword()
    {
        return meetingJoinpassword;
    }
    public void setMeetingStatus(String meetingStatus)
    {
        this.meetingStatus = meetingStatus;
    }

    public String getMeetingStatus()
    {
        return meetingStatus;
    }
    public void setOwndeptid(Long owndeptid)
    {
        this.owndeptid = owndeptid;
    }

    public Long getOwndeptid()
    {
        return owndeptid;
    }
    public void setDeptId(Long deptId)
    {
        this.deptId = deptId;
    }

    public Long getDeptId()
    {
        return deptId;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this,ToStringStyle.MULTI_LINE_STYLE)
            .append("id", getId())
            .append("createBy", getCreateBy())
            .append("createTime", getCreateTime())
            .append("updateBy", getUpdateBy())
            .append("updateTime", getUpdateTime())
            .append("deleteBy", getDeleteBy())
            .append("deleteTime", getDeleteTime())
            .append("dataStatus", getDataStatus())
            .append("longitude", getLongitude())
            .append("latitude", getLatitude())
            .append("dangerStatus", getDangerStatus())
            .append("title", getTitle())
            .append("content", getContent())
            .append("address", getAddress())
            .append("meetingCode", getMeetingCode())
            .append("meetingPassword", getMeetingPassword())
            .append("meetingJoinpassword", getMeetingJoinpassword())
            .append("meetingStatus", getMeetingStatus())
            .append("owndeptid", getOwndeptid())
            .append("deptId", getDeptId())
            .toString();
    }
}
