package com.sooka.sponest.event.emergency.emergencyevents.mapper;

import com.sooka.sponest.event.emergency.emergencyevents.domain.CentereventTEmergencyEmergencyevents;

import java.util.List;

/**
 * 应急事件Mapper接口
 *
 * @author ruoyi
 * @date 2022-07-20
 */
public interface CentereventTEmergencyEmergencyeventsMapper
{
    /**
     * 查询应急事件
     *
     * @param id 应急事件主键
     * @return 应急事件
     */
    public CentereventTEmergencyEmergencyevents selectCentereventTEmergencyEmergencyeventsById(String id);

    /**
     * 查询应急事件列表
     *
     * @param centereventTEmergencyEmergencyevents 应急事件
     * @return 应急事件集合
     */
    public List<CentereventTEmergencyEmergencyevents> selectCentereventTEmergencyEmergencyeventsList(CentereventTEmergencyEmergencyevents centereventTEmergencyEmergencyevents);

    /**
     * 新增应急事件
     *
     * @param centereventTEmergencyEmergencyevents 应急事件
     * @return 结果
     */
    public int insertCentereventTEmergencyEmergencyevents(CentereventTEmergencyEmergencyevents centereventTEmergencyEmergencyevents);

    /**
     * 修改应急事件
     *
     * @param centereventTEmergencyEmergencyevents 应急事件
     * @return 结果
     */
    public int updateCentereventTEmergencyEmergencyevents(CentereventTEmergencyEmergencyevents centereventTEmergencyEmergencyevents);

    /**
     * 删除应急事件
     *
     * @param id 应急事件主键
     * @return 结果
     */
    public int deleteCentereventTEmergencyEmergencyeventsById(String id);

    /**
     * 批量删除应急事件
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteCentereventTEmergencyEmergencyeventsByIds(String[] ids);

    public List<CentereventTEmergencyEmergencyevents> selectByIds(String [] ids);
    public List<CentereventTEmergencyEmergencyevents> selectByMeetingCode(String [] meetingCodes);
}
