package com.sooka.sponest.event.emergency.emergencyevents.service.impl;

import com.ruoyi.common.core.utils.DateUtils;
import com.ruoyi.common.core.utils.uuid.IdUtils;
import com.sooka.sponest.event.emergency.emergencyevents.domain.CentereventTEmergencyEmergencyevents;
import com.sooka.sponest.event.emergency.emergencyevents.mapper.CentereventTEmergencyEmergencyeventsMapper;
import com.sooka.sponest.event.emergency.emergencyevents.service.ICentereventTEmergencyEmergencyeventsService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 应急事件Service业务层处理
 *
 * @author ruoyi
 * @date 2022-07-20
 */
@Service
public class CentereventTEmergencyEmergencyeventsServiceImpl implements ICentereventTEmergencyEmergencyeventsService
{
    @Autowired
    private CentereventTEmergencyEmergencyeventsMapper centereventTEmergencyEmergencyeventsMapper;

    /**
     * 查询应急事件
     *
     * @param id 应急事件主键
     * @return 应急事件
     */
    @Override
    public CentereventTEmergencyEmergencyevents selectCentereventTEmergencyEmergencyeventsById(String id)
    {
        return centereventTEmergencyEmergencyeventsMapper.selectCentereventTEmergencyEmergencyeventsById(id);
    }

    /**
     * 查询应急事件列表
     *
     * @param centereventTEmergencyEmergencyevents 应急事件
     * @return 应急事件
     */
    @Override
    public List<CentereventTEmergencyEmergencyevents> selectCentereventTEmergencyEmergencyeventsList(CentereventTEmergencyEmergencyevents centereventTEmergencyEmergencyevents)
    {
        return centereventTEmergencyEmergencyeventsMapper.selectCentereventTEmergencyEmergencyeventsList(centereventTEmergencyEmergencyevents);
    }

    /**
     * 新增应急事件
     *
     * @param centereventTEmergencyEmergencyevents 应急事件
     * @return 结果
     */
    @Override
    public int insertCentereventTEmergencyEmergencyevents(CentereventTEmergencyEmergencyevents centereventTEmergencyEmergencyevents)
    {   centereventTEmergencyEmergencyevents.setId(IdUtils.fastSimpleUUID());
        centereventTEmergencyEmergencyevents.setCreateTime(DateUtils.getNowDate());
        return centereventTEmergencyEmergencyeventsMapper.insertCentereventTEmergencyEmergencyevents(centereventTEmergencyEmergencyevents);
    }

    /**
     * 修改应急事件
     *
     * @param centereventTEmergencyEmergencyevents 应急事件
     * @return 结果
     */
    @Override
    public int updateCentereventTEmergencyEmergencyevents(CentereventTEmergencyEmergencyevents centereventTEmergencyEmergencyevents)
    {
        centereventTEmergencyEmergencyevents.setUpdateTime(DateUtils.getNowDate());
        return centereventTEmergencyEmergencyeventsMapper.updateCentereventTEmergencyEmergencyevents(centereventTEmergencyEmergencyevents);
    }

    /**
     * 批量删除应急事件
     *
     * @param ids 需要删除的应急事件主键
     * @return 结果
     */
    @Override
    public int deleteCentereventTEmergencyEmergencyeventsByIds(String[] ids)
    {
        return centereventTEmergencyEmergencyeventsMapper.deleteCentereventTEmergencyEmergencyeventsByIds(ids);
    }

    /**
     * 删除应急事件信息
     *
     * @param id 应急事件主键
     * @return 结果
     */
    @Override
    public int deleteCentereventTEmergencyEmergencyeventsById(String id)
    {
        return centereventTEmergencyEmergencyeventsMapper.deleteCentereventTEmergencyEmergencyeventsById(id);
    }

    @Override
    public List<CentereventTEmergencyEmergencyevents> selectByIds(String[] ids) {
        return centereventTEmergencyEmergencyeventsMapper.selectByIds(ids);
    }

    @Override
    public List<CentereventTEmergencyEmergencyevents> selectByMeetingCode(String[] meetingCodes) {
        return centereventTEmergencyEmergencyeventsMapper.selectByMeetingCode(meetingCodes);
    }
}
