package com.sooka.sponest.event.index.service.impl;

import com.sooka.sponest.event.index.mapper.CenterenvenTEventIndexMapper;
import com.sooka.sponest.event.index.service.ICenterevenTEventIndexService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

@Service
public class CenterevenTEventIndexServiceImpl implements ICenterevenTEventIndexService {

    @Autowired
    private CenterenvenTEventIndexMapper centerenvenTEventIndexMapper;

    /**
     * 区县统计
     *
     * @return
     */
    @Override
    public List<Map<String, Object>> selectdistrictAndCountyStatistics(List<String> timeArr) {
        return centerenvenTEventIndexMapper.selectCentereventTEventCountyList(timeArr);
    }

    /**
     * 行管局统计
     *
     * @return
     */
    @Override
    @Cacheable(cacheNames = "event:index", key = "#timeArr.toString()")
    public List<Map<String, Object>> selectCentereventTEventmapdeptList(List<String> timeArr) {
        return centerenvenTEventIndexMapper.selectCentereventTEventmapdept(timeArr);
    }
}
