package com.sooka.sponest.event.remoteapi;

import com.ruoyi.common.core.constant.ServiceNameConstants;
import com.ruoyi.common.core.domain.R;
import com.sooka.sponest.event.remoteapi.domain.*;
import com.sooka.sponest.event.remoteapi.factory.RemoteDataServiceFallbackFactory;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

@FeignClient(contextId = "remoteDataService", value = ServiceNameConstants.DATA_SERVICE, fallbackFactory = RemoteDataServiceFallbackFactory.class)
public interface RemoteDataService {

    @PostMapping("/attach/remotelist")
    R<List<CenterdataTAttach>> remoteattachlist(@RequestBody CenterdataTAttach centerdataTAttach);

    @PostMapping("/attach/remotelistNew")
    R<List<CenterdataTAttach>> remotelistNew(@RequestBody CenterdataTAttach centerdataTAttach);

    /**
     * 获取附件列表-远端调用
     *
     * @param busId
     * @return com.ruoyi.common.core.domain.R<java.util.List < com.sooka.sponest.mobile.event.domain.AppDataTAttach>>
     * @author pengyu
     * @date 2023/2/21 14:46
     */
    @GetMapping("/attach/urlAttch/{busId}")
    R<List<CenterdataTAttach>> urlAttch(@PathVariable("busId") String busId);

    /**
     * 获取附件列表-远端调用
     *
     * @param busId
     * @return com.ruoyi.common.core.domain.R<java.util.List < com.sooka.sponest.mobile.event.domain.AppDataTAttach>>
     * @author pengyu
     * @date 2023/2/21 14:47
     */
    @GetMapping("/attach/urlAttchMpF/{busId}")
    R<List<CenterdataTAttach>> urlAttchMpF(@PathVariable("busId") String busId);

    @PostMapping("/attach/insertAttach")
    void insertAttach(@RequestBody CenterdataTAttach attach);

    @PostMapping("/attach/updateEventAttach")
    void updateAttach(@RequestBody Map<String, String> paramMap);

    // 查询企业
    @GetMapping("/emergency/enterprise/selectById/{id}")
    R<CenterdataTEmergencyEnterprise> getEnterprise(@PathVariable("id") String enterpriseId);

    @GetMapping("/emergency/patrolpoint/findIPatrolpointByBarCode/{barCode}")
    R<CenterdataTEmergencyPatrolpoint> findIPatrolpointByBarCode(@PathVariable("barCode") String barCode);

    @GetMapping("/emergency/inspectiontype/getTypeInfo/{id}")
    R<CenterdataTEmergencyInspectiontype> getTypeInfo(@PathVariable("id") String id);

    @GetMapping("/emergency/inspectionitem/getItemInfo/{id}")
    R<CenterdataTEmergencyInspectionitem> getItemInfo(@PathVariable("id") String id);

    @PostMapping("/attach/delAndInsertBatch")
    R<Integer> delAndInsertBatch(@RequestParam("jsonStr") String jsonStr);
}
