package com.sooka.sponest.event.remoteapi.domain;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.ruoyi.common.core.annotation.Excel;
import com.ruoyi.common.core.web.domain.BaseEntity;
import lombok.Getter;
import lombok.Setter;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import java.util.Date;

/**
 * 巡更点对象 centerdata_t_emergency_patrolpoint
 *
 * @author ruoyi
 * @date 2022-07-20
 */
@Setter
@Getter
public class CenterdataTEmergencyPatrolpoint extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 主键ID
     */
    private String id;

    /**
     * 删除人
     */
    @Excel(name = "删除人")
    private String deleteBy;

    /**
     * 删除时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "删除时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date deleteTime;

    /**
     * 数据状态
     */
    @Excel(name = "数据状态")
    private String dataStatus;

    /**
     * 巡更点名称
     */
    @Excel(name = "巡更点名称")
    private String patrolpointName;

    /**
     * 经度
     */
    @Excel(name = "经度")
    private String longitude;

    /**
     * 纬度
     */
    @Excel(name = "纬度")
    private String latitude;

    /**
     * 隶属企业
     */
    @Excel(name = "隶属企业")
    private String enterpriseId;

    /**
     * 地址
     */
    @Excel(name = "地址")
    private String patrolpointAddress;

    /**
     * 下次巡更时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "下次巡更时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date patrolNexttime;

    /**
     * 最后一次巡更时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "最后一次巡更时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date patrolLasttime;

    /**
     * 巡更周期(单位-天)
     */
    @Excel(name = "巡更周期(单位-天)")
    private Long patrolCycle;

    /**
     * 预警阈值
     */
    @Excel(name = "预警阈值")
    private Long alertDay;

    /**
     * 负责人
     */
    @Excel(name = "负责人")
    private String charger;

    /**
     * 负责人电话
     */
    @Excel(name = "负责人电话")
    private String chargerPhone;

    /**
     * 备注
     */
    @Excel(name = "备注")
    private String pointRemark;

    /**
     * 绑定条码
     */
    @Excel(name = "绑定条码")
    private String barCode;

    /**
     * 巡更点状态
     */
    @Excel(name = "巡更点状态")
    private String patrolpointStatus;

    /**
     * $column.columnComment
     */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    private String enterpriseName;

    /**
     * $column.columnComment
     */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    private Long owndeptid;

    /**
     * 数据所属部门(政或党的id)
     */
    @Excel(name = "数据所属部门(政或党的id)")
    private Long dataDeptId;


    @Override
    public String toString() {
        return new ToStringBuilder(this, ToStringStyle.MULTI_LINE_STYLE)
                .append("id", getId())
                .append("createBy", getCreateBy())
                .append("createTime", getCreateTime())
                .append("updateBy", getUpdateBy())
                .append("updateTime", getUpdateTime())
                .append("deleteBy", getDeleteBy())
                .append("deleteTime", getDeleteTime())
                .append("dataStatus", getDataStatus())
                .append("patrolpointName", getPatrolpointName())
                .append("longitude", getLongitude())
                .append("latitude", getLatitude())
                .append("enterpriseId", getEnterpriseId())
                .append("patrolpointAddress", getPatrolpointAddress())
                .append("patrolNexttime", getPatrolNexttime())
                .append("patrolLasttime", getPatrolLasttime())
                .append("patrolCycle", getPatrolCycle())
                .append("alertDay", getAlertDay())
                .append("charger", getCharger())
                .append("chargerPhone", getChargerPhone())
                .append("pointRemark", getPointRemark())
                .append("barCode", getBarCode())
                .append("patrolpointStatus", getPatrolpointStatus())
                .append("enterpriseName", getEnterpriseName())
                .append("owndeptid", getOwndeptid())
                .append("dataDeptId", getDataDeptId())
                .toString();
    }
}
