package com.sooka.sponest.event.remoteapi.factory;

import com.ruoyi.common.core.domain.R;
import com.sooka.sponest.event.remoteapi.RemoteDataService;
import com.sooka.sponest.event.remoteapi.domain.*;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.cloud.openfeign.FallbackFactory;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;

@Component
public class RemoteDataServiceFallbackFactory implements FallbackFactory<RemoteDataService> {

    private static final Logger logger = LoggerFactory.getLogger(RemoteDataServiceFallbackFactory.class);

    @Override
    public RemoteDataService create(Throwable cause) {
        logger.error("数据中心-服务调用失败:{}", cause.getMessage());

        return new RemoteDataService() {

            @Override
            public R<List<CenterdataTAttach>> remoteattachlist(CenterdataTAttach centerdataTAttach) {
                return null;
            }

            @Override
            public R<List<CenterdataTAttach>> remotelistNew(CenterdataTAttach centerdataTAttach) {
                return null;
            }

            @Override
            public R<List<CenterdataTAttach>> urlAttch(String busId) {
                return null;
            }

            @Override
            public R<List<CenterdataTAttach>> urlAttchMpF(String busId) {
                return null;
            }

            @Override
            public void insertAttach(CenterdataTAttach attach) {
                throw new UnsupportedOperationException();
            }

            @Override
            public void updateAttach(Map<String, String> paramMap) {
                throw new UnsupportedOperationException();
            }

            @Override
            public R<CenterdataTEmergencyEnterprise> getEnterprise(String enterpriseId) {
                return null;
            }

            @Override
            public R<CenterdataTEmergencyPatrolpoint> findIPatrolpointByBarCode(String barCode) {
                return null;
            }

            @Override
            public R<CenterdataTEmergencyInspectiontype> getTypeInfo(String id) {
                return null;
            }

            @Override
            public R<CenterdataTEmergencyInspectionitem> getItemInfo(String id) {
                return null;
            }

            @Override
            public R<Integer> delAndInsertBatch(String jsonStr) {
                return null;
            }
        };
    }
}
