package com.sooka.sponest.event.test;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.ruoyi.common.core.domain.R;
import com.ruoyi.common.core.utils.DateUtils;
import com.ruoyi.common.core.web.controller.BaseController;
import com.ruoyi.common.core.web.domain.AjaxResult;
import com.sooka.sponest.event.centereventteventcatalogue.domain.dahua.DaHuaFireEventVO;
import com.sooka.sponest.event.centereventteventcatalogue.domain.dahua.InfoVO;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Date;

@RestController
@RequestMapping("AlarmEventController")
public class TestController extends BaseController {

    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @PostMapping("/eventlisten")
    public R eventlisten(@RequestBody String jsonStr) {
        long start = System.currentTimeMillis();
        try {
            DaHuaFireEventVO daHuaFireEventVO = JSONObject.parseObject(jsonStr, DaHuaFireEventVO.class);
            InfoVO infoVO = JSONObject.parseObject(JSON.toJSONString(daHuaFireEventVO.getInfo()), InfoVO.class);
            String eventName = infoVO.getChannelName() + infoVO.getAlarmDateStr() + infoVO.getAlarmTypeName();
            Date reportTime = DateUtils.timestampToTime(infoVO.getAlarmDate());
            double diff = (DateUtils.timestampToTime(start).getTime() - reportTime.getTime()) / 1000;// 计算时间差，单位为秒
            if (180 < diff) {
                logger.info("===事件名称：" + eventName + "，===超时推送：" + diff);
            } else {
                logger.info("===事件名称：" + eventName + "，===延时推送：" + diff);
            }
        } catch (Exception e) {
            logger.error(e.getMessage());
        }
        logger.info("===接口耗时：" + (System.currentTimeMillis() - start));
        return R.ok();
    }


    @PostMapping("/testReport")
    public AjaxResult testReportJsonObj(@RequestBody String jsonStr){
        logger.info("测试接受数据--->: {}", jsonStr);
        return AjaxResult.success();
    }
}
