package com.sooka.sponest.event.urge;

import com.alibaba.fastjson.JSONObject;
import com.sooka.sponest.event.centereventteventcatalogue.domain.CentereventTEventcatalogue;
import com.sooka.sponest.event.urge.domain.EventPush;
import com.sooka.sponest.event.utils.EventConstants;
import org.springframework.data.redis.connection.Message;
import org.springframework.data.redis.listener.adapter.MessageListenerAdapter;
import org.springframework.stereotype.Component;

import javax.websocket.Session;
import java.util.concurrent.ConcurrentMap;

@Component(EventConstants.SOCKET_PUSH_TOPIC)
public class EventSocketAdapter extends MessageListenerAdapter {

    private final Object lockObj = new Object();

    @Override
    public void onMessage(Message message, byte[] pattern) {
        logger.info(String.format("redis Message Received on channel %s message :: %s", new String(message.getChannel()), message.toString()));
        // 转换消息为对象
        CentereventTEventcatalogue eventcatalogue = JSONObject.parseObject(message.toString(), CentereventTEventcatalogue.class);
        // 开始循环当前服务的用户集合
        for (ConcurrentMap.Entry<String, Session> entry : EventWebSocketServer.sessionPools.entrySet()) {
            // 将key转换为实体类对象，用于判断
            EventPush eventPush = JSONObject.parseObject(entry.getKey(), EventPush.class);
            if (eventPush.getEventType().contains(eventcatalogue.getEventTypeXl()) || (eventPush.getEventTypeDl().contains("1") && "1".equals(eventcatalogue.getEventType()))) {
                try {
                    JSONObject jsonObject = new JSONObject();
                    jsonObject.put("tag", "eventPush");
                    jsonObject.put("eventCode", eventcatalogue.getEventCode());
                    // 获取session对象
                    Session session = entry.getValue();
                    // 判断session是否为空
                    if (null != session) {
                        synchronized (lockObj) {
                            // 推送消息给当前的session用户
                            session.getBasicRemote().sendText(jsonObject.toJSONString());
                        }
                    }
                } catch (Exception e) {
                    logger.info(e.getMessage());
                }
            }
        }
    }
}
