package com.sooka.sponest.event.urge.listener;

import com.sooka.sponest.event.urge.domain.EventUrge;
import com.sooka.sponest.event.urge.service.EventUrgeService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationEvent;
import org.springframework.context.ApplicationListener;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Component;

/**
 * 促销产品批量添加或删除事件处理监听器
 */
@Component
public class EventUrgeListener implements ApplicationListener {

    protected final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private EventUrgeService eventUrgeService;

    @Async
    @Override
    public void onApplicationEvent(ApplicationEvent event) {
        if (event.getSource() instanceof EventUrgeService) {
            EventUrge u = (EventUrge) event;
            logger.info("来了一个事件，看看给他一个置顶的催办{}", u);
            eventUrgeService.toBeUrge(u.getCentereventTEventcatalogue());
        }
    }
}
