package com.sooka.sponest.event.utils;

/**
 * 事件中心常量池
 */
public class EventConstants {

    private EventConstants() {
        throw new IllegalStateException("Utility class");
    }

    // 事件状态
    public static final String FOREST_EVENT_STATUS_1 = "forest_event_status_1";// 上报
    public static final String FOREST_EVENT_STATUS_2 = "forest_event_status_2";// 签收
    public static final String FOREST_EVENT_STATUS_5 = "forest_event_status_5";// 办结
    public static final String FOREST_EVENT_STATUS_6 = "forest_event_status_6";// 归档
    public static final String FOREST_EVENT_STATUS_7 = "forest_event_status_7";// 确认

    // 事件来源
    public static final String REPORTING_SOURCE_1 = "reporting_source_1";// AI
    public static final String REPORTING_SOURCE_4 = "reporting_source_4";// 传感器
    public static final String REPORTING_SOURCE_5 = "reporting_source_5";// 数字住建
    public static final String REPORTING_SOURCE_6 = "reporting_source_6";// 数字住建

    // 是否催办
    public static final String SYS_ISURGE_2 = "sys_isurge_2";// 否

    // 部门类型
    public static final String DEPT_HANDLE_TYPE_2 = "dept_handleType_2";// 配合单位
    public static final String DEPT_HANDLE_TYPE_3 = "dept_handleType_3";// 行管局

    // 业务操作类型
    public static final String BUS_OPER_TYPE_1 = "bus_oper_type_1";
    public static final String BUS_OPER_TYPE_2 = "bus_oper_type_2";// 反馈

    // 日志操作类型
    public static final String LOG_OPER_TYPE_1 = "log_oper_type_1";
    public static final String LOG_OPER_TYPE_2 = "log_oper_type_2";
    public static final String LOG_OPER_TYPE_3 = "log_oper_type_3";// AI反馈
    public static final String LOG_OPER_TYPE_4 = "log_oper_type_4";// 无人机

    // 附件索引
    public static final String BUS_INDEX_1 = "bus_indx_forest";// 火情事件
    public static final String BUS_INDEX_2 = "bus_indx_other";// 其他事件
    public static final String BUS_INDEX_3 = "bus_indx_sensor";// 传感器事件

    // 文件类型
    public static final String FILE_TYPE_1 = "image";
    public static final String FILE_TYPE_2 = "video";

    // 文件前缀
    public static final String FILE_PREFIX_LOCAL = "fileUrl";
    public static final String FILE_PREFIX_APP = "appUrl";
    public static final String FILE_PREFIX_HIK1 = "HIK_1";
    public static final String FILE_PREFIX_HIK2 = "HIK_2";
    public static final String FILE_PREFIX_HIK3 = "HIK_3";
    public static final String FILE_PREFIX_DH1 = "DH_1";
    public static final String FILE_PREFIX_DH2 = "DH_2";
    public static final String FILE_DOWNLOAD = "downloadUrl";

    // 部门id
    public static final String SI_PING = "365";// 365_四平市
    public static final String SI_PING_NAME = SI_PING + "_四平市";
    public static final String SHUANG_LIAO = "369";// 369_双辽市
    public static final String SHUANG_LIAO_NAME = SHUANG_LIAO + "_双辽市";
    public static final String YI_TONG = "370";// 370_伊通县
    public static final String YI_TONG_NAME = YI_TONG + "_伊通县";
    public static final String LI_SHU = "371";// 371_梨树县
    public static final String LI_SHU_NAME = LI_SHU + "_梨树县";
    public static final String TIE_DONG = "372";// 372_铁东区
    public static final String TIE_DONG_NAME = TIE_DONG + "_铁东区";
    public static final String TIE_XI = "373";// 373_铁西区
    public static final String TIE_XI_NAME = TIE_XI + "_铁西区";

    // redis
    public static final String SOCKET_PUSH_TOPIC = "socketpushTopic";// 可视化socket推送监听主题
    public static final String EVENT_URGE_PREFIX = "event:urge:";// 事件催办的key前缀
}
